C 18/11/99                                                      DWBA98  GERA-000
C PROGRAMME USED BY HEINRICH VON GERAMB TO GENERATE INPUT OF DWBA91     GERA-001
C ADAPTED FOR THE INPUT OF DWBA98                                       GERA-002
C***********************************************************************GERA-003
      IMPLICIT REAL*8(A-H,O-Z)                                          GERA-004
      INTEGER ELAB,TLAB,OUTUNIT                                         GERA-005
                                                                        GERA-006
               PARAMETER (NRANGE=4,NFERM=6,NENG=5)                      GERA-007
                                                                        GERA-008
      REAL*8  RANGE(3,NRANGE),FERMI(NFERM)                              GERA-009
      REAL*8  VCRE00(NRANGE,NFERM),VCIM00(NRANGE,NFERM)                 GERA-010
      REAL*8  VCRE01(NRANGE,NFERM),VCIM01(NRANGE,NFERM)                 GERA-011
      REAL*8  VCRE10(NRANGE,NFERM),VCIM10(NRANGE,NFERM)                 GERA-012
      REAL*8  VCRE11(NRANGE,NFERM),VCIM11(NRANGE,NFERM)                 GERA-013
      REAL*8  VLRE10(NRANGE,NFERM),VLIM10(NRANGE,NFERM)                 GERA-014
      REAL*8  VLRE11(NRANGE,NFERM),VLIM11(NRANGE,NFERM)                 GERA-015
      REAL*8  VTRE10(NRANGE,NFERM),VTIM10(NRANGE,NFERM)                 GERA-016
      REAL*8  VTRE11(NRANGE,NFERM),VTIM11(NRANGE,NFERM)                 GERA-017
      DATA INPUNIT/4/,OUTUNIT/7/,ITERMINAL/5/                           GERA-018
                                                                        GERA-019
C=> ENERGY,DENSITY (ALLOWED ELAB:  40, 50, 60, 70, 100 )                GERA-020
                                                                        GERA-021
      READ (ITERMINAL,*) ELAB                                           GERA-022
      CALL SKIP(INPUNIT,8)                                              GERA-023
                                                                        GERA-024
C=> READ DATA FROM INPUT-UNIT INPUNIT                                   GERA-025
                                                                        GERA-026
      DO 1 I=1,NENG                                                     GERA-027
      READ (INPUNIT,'(T24,I3)') TLAB                                    GERA-028
      IF (TLAB.NE.ELAB) THEN                                            GERA-029
      IF (I.LT.NENG) CALL SKIP(INPUNIT,359)                             GERA-030
      GO TO 1                                                           GERA-031
      ELSE                                                              GERA-032
      DO 6 IFERM=1,NFERM                                                GERA-033
      READ (INPUNIT,'(T44,F4.2)') FERMI(IFERM)                          GERA-034
      CALL SKIP(INPUNIT,12)                                             GERA-035
         DO 2 IRANGE=1,NRANGE                                           GERA-036
         READ (INPUNIT,'(T2,F4.2,TR1,2E16.8,TR1,2E16.8)')               GERA-037
     +    RANGE(1,IRANGE),VCRE00(IRANGE,IFERM),VCIM00(IRANGE,IFERM)     GERA-038
     +                   ,VCRE01(IRANGE,IFERM),VCIM01(IRANGE,IFERM)     GERA-039
2        CONTINUE                                                       GERA-040
         CALL SKIP(INPUNIT,8)                                           GERA-041
         DO 3 IRANGE=1,NRANGE                                           GERA-042
         READ (INPUNIT,'(T2,F4.2,TR1,2E16.8,TR1,2E16.8)')               GERA-043
     +    RANGE(1,IRANGE),VCRE10(IRANGE,IFERM),VCIM10(IRANGE,IFERM)     GERA-044
     +                   ,VCRE11(IRANGE,IFERM),VCIM11(IRANGE,IFERM)     GERA-045
3        CONTINUE                                                       GERA-046
         CALL SKIP(INPUNIT,8)                                           GERA-047
         DO 4 IRANGE=1,NRANGE                                           GERA-048
         READ (INPUNIT,'(T2,F4.2,TR1,2E16.8,TR1,2E16.8)')               GERA-049
     +    RANGE(2,IRANGE),VLRE10(IRANGE,IFERM),VLIM10(IRANGE,IFERM)     GERA-050
     +                   ,VLRE11(IRANGE,IFERM),VLIM11(IRANGE,IFERM)     GERA-051
4        CONTINUE                                                       GERA-052
         CALL SKIP(INPUNIT,8)                                           GERA-053
         DO 5 IRANGE=1,NRANGE                                           GERA-054
         READ (INPUNIT,'(T2,F4.2,TR1,2E16.8,TR1,2E16.8)')               GERA-055
     +    RANGE(3,IRANGE),VTRE10(IRANGE,IFERM),VTIM10(IRANGE,IFERM)     GERA-056
     +                   ,VTRE11(IRANGE,IFERM),VTIM11(IRANGE,IFERM)     GERA-057
5        CONTINUE                                                       GERA-058
         IF (IFERM.NE.6) CALL SKIP(INPUNIT,7)                           GERA-059
6     CONTINUE                                                          GERA-060
      GOTO 7                                                            GERA-061
      ENDIF                                                             GERA-062
1     CONTINUE                                                          GERA-063
      STOP 'LAB-ENERGY NOT IN LIST, PLEASE TRY AGAIN'                   GERA-064
                                                                        GERA-065
C=> WRITE DWBA-INPUT-FILE ON FORTRAN-UNIT OUTUNIT                       GERA-066
                                                                        GERA-067
7     CALL DWBAINPUT(VCRE00,VCIM00,VCRE01,VCIM01,VCRE10,VCIM10,         GERA-068
     +     VCRE11,VCIM11,VLRE10,VLIM10,VLRE11,VLIM11,VTRE10,VTIM10,     GERA-069
     +     VTRE11,VTIM11,RANGE,FERMI,OUTUNIT)                           GERA-070
      STOP                                                              GERA-071
      END                                                               GERA-072
      SUBROUTINE SKIP(IUNIT,INT)                                        GERA-073
      DO 1 I=1,INT                                                      GERA-074
      READ (IUNIT,*)                                                    GERA-075
1     CONTINUE                                                          GERA-076
      RETURN                                                            GERA-077
      END                                                               GERA-078
C 18/11/99                                                      DWBA98  GERA-079
      SUBROUTINE DWBAINPUT(VCRE00,VCIM00,VCRE01,VCIM01,VCRE10,VCIM10,   GERA-080
     +     VCRE11,VCIM11,VLRE10,VLIM10,VLRE11,VLIM11,VTRE10,VTIM10,     GERA-081
     +     VTRE11,VTIM11,RANGE,FERMI,OUTUNIT)                           GERA-082
C********************************************************************   GERA-083
C                                                                       GERA-084
C                  INPUT FOR RAYNAL'S DWBA98-PROGRAM                    GERA-085
C                                                                       GERA-086
C********************************************************************   GERA-087
      IMPLICIT REAL*8 (A-H,O-Z)                                         GERA-088
      PARAMETER (NRANGE=4,NFERM=6,NENG=9)                               GERA-089
      INTEGER OUTUNIT                                                   GERA-090
      REAL*8  RANGE(3,NRANGE),FERMI(NFERM)                              GERA-091
      REAL*8  VCRE00(NRANGE,NFERM),VCIM00(NRANGE,NFERM)                 GERA-092
      REAL*8  VCRE01(NRANGE,NFERM),VCIM01(NRANGE,NFERM)                 GERA-093
      REAL*8  VCRE10(NRANGE,NFERM),VCIM10(NRANGE,NFERM)                 GERA-094
      REAL*8  VCRE11(NRANGE,NFERM),VCIM11(NRANGE,NFERM)                 GERA-095
      REAL*8  VLRE10(NRANGE,NFERM),VLIM10(NRANGE,NFERM)                 GERA-096
      REAL*8  VLRE11(NRANGE,NFERM),VLIM11(NRANGE,NFERM)                 GERA-097
      REAL*8  VTRE10(NRANGE,NFERM),VTIM10(NRANGE,NFERM)                 GERA-098
      REAL*8  VTRE11(NRANGE,NFERM),VTIM11(NRANGE,NFERM)                 GERA-099
      LOGICAL LO16,LO25,LOO(9)                                          GERA-100
      LOGICAL CENTRAL,L2,LS,LS2,TENSOR,Q12                              GERA-101
      DIMENSION KTV(14,18),XMU(18)                                      GERA-102
      DATA LO16,LO25,LOO/3*.FALSE.,.TRUE.,7*.FALSE./,HB2ONM/41.48D0/    GERA-103
      DATA CENTRAL,L2,LS,LS2,TENSOR,Q12/.TRUE.,.FALSE.,.TRUE.,.FALSE.,  GERA-104
     +  .TRUE.,.FALSE./                                                 GERA-105
      EXTERNAL INDEX                                                    GERA-106
      IF (Q12) LO25=.TRUE.                                              GERA-107
      NRANGES=0                                                         GERA-108
C                                                                       GERA-109
      DO 1 I=1,NRANGE                                                   GERA-110
      DO 10 J=1,MAX(NRANGES,1)                                          GERA-111
      IF(XMU(J).EQ.RANGE(1,I)) GOTO 11                                  GERA-112
10    CONTINUE                                                          GERA-113
      NRANGES=NRANGES+1                                                 GERA-114
      XMU(NRANGES)=RANGE(1,I)                                           GERA-115
      J=NRANGES                                                         GERA-116
11    IF (CENTRAL) THEN                                                 GERA-117
      KTV(1,J)=J                                                        GERA-118
      KTV(2,J)=J                                                        GERA-119
      KTV(3,J)=J                                                        GERA-120
      KTV(4,J)=J                                                        GERA-121
      ENDIF                                                             GERA-122
1     CONTINUE                                                          GERA-123
      DO 2 I=1,NRANGE                                                   GERA-124
      DO 20 J=1,MAX(NRANGES,1)                                          GERA-125
      IF (XMU(J).EQ.RANGE(2,I)) GOTO 21                                 GERA-126
20    CONTINUE                                                          GERA-127
      NRANGES=NRANGES+1                                                 GERA-128
      XMU(NRANGES)=RANGE(2,I)                                           GERA-129
      J=NRANGES                                                         GERA-130
21    IF (L2.AND..NOT.Q12) THEN                                         GERA-131
      KTV(11,J)=J                                                       GERA-132
      KTV(12,J)=J                                                       GERA-133
      KTV(13,J)=J                                                       GERA-134
      KTV(14,J)=J                                                       GERA-135
      ENDIF                                                             GERA-136
      IF (L2.AND.Q12) THEN                                              GERA-137
      KTV(11,J)=J                                                       GERA-138
      KTV(12,J)=J                                                       GERA-139
      ENDIF                                                             GERA-140
      IF (LS) THEN                                                      GERA-141
      KTV(5,J)=J                                                        GERA-142
      KTV(6,J)=J                                                        GERA-143
      ENDIF                                                             GERA-144
      IF (LS2.OR.(L2.AND.Q12)) THEN                                     GERA-145
      KTV(9,J)=J                                                        GERA-146
      KTV(10,J)=J                                                       GERA-147
      ENDIF                                                             GERA-148
2     CONTINUE                                                          GERA-149
      DO 3 I=1,NRANGE                                                   GERA-150
      DO 30 J=1,MAX(NRANGES,1)                                          GERA-151
      IF (XMU(J).EQ.RANGE(3,I)) GOTO 31                                 GERA-152
30    CONTINUE                                                          GERA-153
      NRANGES=NRANGES+1                                                 GERA-154
      XMU(NRANGES)=RANGE(3,I)                                           GERA-155
      J=NRANGES                                                         GERA-156
31    IF (TENSOR) THEN                                                  GERA-157
      KTV(7,J)=J                                                        GERA-158
      KTV(8,J)=J                                                        GERA-159
      ENDIF                                                             GERA-160
3     CONTINUE                                                          GERA-161
      WRITE (OUTUNIT,'(3I5)') NRANGES                                   GERA-162
      WRITE (OUTUNIT,101) LO16,LO25,(LOO(I),I=1,9)                      GERA-163
101   FORMAT (T1,11L1)                                                  GERA-164
      DO 4 J=1,NRANGES                                                  GERA-165
      WRITE (OUTUNIT,102) 1.0D0/XMU(J)                                  GERA-166
102   FORMAT (T1,F10.5)                                                 GERA-167
      WRITE (OUTUNIT,103) (5*KTV(I,J)/J,I=1,14)                         GERA-168
103   FORMAT (T1,14I5)                                                  GERA-169
4     CONTINUE                                                          GERA-170
C                                                                       GERA-171
      DO 5 I=1,14                                                       GERA-172
      DO 6 J=1,NRANGES                                                  GERA-173
      IF (KTV(I,J).NE.0) THEN                                           GERA-174
      WRITE (OUTUNIT,104) I,J                                           GERA-175
      WRITE (OUTUNIT,*) '1.0'                                           GERA-176
104   FORMAT (T1,2I5,'    5','    0','    6')                           GERA-177
      IF (I.EQ.1) THEN                                                  GERA-178
      DO 501 K=NFERM,1,-1                                               GERA-179
      WRITE (OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                GERA-180
     &                            VCRE00(J,K),VCIM00(J,K)               GERA-181
 501  CONTINUE                                                          GERA-182
 105  FORMAT (T1,F10.4,2F20.8)                                          GERA-183
      ENDIF                                                             GERA-184
      IF (I.EQ.2) THEN                                                  GERA-185
      DO 502 K=NFERM,1,-1                                               GERA-186
      WRITE (OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                GERA-187
     &                            VCRE01(J,K),VCIM01(J,K)               GERA-188
 502  CONTINUE                                                          GERA-189
      ENDIF                                                             GERA-190
      IF (I.EQ.3) THEN                                                  GERA-191
      DO 503 K=NFERM,1,-1                                               GERA-192
      WRITE (OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                GERA-193
     &                            VCRE10(J,K),VCIM10(J,K)               GERA-194
 503  CONTINUE                                                          GERA-195
      ENDIF                                                             GERA-196
      IF (I.EQ.4) THEN                                                  GERA-197
      DO 504 K=NFERM,1,-1                                               GERA-198
      WRITE (OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                GERA-199
     &                            VCRE11(J,K),VCIM11(J,K)               GERA-200
 504  CONTINUE                                                          GERA-201
      ENDIF                                                             GERA-202
      IF (I.EQ.5) THEN                                                  GERA-203
      DO 505 K=NFERM,1,-1                                               GERA-204
      WRITE (OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                GERA-205
     &                            VLRE10(J-4,K),VLIM10(J-4,K)           GERA-206
 505  CONTINUE                                                          GERA-207
      ENDIF                                                             GERA-208
      IF (I.EQ.6) THEN                                                  GERA-209
      DO 506 K=NFERM,1,-1                                               GERA-210
      WRITE (OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                GERA-211
     &                            VLRE11(J-4,K),VLIM11(J-4,K)           GERA-212
 506  CONTINUE                                                          GERA-213
      ENDIF                                                             GERA-214
      IF (I.EQ.7) THEN                                                  GERA-215
      DO 507 K=NFERM,1,-1                                               GERA-216
      WRITE (OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                GERA-217
     &                            VTRE10(J-4,K),VTIM10(J-4,K)           GERA-218
 507  CONTINUE                                                          GERA-219
      ENDIF                                                             GERA-220
      IF (I.EQ.8) THEN                                                  GERA-221
      DO 508 K=NFERM,1,-1                                               GERA-222
      WRITE (OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                GERA-223
     &                            VTRE11(J-4,K),VTIM11(J-4,K)           GERA-224
 508  CONTINUE                                                          GERA-225
      ENDIF                                                             GERA-226
      ENDIF                                                             GERA-227
6     CONTINUE                                                          GERA-228
5     CONTINUE                                                          GERA-229
      RETURN                                                            GERA-230
      END                                                               GERA-231
