C 03/04/98                                                      DWBA98  CALC-000
      SUBROUTINE CALC(W,NW,IDMX)                                        CALC-001
C W(I),NW(I) ARE EQUIVALENCED BY THE CALL.                              CALC-002
C IDMX IS THEIR LENGTH IN DOUBLE PRECISION.                             CALC-003
C                                                                       CALC-004
C THE COMMON /SAUVE/ IS USED IN CALC AND LECT                           CALC-005
C THE COMMON /NOMBR/ IS USED IN CALC,LECT,LEC2,FDIS,POTE,INTE,LEC6,DIRZ,CALC-006
C                               DIRA,MULT,PTC0,PTI0,PTII,PTIP AND ECHA  CALC-007
C THE COMMON /LIMIT/ IS USED IN CALC,LECT,FDIS AND SCEL..               CALC-008
C THE OTHER COMMONS ARE /POIN/  IN LECT,FDIS,POTE AND INTE. (SEE FDIS)  CALC-009
C                       /GARDE/ IN FDIS,SCEL AND DIRA. (SEE FDIS)       CALC-010
C                       /GABJ/  IN POTE,INTE,PTIV,MULT,DIRA,PTIP,PTCP,  CALC-011
C                               PTII,PTCI,PTC0,GEOM AND ECHA. (SEE MULT)CALC-012
C                                                                       CALC-013
C SIGNIFICANCE OF THE QUANTITIES IN COMMON /SAUVE/                      CALC-014
C  HA,INMA  PREVIOUS NUMBER OF INTEGRATION POINTS AND STEP SIZE.        CALC-015
C  NA(4)    FIRST ADDRESS OF PERMANENT STORAGE RELATED TO ILECT=2,3,4,6.CALC-016
C  NAB      FIRST FREE ADDRESS FOR WORKING SPACE.                       CALC-017
C  NBFOND   NUMBER OF BOUND STATES (PROTONS PLUS NEUTRONS).             CALC-018
C  NTM      ADDRESS OF DESCRIPTION OF MACROSCOPIC TRANSITIONS.          CALC-019
C  NBINT    MAXIMUM NUMBER OF COMPONENTS OF THE FORCE.                  CALC-020
C                                                                       CALC-021
C SIGNIFICANCE OF THE QUANTITIES IN COMMON /NOMBR/                      CALC-022
C  H        INTEGRATION STEP SIZE.                                      CALC-023
C  CCO(5)   COULOMB INTERACTION,FINAL VALUE OF THE FORM FACTOR IN CCO(5)CALC-024
C  JMAX     NUMBER OF PARTIAL WAVES.                                    CALC-025
C  KV       NUMBER OF DIFFERENT RANGES IN THE INTERACTION.              CALC-026
C  KR       ADDRESS OF THE MULTIPOLES OF THE COULOMB INTERACTION OR 0.  CALC-027
C  KS       NUMBER OF FINITE RANGES.                                    CALC-028
C  NBCONF   NUMBER OF CONFIGURATIONS.                                   CALC-029
C  NBPROT   NUMBER OF SINGLE PARTICLE STATES WITH THE PARTICLE IDENTICALCALC-030
C                TO THE INCIDENT PARTICLE.                              CALC-031
C  J        MOMENTUM TRANSFER.                                          CALC-032
C  KY       NUMBER OF RADIAL DEPENDENCES IN THE INTERACTION.            CALC-033
C  ILL(3,4) MAXIMUM NUMBER OF FORM FACTORS WITH 0,1 OR TWO DERIVATIONS  CALC-034
C           FOR NATURAL AND UNNATURAL PARITY TRANSITIONS IN THE DIRECT  CALC-035
C           AND THE EXCHANGE CALCULATIONS.                              CALC-036
C  LO(40)   LOGICAL CONTROLS:                                           CALC-037
C LO(1) TO LO(7)   CONTROLS FOR READING THE INPUT STREAM.               CALC-038
C LO(8)  SUM OVER  J              LO(9)  RELATIVISTIC CORRECTIONS       CALC-039
C LO(10) COULOMB CORRECTIONS      LO(11) NON-LOCALITY                   CALC-040
C LO(12) RECOIL CORRECTIONS       LO(13) PRINT MEMORY EXPANSION         CALC-041
C LO(14) NO PRINT OF FORM FACTORS LO(15) PUNCH AMPLITUDES               CALC-042
C LO(16) COULOMB INTERACTION.     LO(17) NO EXCHANGE                    CALC-043
C LO(18) FINAL VALUE OF J         LO(19) STOP BY MEMORY EXPANSION       CALC-044
C LO(20) NATURAL PARITY STATE     LO(21) NO COULOMB CORRECTIONS         CALC-045
C LO(22) EXCHANGE CALC. IN PROG.  LO(23) ZERO RANGE INTERACTION         CALC-046
C LO(24) INTER. DIRECT REAL       LO(25) USE OF (L.S)**2-L**2           CALC-047
C LO(26) MACROSCOPIC INTERACTION  LO(27) MACROSCOPIC S.-O. INTERACTION  CALC-048
C LO(28) INDEPENDENT SPIN ORBIT   LO(29) MICROSC. INTER. REAL           CALC-049
C LO(30) MACROSC. INTER. REAL     LO(31) NATURAL PARITY CALCULATION     CALC-050
C LO(32) READ ONLY THE EXCITATION ENERGY FOR THE FINAL STATE            CALC-051
C LO(33) PRINT PHASE-SHIFTS       LO(34) PRINT POTENTIALS               CALC-052
C LO(35) PRINT ELASTIC SCATTERING LO(36) EXTERNALLY CALCULATED POTENTIALCALC-053
C LO(37) FOR POTENTIAL COMPUTED FROM THE TWO BODY INTERACTION           CALC-054
C LO(38) AND LO(39) TO SAVE LO(36) AND LO(37) OF THE INITIAL STATE      CALC-055
C LO(40) BCS FOR PARTICLE HOLE STATES                                   CALC-056
C                                                                       CALC-057
C SIGNIFICANCE OF THE QUANTITIES IN COMMON /LIMIT/                      CALC-058
C  COEF     NORMALISATION COEFFICIENT FOR THE AMPLITUDES.               CALC-059
C  TMIN     FIRST ANGLE FOR THE RESULTS.                                CALC-060
C  TMAX     FINAL ANGLE FOR THE RESULTS.                                CALC-061
C  TITRE    LEGEND REPRODUCED WITH THE RESULTS.                         CALC-062
C  VAL(I,J) OPTICAL MODEL FOR I=1,16, MASSES FOR I=17,18, PRODUCT OF    CALC-063
C           CHARGES FOR I=19, NON-LOCALITY COEFFICIENT FOR I=21.        CALC-064
C           INITIAL STATE FOR J=1, FINAL STATE FOR J=2.                 CALC-065
C  NG       GRAPHICAL CONTROLS.                                         CALC-066
C  JMX      NUMBER OF MULTIPOLES FOR THE EXCHANGE TERM.                 CALC-067
C  MTJ      CONTROL FOR THE SUMMATION OVER DIFFERENT J TRANSFERS.       CALC-068
C  NJ       2*J+1 USED FOR THE DIMENSIONS.                              CALC-069
C  MPAR     1 OR -1 FOR NATURAL OR NON-NATURAL PARITY.                  CALC-070
C  INM      NUMBER OF INTEGRATION STEPS.                                CALC-071
C  MTETA    NUMBER OF ANGLES FOR THE RESULTS.                           CALC-072
C  NAF      ADDRESS OF THE WORK ZONE FOR THE 3-J IN SCEF.               CALC-073
C  NAMP     ADDRESS OF THE WORK ZONE FOR THE AMPLITUDES IN SCEF.        CALC-074
C  NKTF     ADDRESS OF THE INTEGER DESCRIPTION OF THE INTERACTION.      CALC-075
C  NCMU     ADDRESS OF THE RANGES OF THE INTERACTION.                   CALC-076
C  NCH(3)   ADDRESS OF THE DESCRIPTION OF THE CONFIGURATIONS.           CALC-077
C  NCZ(3)   ADDRESS OF THE PARTICLE AND THE HOLE OF PARTICLE HOLE STATESCALC-078
C                1 - TO COMPUTE DENSITY.                                CALC-079
C                2 - DESCRIPTION OF TARGET.                             CALC-080
C                3 - DESCRIPTION OF TRANSITION.                         CALC-081
C  NCOU     ADDRESS OF THE NUCLEAR PHASE SHIFTS.                        CALC-082
C  NFA      NUMBER OF LOGARITHMS OF FACTORIALS.                         CALC-083
C  NFO      ADDRESS OF THE BOUND STATES.                                CALC-084
C  NFON     ADDRESS OF THE DISTORTED WAVE FUNCTIONS.                    CALC-085
C  NINT     ADDRESS OF THE INTERACTION RADIAL DEPENDENCE.               CALC-086
C  NFF      ADDRESS OF THE COULOMB FUNCTIONS.                           CALC-087
C  NMUL     ADDRESS OF THE MULTIPOLES.                                  CALC-088
C  NPLACE   MAXIMUM SPACE.                                              CALC-089
C  NQU      ADDRESS OF THE QUANTUM NUMBERS OF THE BOUND STATES.         CALC-090
C  NSOM     ADDRESS OF THE TRANSITION MATRIX ELEMENTS.                  CALC-091
C  NT1      ADDRESS OF THE RESULTS IN SCEF.                             CALC-092
C  NT2      ADDRESS OF THE PARTIAL RESULTS IN THE CASE OF A SUM OVER J. CALC-093
C  NVT      WORK SPACE FOR THE FORM FACTORS (SEE DIRZ).                 CALC-094
C  NFB      ADDRESS OF THE LOGARITHM OF THE FACTORIALS.                 CALC-095
C  JMAX1    MAXIMUM NUMBER OF PARTIAL WAVES,WHICH INCLUDE THE           CALC-096
C           ASYMPTOTIC COULOMB CORRECTIONS.                             CALC-097
C  LX1      EFFECTIVE NUMBER OF COULOMB FUNCTIONS.                      CALC-098
C  NWF      ADDRESS OF THE COULOMB PHASE SHIFTS.                        CALC-099
C  NMF      ADDRESS OF THE STRENGTHS OF THE INTERACTION.                CALC-100
C***********************************************************************CALC-101
      IMPLICIT REAL*8 (A-H,O-Z)                                         CALC-102
      LOGICAL LO                                                        CALC-103
      DIMENSION W(1),NW(1)                                              CALC-104
      COMMON /SAUVE/ HA,NAB,NA(4),INMA,NBFOND,NTM,NBINT                 CALC-105
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),CALC-106
     1LO(40)                                                            CALC-107
      COMMON /LIMIT/ COEF,TMIN,TMAX,TITRE(18),VAL(21,2),NG(8),JMX,MTJ,NJCALC-108
     1,MPAR,INM,MTETA,NAF,NAMP,NKTF,NCMU,NCH(3),NCZ(3),NCOU,NFA,NFO,NFONCALC-109
     2,NINT,NFF,NMUL,NPLACE,NQU,NSOM,NT1,NT2,NVT,NFB,JMAX1,LX1,NWF,NMF  CALC-110
      IDMT=IDMX                                                         CALC-111
      DO 1 I=1,4                                                        CALC-112
    1 NA(I)=0                                                           CALC-113
      NAB=0                                                             CALC-114
      INMA=0                                                            CALC-115
      HA=0.D0                                                           CALC-116
      DO 2 I=1,7                                                        CALC-117
    2 LO(I)=.TRUE.                                                      CALC-118
    3 CALL LECT(W,NW,IDMT)                                              CALC-119
      IF (LO(19)) GO TO 5                                               CALC-120
      CALL HORA                                                         CALC-121
      CALL DIRA(W(NMUL),W(NVT),W(NFON),W(NFO),INM,W(NSOM),NJ,W(NFB),NFA,CALC-122
     1NW(NQU),NW(NCZ(3)),W(NCH(3)),NW(NKTF),W(NCMU),W(NMF),W(NINT),W(NFFCALC-123
     2),JMAX+4,W(NWF),JMAX1+4,W(NCOU),LX1)                              CALC-124
      IF (LO(19)) GO TO 5                                               CALC-125
      CALL HORA                                                         CALC-126
      CALL SCEF(1,W(NAMP),NJ+1,JMAX1+1,W(NAF),W(NSOM),NJ,W(NT1),W(NT2),MCALC-127
     1TETA,W(NFB),NFA,J,MPAR,TITRE,VAL(20,2),TMIN,TMAX,COEF,NG,MTJ,LO)  CALC-128
      IF (LO(19)) GO TO 5                                               CALC-129
      IF (LO(17)) GO TO 4                                               CALC-130
      CALL HORA                                                         CALC-131
      WRITE (6,1000)                                                    CALC-132
      LO(22)=.TRUE.                                                     CALC-133
      CALL ECHA(W(NMUL),W(NVT),W(NFON),W(NFO),INM,W(NSOM),NJ,W(NFB),NFA,CALC-134
     1NW(NQU),NW(NCZ(3)),W(NCH(3)),NW(NKTF),W(NCMU),W(NMF),W(NINT),JMX) CALC-135
      IF (LO(19)) GO TO 5                                               CALC-136
      CALL HORA                                                         CALC-137
      CALL SCEF(2,W(NAMP),NJ+1,JMAX1+1,W(NAF),W(NSOM),NJ,W(NT1),W(NT2),MCALC-138
     1TETA,W(NFB),NFA,J,MPAR,TITRE,VAL(20,2),TMIN,TMAX,COEF,NG,MTJ,LO)  CALC-139
    4 LO(7)=((.NOT.LO(8)).OR.LO(18))                                    CALC-140
    5 CALL HORA                                                         CALC-141
      ID=IDMT-NPLACE                                                    CALC-142
      WRITE (6,1001) NAB,NPLACE,ID                                      CALC-143
      IF (LO(19)) STOP                                                  CALC-144
      GO TO 3                                                           CALC-145
 1000 FORMAT (1H1)                                                      CALC-146
 1001 FORMAT (5H ****,2I10,19H MEMORIES USED ****,10X,I10,14H FREE MEMORCALC-147
     1IES)                                                              CALC-148
      END                                                               CALC-149
