C 12/04/98                                                      DWBA98  LEC1-000
      SUBROUTINE LEC1(FO,NQUA,VBCS,XY,XX,H,INM,NBFOND,NBPROT,IDMT,NTOT,LLEC1-001
     1O)                                                                LEC1-002
C READ THE SINGLE PARTICLE WAVE FUNCTIONS.                              LEC1-003
C INPUT:     INM      NUMBER OF INTEGRATION STEPS.                      LEC1-004
C            NBFOND   NUMBER OF SINGLE PARTICLE STATES.                 LEC1-005
C            NBPROT   NUMBER OF THESE SINGLE PARTICLE STATES IDENTICAL  LEC1-006
C                     TO THE INCIDENT PARTICLE.                         LEC1-007
C            IDMT     TOTAL DIMENSION OF THE WORKING AREA.              LEC1-008
C            NTOT     DIMENSION OF XX IN SINGLE PRECISION.              LEC1-009
C            LO       LOGICAL CONTROLS.                                 LEC1-010
C                          LO(11)=.TRUE.  NON-LOCALITY CORRECTION       LEC1-011
C                          LO(12)=.TRUE.  RECOIL CORRECTION             LEC1-012
C                          LO(40)=.TRUE.  BCS                           LEC1-013
C OUTPUT:    FO       WAVE FUNCTIONS.                                   LEC1-014
C            NQUA     QUANTUM NUMBERS N, L AND 2*(J-L).                 LEC1-015
C            VBCS     U AND V FROM THE BCS MODEL                        LEC1-016
C            NTOT     SPACE USED.                                       LEC1-017
C WORKING AREA FOR:   XX   TO READ AMPLITUDES FOR A SUM ON RADIAL       LEC1-018
C                          QUANTUM AND WORKING AREA IN STDP.            LEC1-019
C                     XY   FOR ADDITIONAL FUNCTION FOR A SUM.           LEC1-020
C***********************************************************************LEC1-021
      IMPLICIT REAL*8 (A-H,O-Z)                                         LEC1-022
      LOGICAL LO(40),LOO(3)                                             LEC1-023
      DIMENSION FO(INM,1),VBCS(2,1),NQUA(3,1),XY(1),XX(1)               LEC1-024
      DATA LOO /3*.FALSE./                                              LEC1-025
      WRITE (6,1000)                                                    LEC1-026
      READ (5,1001) H,CM                                                LEC1-027
      WRITE (6,1002) INM,H                                              LEC1-028
      WRITE (6,1003) NBFOND,NBPROT                                      LEC1-029
      HL=H                                                              LEC1-030
      IF (.NOT.LO(12)) GO TO 1                                          LEC1-031
      IF (CM.NE.0.D0) HL=HL*(CM+1.D0)/CM                                LEC1-032
      BM=HL/H                                                           LEC1-033
      WRITE (6,1004) CM,BM,HL                                           LEC1-034
    1 LO(40)=.FALSE.                                                    LEC1-035
      READ (5,1005) LO(40),LOO                                          LEC1-036
      WRITE (6,1006) LO(40),LOO(1),LOO(2)                               LEC1-037
      IF (.NOT.LOO(1)) WRITE (6,1007) LOO(3)                            LEC1-038
      IF (LOO(1)) WRITE (6,1008) LOO(3),INM                             LEC1-039
      NT=0                                                              LEC1-040
      DO 11 M=1,NBFOND                                                  LEC1-041
      READ (5,1009) NQUA(1,M),NQUA(2,M),NQUA(3,M),NOMBN                 LEC1-042
      IF (.NOT.LOO(3).OR.LOO(1)) NOMBN=1                                LEC1-043
      WRITE (6,1010) M,(NQUA(I,M),I=1,3)                                LEC1-044
      READ (5,1001) ALP,(XX(I),I=1,NOMBN)                               LEC1-045
      NT1=NOMBN+1                                                       LEC1-046
      IF (2*NT1.GT.NTOT) CALL MEMO(IDMT,IDMT+2*NT1-NTOT,NTOT,3,LO)      LEC1-047
      IF (LO(19)) GO TO 12                                              LEC1-048
      IF (.NOT.LOO(1)) WRITE (6,1011) ALP                               LEC1-049
      CALL STDP(FO(1,M),NQUA(1,M),ALP,XX(NT1),INM,HL,H,LO(11),LOO,IDMT,NLEC1-050
     1TOT-2*NT1,MT)                                                     LEC1-051
      NT=MAX0(NT,MT+NT1)                                                LEC1-052
      IF (NOMBN.LE.1) GO TO 6                                           LEC1-053
      DO 2 I=1,INM                                                      LEC1-054
    2 FO(I,M)=XX(1)*FO(I,M)                                             LEC1-055
      AX=XX(1)**2                                                       LEC1-056
      DO 4 J=2,NOMBN                                                    LEC1-057
      NQUA(1,M)=NQUA(1,M)+1                                             LEC1-058
      CALL STDP(XY,NQUA(1,M),ALP,XX(NT1),INM,HL,H,LO(11),LOO,IDMT,NTOT-NLEC1-059
     1T1,MT)                                                            LEC1-060
      IF (LO(19)) GO TO 12                                              LEC1-061
      NT=MAX0(NT,MT+NT1)                                                LEC1-062
      DO 3 I=1,INM                                                      LEC1-063
    3 FO(I,M)=FO(I,M)+XX(J)*XY(I)                                       LEC1-064
    4 AX=AX+XX(J)**2                                                    LEC1-065
      NQUA(1,M)=NQUA(1,M)-NOMBN+1                                       LEC1-066
      AX=1.D0/DSQRT(AX)                                                 LEC1-067
      DO 5 I=1,INM                                                      LEC1-068
    5 FO(I,M)=AX*FO(I,M)                                                LEC1-069
      WRITE (6,1012) AX,NOMBN,(XX(I),I=1,NOMBN)                         LEC1-070
    6 IF (.NOT.(LOO(1).AND.LOO(3))) GO TO 10                            LEC1-071
      IP=1                                                              LEC1-072
      IF (M.GT.NBPROT) IP=NBPROT+1                                      LEC1-073
      IF (IP.EQ.M) GO TO 10                                             LEC1-074
      M1=M-1                                                            LEC1-075
      DO 9 L=IP,M1                                                      LEC1-076
      IF (NQUA(2,L).NE.NQUA(2,M).OR.NQUA(3,L).NE.NQUA(3,M)) GO TO 9     LEC1-077
      NOMBN=NOMBN+1                                                     LEC1-078
      ALL=0.D0                                                          LEC1-079
      ALM=0.D0                                                          LEC1-080
      AMM=0.D0                                                          LEC1-081
      DO 7 I=1,INM                                                      LEC1-082
      ALL=ALL+FO(I,L)*FO(I,L)*H                                         LEC1-083
      ALM=ALM+FO(I,L)*FO(I,M)*H                                         LEC1-084
    7 AMM=AMM+FO(I,M)*FO(I,M)*H                                         LEC1-085
      AY=1.D0/DSQRT(1.D0-ALM**2/(ALL*AMM))                              LEC1-086
      AX=ALM/ALL                                                        LEC1-087
      WRITE (6,1013) L,M,NQUA(1,L),(NQUA(I,M),I=1,3),ALL,AMM,ALM,AY,AX  LEC1-088
      DO 8 I=1,INM                                                      LEC1-089
    8 FO(I,M)=AY*(FO(I,M)-AX*FO(I,L))                                   LEC1-090
    9 CONTINUE                                                          LEC1-091
   10 IF (LOO(2).AND.NOMBN.NE.1) WRITE (6,1014) NOMBN,(IS,FO(IS,M),IS=1,LEC1-092
     1INM)                                                              LEC1-093
      IF (.NOT.LO(40)) GO TO 11                                         LEC1-094
      READ (5,1001) VBCS(1,M)                                           LEC1-095
      VBCS(2,M)=DSQRT(1.D0-VBCS(1,M)**2)                                LEC1-096
      WRITE (6,1015) VBCS(1,M),VBCS(2,M)                                LEC1-097
   11 CONTINUE                                                          LEC1-098
      NTOT=2*NT                                                         LEC1-099
      RETURN                                                            LEC1-100
   12 WRITE (6,1016)                                                    LEC1-101
      RETURN                                                            LEC1-102
 1000 FORMAT (//23H SINGLE PARTICLE STATES/)                            LEC1-103
 1001 FORMAT (7F10.5)                                                   LEC1-104
 1002 FORMAT (10X,I5,21H INTEGRATION STEPS OF,D15.6/)                   LEC1-105
 1003 FORMAT (5X,I5,27H  SINGLE PARTICLE FUNCTIONS/5X,I5,18H  PROTON FUNLEC1-106
     1CTIONS/)                                                          LEC1-107
 1004 FORMAT (30H RECOIL CORRECTIONS FOR A MASS,D15.6,5X,8HMATCHING,D15.LEC1-108
     16,5X,14HEFFECTIVE STEP,D15.6/)                                    LEC1-109
 1005 FORMAT (72L1)                                                     LEC1-110
 1006 FORMAT (/8H LO(40)=,L2,13H - USE OF BCS/8H LOO(1)=,L2,34H - USE OFLEC1-111
     1 WOODS SAXON BOUND STATES/8H LOO(2)=,L2,34H - PRINT THE BOUND STATLEC1-112
     2E FUNCTIONS)                                                      LEC1-113
 1007 FORMAT (8H LOO(3)=,L2,78H - SUM OF HARMONIC OSCILLATOR FUNCTIONS WLEC1-114
     1ITH A RANGE OF RADIAL QUANTUM NUMBERS)                            LEC1-115
 1008 FORMAT (8H LOO(3)=,L2,60H - ORTHOGONALISATION OF THE WOODS SAXON SLEC1-116
     1OLUTIONS INSIDE THE,I4,6H STEPS)                                  LEC1-117
 1009 FORMAT (14I5)                                                     LEC1-118
 1010 FORMAT (5X,I5,5X,3HN =,I3,5X,3HL =,I3,5X,3HJ =,I3)                LEC1-119
 1011 FORMAT (30X,7HALPHA =,F10.4,10X,19HHARMONIC OSCILLATOR)           LEC1-120
 1012 FORMAT (24H RENORMALISATION FACTOR:,D15.6,10X,I3,53H DIFFERENT RADLEC1-121
     1IAL QUANTUM NUMBERS WITH THE AMPLITUDES/(8D15.6))                 LEC1-122
 1013 FORMAT (/36H ORTHOGONALISATION BETWEEN FUNCTIONS,I4,4H AND,I4,8H WLEC1-123
     1ITH N=,I2,7H AND N=,I2,7H FOR L=,I3,7H AND J=,I2/15H NORMALISATIONLEC1-124
     2S,2D15.8,8H OVERLAP,D15.8/20H CORRECTION FACTOR =,D15.8,5X,17HRENOLEC1-125
     2RMALISATION =,D15.8)                                              LEC1-126
 1014 FORMAT (/40H RESULT OF SUM OR ORTHOGONALISATION WITH,I3,10H FUNCTILEC1-127
     1ONS/(6(I6,D15.6)))                                                LEC1-128
 1015 FORMAT (20X,17H*** BCS ***   V =,D18.6,10X,3HU =,D18.6)           LEC1-129
 1016 FORMAT (25H ***** STOP IN LEC1 *****)                             LEC1-130
      END                                                               LEC1-131
