C 11/12/99                                                      DWBA98  LEC2-000
      SUBROUTINE LEC2(INM,KTF,CMU,CVF,VV,VR,NR,FO,NCHE,X,IDMT,NTOT)     LEC2-001
C READ IN THE INTERACTION.                                              LEC2-002
C INPUT:     INM     NUMBER OF INTEGRATION POINTS.                      LEC2-003
C            NR      SHIFT BETWEEN VR AND VV.                           LEC2-004
C            FO      SINGLE PARTICLE FUNCTIONS.                         LEC2-005
C            NCHE,X  DESCRIPTION OF THE TARGET.                         LEC2-006
C            IDMT    TOTAL DIMENSION OF THE WORKING AREA.               LEC2-007
C            NTOT    DIMENSION OF THE WORKING AREA VR.                  LEC2-008
C                    ON RETURN THE AREA ACTUALLY USED.                  LEC2-009
C DATA TRANSFERRED BY THE COMMON /NOMBR/                                LEC2-010
C            H       INTEGRATION STEP.                                  LEC2-011
C            KV      NUMBER OF DIFFERENT RANGES.                        LEC2-012
C            LO      LOGICAL CONTROLS. THE PROGRAMME BELOW RETURNS:     LEC2-013
C                          LO(16)=.TRUE.  COULOMB INTERACTION           LEC2-014
C                          LO(23)=.TRUE.  ZERO RANGE INTERACTION.       LEC2-015
C                          LO(25)=.TRUE.  USE OF (L.S)**2-L**2.         LEC2-016
C                          LO(29)=.TRUE.  REAL INTERACTION.             LEC2-017
C OUTPUTS: KTF(7,1,*)      ADDRESS OF THE REAL DEPENDENCE FOR THE       LEC2-018
C                          PROTON-PROTON INTERACTION.                   LEC2-019
C          KTF(7,2,*)      ADDRESS OF THE REAL DEPENDENCE FOR THE       LEC2-020
C                          DIRECT PROTON-NEUTRON INTERACTION.           LEC2-021
C          KTF(7,3,*)      ADDRESS OF THE REAL DEPENDENCE FOR THE       LEC2-022
C                          EXCHANGE PROTON-NEUTRON INTERACTION.         LEC2-023
C          KTF(7,I,*)      ADDRESS OF THE IMAGINARY DEPENDENCES FOR     LEC2-024
C                          I=4,6 IN THE SAME ORDER.                     LEC2-025
C          KTF(7,7,*)      NATURE OF THE RADIAL DEPENDENCE:             LEC2-026
C                          0 - GEOMETRIC AVERAGE, 1 - ARITHMETIC AVERAGELEC2-027
C                          -1 - VALUE AT MIDDLE POINT.                  LEC2-028
C                          FOR A FINITE RANGE, THE ADDRESS OF THE REAL  LEC2-029
C                          DEPENDENCE ALONE IS TESTED. FOR A ZERO RANGE,LEC2-030
C                          THE ADDRESS PF THE IMAGINARY DEPENDENCE      LEC2-031
C                          IS ALSO TESTED.                              LEC2-032
C          CMU(I)          RANGE.                                       LEC2-033
C          CVF(7,I,*)      REAL STRENGTH FOR I=1,3, IMAGINARY STRENGTH  LEC2-034
C                          FOR I=4,6 IN THE ORDER USED FOR KTF.         LEC2-035
C          VV              RADIAL FORM-FACTORS.                         LEC2-036
C OUTPUTS TRANSFERRED BY THE COMMON /NOMBR/                             LEC2-037
C          CCO             COULOMB INTERACTION.                         LEC2-038
C          KS              NUMBER OF NON-ZERO RANGES.                   LEC2-039
C          KR              ADDRESS OF THE COULOMB MULTIPOLES.           LEC2-040
C          KY              NUMBER OF DIFFERENT RADIAL DEPENDENCES.      LEC2-041
C          ILL             NUMBER OF FORM FACTORS                       LEC2-042
C WORKING AREA VR FOR THE INPUT OF FORM FACTORS.                        LEC2-043
C***********************************************************************LEC2-044
      IMPLICIT REAL*8 (A-H,O-Z)                                         LEC2-045
      LOGICAL LOO(10),LO                                                LEC2-046
      DIMENSION KTF(7,7,1),CMU(1),CVF(7,6,1),VV(INM,1),VR(1),FO(INM,1),NLEC2-047
     1CHE(2,1),X(2,1),LG0(4),ILX(6,4),KF(6),CFV(6),LG1(3,14),LG2(5,3)   LEC2-048
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),LEC2-049
     1LO(40)                                                            LEC2-050
      DATA LG0 /4HPROT,4HON  ,4HNEUT,4HRON /                            LEC2-051
      DATA LG1 /4H SCA,4HLAR ,4HS=0 ,4H SCA,4HLAR ,4HS=1 ,4H    ,4HL.S ,LEC2-052
     14H    ,4H   T,4HENSO,4HR   ,4H  (L,4H.S)*,4H*2  ,4H  L*,4H*2,S,4H=LEC2-053
     20  ,4H  L*,4H*2,S,4H=1  ,4H SCA,4HLAR ,4HS=0 ,4H SCA,4HLAR ,4HS=0 LEC2-054
     3,4H    ,4HL.S ,4H    ,4H  (L,4H.S)*,4H*2  ,4H SKY,4HRME,,4HS=0 ,4HLEC2-055
     4 SKY,4HRME,,4HS=1 ,4H   T,4HENSO,4HR   /                          LEC2-056
      DATA LG2 /4HV((D,4H1+D2,4H)/2),4H    ,4H    ,4H(V(D,4H1)*V,4H(D2),LEC2-057
     14H)**(,4H1/2),4H(V(D,4H1)+V,4H(D2),4H)/2 ,4H    /                 LEC2-058
      DATA ILX /2,0,0,2,0,0,5,2,0,3,0,0,9,5,2,9,5,2,12,6,2,12,6,2/      LEC2-059
      IDT=0                                                             LEC2-060
C INPUT OF LOGICAL CONTROLS                                             LEC2-061
      LO(16)=.FALSE.                                                    LEC2-062
      LO(25)=.FALSE.                                                    LEC2-063
      DO 1 I=1,9                                                        LEC2-064
    1 LOO(I)=.FALSE.                                                    LEC2-065
      READ (5,1000) LO(16),LO(25),(LOO(I),I=1,9)                        LEC2-066
      WRITE (6,1001) LO(16),LO(25),(LOO(I),I=1,9)                       LEC2-067
      LO(23)=.FALSE.                                                    LEC2-068
      LO(29)=.TRUE.                                                     LEC2-069
      IL1=1                                                             LEC2-070
      IL2=1                                                             LEC2-071
C RANGES AND TYPES OF THE INTERACTION.                                  LEC2-072
      KS=KV                                                             LEC2-073
      KT=0                                                              LEC2-074
      DO 4 K=1,KV                                                       LEC2-075
      READ (5,1002) CMU(K)                                              LEC2-076
      READ (5,1003) (KTF(I,1,K),KTF(I,2,K),I=1,7)                       LEC2-077
C CONTROL OF INTERACTIONS AND COUNT OF DENSITY DEPENDENCES              LEC2-078
      DO 2 I=1,7                                                        LEC2-079
      IF (KTF(I,1,K).LT.0.OR.KTF(I,1,K).GT.5) GO TO 59                  LEC2-080
      IF (KTF(I,1,K).NE.KTF(I,2,K)) GO TO 60                            LEC2-081
      IF (KTF(I,1,K).NE.0) KT=KT+2                                      LEC2-082
      IF (CMU(K).NE.0..OR.KTF(I,1,K).EQ.0) GO TO 2                      LEC2-083
      IF (I.LE.4) KT=KT-1                                               LEC2-084
      IF (I.GT.4) IL1=3                                                 LEC2-085
    2 LO(29)=LO(29).AND.KTF(I,1,K).LT.2                                 LEC2-086
      IF (CMU(K).EQ.0.) GO TO 3                                         LEC2-087
      IF (KTF(3,1,K).GT.0) IL2=MAX0(IL2,2)                              LEC2-088
      IF (MAX0(KTF(5,1,K),KTF(6,1,K),KTF(7,1,K)).GT.0) IL2=4            LEC2-089
      GO TO 4                                                           LEC2-090
C INPUT AND CONTROL FOR ZERO RANGE                                      LEC2-091
    3 IF (K.LT.KV) GO TO 61                                             LEC2-092
      KS=KV-1                                                           LEC2-093
      LO(23)=.TRUE.                                                     LEC2-094
      IF (KTF(4,1,K).GT.0) IL1=MAX0(IL1,3)                              LEC2-095
      IF (KTF(3,1,K).GT.0) IL1=MAX0(IL1,2)                              LEC2-096
    4 CONTINUE                                                          LEC2-097
      IL1=MAX0(IL1,IL2)                                                 LEC2-098
      DO 5 I=1,6                                                        LEC2-099
      ILL(I,1)=ILX(I,IL1)                                               LEC2-100
    5 ILL(I,3)=ILX(I,IL2)                                               LEC2-101
      KR=0                                                              LEC2-102
C DEFAULT VALUE FOR COULOMB POTENTIAL                                   LEC2-103
      DO 6 I=1,3,2                                                      LEC2-104
      CCO(I)=1.43997595D0                                               LEC2-105
    6 CCO(I+1)=0.D0                                                     LEC2-106
      IF (LO(16)) KR=KS+1                                               LEC2-107
C READ THE COULOMB POTENTIAL                                            LEC2-108
      IF (LOO(1)) READ (5,1002) (CCO(I),I=1,4)                          LEC2-109
      IF (LO(16)) WRITE (6,1004) (CCO(I),I=1,4)                         LEC2-110
      KVM=0                                                             LEC2-111
      KVD=0                                                             LEC2-112
      KY=0                                                              LEC2-113
C READ THE INTERACTIONS                                                 LEC2-114
      DO 13 K=1,KT                                                      LEC2-115
      READ (5,1003) I7,I3,I4,I5,I6                                      LEC2-116
      I1=(I7+1)/2                                                       LEC2-117
      I2=I7+2-2*I1                                                      LEC2-118
      I9=I1                                                             LEC2-119
      IF (I3.GT.KS) I9=I9+7                                             LEC2-120
      LOO(10)=.NOT.(I1.LE.4.AND.I3.GT.KS)                               LEC2-121
      IF ((I7.LE.0).OR.(I7.GT.14).OR.(I3.LE.0).OR.(I3.GT.KV)) GO TO 62  LEC2-122
      IF (KTF(I1,I2,I3).LT.0) GO TO 63                                  LEC2-123
      IF (KTF(I1,I2,I3).NE.I4) GO TO 64                                 LEC2-124
      KTF(I1,I2,I3)=-KTF(I1,I2,I3)                                      LEC2-125
      CVF(I1,I2+3,I3)=0.D0                                              LEC2-126
      IF (LOO(10)) GO TO 7                                              LEC2-127
      KTF(I1,3-I2,I3)=-KTF(I1,3-I2,I3)                                  LEC2-128
      CVF(I1,6-I2,I3)=0.D0                                              LEC2-129
      I2=2                                                              LEC2-130
      AC=0.D0                                                           LEC2-131
      IF (I1.EQ.2.AND.LOO(3)) AC=.5D0                                   LEC2-132
      IF (I1.EQ.2) I2=1                                                 LEC2-133
      IF (LOO(3)) I2=3-I2                                               LEC2-134
    7 IF (I4.LE.2) READ (5,1005) CVF(I1,I2,I3)                          LEC2-135
      IF (I4.GT.2) READ (5,1005) CVF(I1,I2,I3),CVF(I1,I2+3,I3)          LEC2-136
      IF (I3.LE.KS.AND.LOO(2)) CVF(I1,I2,I3)=CVF(I1,I2,I3)/CMU(I3)      LEC2-137
      IF (I3.LE.KS.AND.LOO(2).AND.I4.GT.2) CVF(I1,I2+3,I3)=CVF(I1,I2+3,ILEC2-138
     13)/CMU(I3)                                                        LEC2-139
      IF (LOO(7).AND.I4.EQ.1) WRITE (6,1006) (LG1(L,I9),L=1,3),I2-1,I7,ILEC2-140
     13,CMU(I3),CVF(I1,I2,I3)                                           LEC2-141
      IF (LOO(7).AND.I4.EQ.3) WRITE (6,1007) (LG1(L,I9),L=1,3),I2-1,I7,ILEC2-142
     13,CMU(I3),CVF(I1,I2,I3),CVF(I1,I2+3,I3)                           LEC2-143
      IF ((I4.EQ.1).OR.(I4.EQ.3)) GO TO 12                              LEC2-144
C READ DENSITY DEPENDENCE OF THE INTERACTION                            LEC2-145
      I0=IABS(I6)                                                       LEC2-146
      IF (I6.EQ.I0) KVD=MAX0(KVD,1)                                     LEC2-147
      IF (I6.EQ.I0.AND.I5.LT.0) KVD=MAX0(KVD,2)                         LEC2-148
      IF (.NOT.LOO(7)) GO TO 8                                          LEC2-149
      IF (I4.EQ.2) WRITE (6,1008) (LG1(L,I9),L=1,3),I2-1,I7,I3,CMU(I3),CLEC2-150
     1VF(I1,I2,I3)                                                      LEC2-151
      IF (I4.GE.4) WRITE (6,1009) (LG1(L,I9),L=1,3),I2-1,I7,I3,CMU(I3),CLEC2-152
     1VF(I1,I2,I3),CVF(I1,I2+3,I3)                                      LEC2-153
      WRITE (6,1010)                                                    LEC2-154
      IF (I6.NE.I0.AND.I4.EQ.2) WRITE (6,1011)                          LEC2-155
      IF (I6.EQ.I0.AND.I4.EQ.2) WRITE (6,1012)                          LEC2-156
      IF (I6.NE.I0.AND.I4.NE.2) WRITE (6,1013)                          LEC2-157
      IF (I6.EQ.I0.AND.I4.NE.2) WRITE (6,1014)                          LEC2-158
    8 IF (I6.LE.3) GO TO 65                                             LEC2-159
      I8=I5                                                             LEC2-160
      IF (I8.NE.0) I8=I8/IABS(I8)                                       LEC2-161
      IF (KTF(I1,1,I3).EQ.KTF(I1,2,I3).AND.KTF(I1,7,I3).NE.I8) GO TO 66 LEC2-162
      KTF(I1,7,I3)=I8                                                   LEC2-163
      KTF(I1,I2+2,I3)=I6                                                LEC2-164
      KTF(I1,I2+4,I3)=KY                                                LEC2-165
      IF (2*(KY+3*I7).GT.NTOT) CALL MEMO(IDMT,IDMT+2*(KY+3*I0)-NTOT,NTOTLEC2-166
     1,3,LO)                                                            LEC2-167
      IF (LO(19)) GO TO 71                                              LEC2-168
      DO 9 I=1,I0                                                       LEC2-169
      A2=0.D0                                                           LEC2-170
      IF (I4.EQ.2) READ (5,1015) VR(KY+1),A1                            LEC2-171
      IF (I4.NE.2) READ (5,1015) VR(KY+1),A1,A2                         LEC2-172
      VR(KY+2)=A1*CVF(I1,I2,I3)-A2*CVF(I1,I2+3,I3)                      LEC2-173
      VR(KY+3)=A1*CVF(I1,I2+3,I3)+A2*CVF(I1,I2,I3)                      LEC2-174
      IF (.NOT.LOO(7)) GO TO 9                                          LEC2-175
      IF (I4.EQ.2) WRITE (6,1016) VR(KY+1),A1,VR(KY+2)                  LEC2-176
      IF (I4.NE.2) WRITE (6,1016) VR(KY+1),A1,A2,VR(KY+2),VR(KY+3)      LEC2-177
    9 KY=KY+3                                                           LEC2-178
      CVF(I1,I2+1,I3)=1.D0                                              LEC2-179
      CVF(I1,I2+4,I3)=0.D0                                              LEC2-180
C VERIFICATION OF DECREASE OR INCREASE OF ABSCISSAE                     LEC2-181
      DO 10 I=2,I0                                                      LEC2-182
      IF (I6.EQ.I0.AND.VR(KY-3*I+4).GT.VR(KY-3*I+1)) GO TO 67           LEC2-183
      IF (I6.NE.I0.AND.VR(KY-3*I+4).LT.VR(KY-3*I+1)) GO TO 68           LEC2-184
   10 CONTINUE                                                          LEC2-185
      IF (KTF(I1,1,I3).NE.KTF(I1,2,I3)) GO TO 13                        LEC2-186
      INC=2                                                             LEC2-187
      IF (I4.EQ.2) INC=1                                                LEC2-188
      KVM=KVM+3*INC                                                     LEC2-189
      IF (LOO(10)) GO TO 13                                             LEC2-190
      KZ=KTF(I1,I2+4,I3)                                                LEC2-191
      KTF(I1,5-I2,I3)=I6                                                LEC2-192
      KTF(I1,7-I2,I3)=KY                                                LEC2-193
      IF (2*(KY+3*I0).GT.NTOT) CALL MEMO(IDMT,IDMT+2*(KY+3*I0)-NTOT,NTOTLEC2-194
     1,3,LO)                                                            LEC2-195
C ELIMINATION OF DUMMY ZERO RANGE INTERACTIONS                          LEC2-196
      IF (LO(19)) GO TO 71                                              LEC2-197
      DO 11 I=1,I0                                                      LEC2-198
      VR(KY+1)=VR(KZ+1)                                                 LEC2-199
      VR(KY+2)=AC*VR(KZ+2)                                              LEC2-200
      VR(KY+3)=AC*VR(KZ+3)                                              LEC2-201
      KZ=KZ+3                                                           LEC2-202
   11 KY=KY+3                                                           LEC2-203
      CVF(I1,I2+1,I3)=1.D0                                              LEC2-204
      CVF(I1,I2+4,I3)=0.D0                                              LEC2-205
      GO TO 13                                                          LEC2-206
   12 IF (LOO(10)) GO TO 13                                             LEC2-207
      CVF(I1,3-I2,I3)=AC*CVF(I1,I2,I3)                                  LEC2-208
      CVF(I1,6-I2,I3)=AC*CVF(I1,I2,I3)                                  LEC2-209
   13 CONTINUE                                                          LEC2-210
C TRANSLATION OF DATA                                                   LEC2-211
      IF (KVM.EQ.0) GO TO 27                                            LEC2-212
      KY0=MAX0(INM*KVM-NR,0)                                            LEC2-213
      KY1=KY0+KY                                                        LEC2-214
C 1-KY0 FREE TO USE   KY0+1-KY1 INPUT  KY1+1-IDT  DENSITIES             LEC2-215
      IMN=INM*KVD                                                       LEC2-216
      HX=H/DFLOAT(KVD)                                                  LEC2-217
      IDT=KY1+2*KVD*IMN                                                 LEC2-218
      IF (2*IDT.GT.NTOT) CALL MEMO(IDMT,IDMT+2*IDT-NTOT,NTOT,3,LO)      LEC2-219
      IF (LO(19)) GO TO 71                                              LEC2-220
      DO 14 I=1,KY                                                      LEC2-221
   14 VR(I+KY0)=VR(I)                                                   LEC2-222
      IF (LOO(5)) GO TO 17                                              LEC2-223
      KY2=KY1                                                           LEC2-224
C WOODS-SAXON DENSITY                                                   LEC2-225
      DO 16 K=1,2                                                       LEC2-226
      READ (5,1002) XV,XR,XM,XA                                         LEC2-227
      RR=XR*XM**.3333333333D0                                           LEC2-228
      IF (LOO(7)) WRITE (6,1017) LG0(2*K-1),LG0(2*K),XV,RR,XA,XR,XM     LEC2-229
      DO 15 I=1,IMN                                                     LEC2-230
      KY2=KY2+1                                                         LEC2-231
      Y0=I*HX                                                           LEC2-232
   15 VR(KY2)=XV/(1.D0+DEXP((Y0-RR)/XA))                                LEC2-233
   16 CONTINUE                                                          LEC2-234
      GO TO 24                                                          LEC2-235
C DENSITY DERIVED FROM OCCUPATION NUMBERS                               LEC2-236
   17 DO 18 I=1,INM                                                     LEC2-237
      VR(KY1+I*KVD)=0.D0                                                LEC2-238
   18 VR(KY1+INM+I*KVD)=0.D0                                            LEC2-239
      DO 21 K=1,NBCONF                                                  LEC2-240
      DO 20 M=1,2                                                       LEC2-241
      AX=X(M,K)/12.566370614359172D0/0.926251D-1                        LEC2-242
      IF (AX.EQ.0.D0) GO TO 20                                          LEC2-243
      NPAR=NCHE(M,K)                                                    LEC2-244
      NTRO=NCHE(3-M,K)                                                  LEC2-245
      KY2=KY1                                                           LEC2-246
      IF (NPAR.GT.NBPROT) KY2=KY2+IMN                                   LEC2-247
      DO 19 I=1,INM                                                     LEC2-248
      R=I*H                                                             LEC2-249
   19 VR(KY2+I*KVD)=VR(KY2+I*KVD)+AX*FO(I,NPAR)*FO(I,NTRO)/R**2         LEC2-250
   20 CONTINUE                                                          LEC2-251
   21 CONTINUE                                                          LEC2-252
      IF (KVD.EQ.1) GO TO 24                                            LEC2-253
      KY3=KY2                                                           LEC2-254
      DO 23 M=1,2                                                       LEC2-255
      VR(KY3+1)=VR(KY3+2)                                               LEC2-256
      DO 22 I=2,INM                                                     LEC2-257
   22 VR(KY3+2*I-1)=0.5D0*(VR(KY3+2*I-2)+VR(KY3+2*I))                   LEC2-258
   23 KY3=KY3+IMN                                                       LEC2-259
   24 IF (.NOT.LOO(6)) GO TO 26                                         LEC2-260
      DO 25 IS=1,IMN                                                    LEC2-261
   25 VR(KY1+IS+IMN)=(VR(KY1+IS)+VR(KY1+IS+IMN))*.5D0                   LEC2-262
   26 IF (LOO(8)) WRITE (6,1018) (IS,VR(KY1+IS),VR(KY1+IS+IMN),IS=1,IMN)LEC2-263
   27 WRITE (6,1019) (CCO(I),I=1,4)                                     LEC2-264
      KY=1                                                              LEC2-265
C PROTON-PROTON, DIRECT AND EXCHANGE PROTON-NEUTRON INTERACTIONS        LEC2-266
      KZ=KVM                                                            LEC2-267
      DO 56 K=1,KV                                                      LEC2-268
      DO 55 I=1,7                                                       LEC2-269
      DO 28 L=1,6                                                       LEC2-270
      KF(L)=-KTF(I,L,K)                                                 LEC2-271
      CFV(L)=CVF(I,L,K)                                                 LEC2-272
   28 CVF(I,L,K)=0.D0                                                   LEC2-273
      IF (KF(1).EQ.0) GO TO 32                                          LEC2-274
      IF ((KF(1).NE.1).AND.(KF(1).NE.3)) GO TO 34                       LEC2-275
      IF (LOO(3)) GO TO 30                                              LEC2-276
      DO 29 L=1,4,3                                                     LEC2-277
      CVF(I,L,K)=CFV(L+1)                                               LEC2-278
      CVF(I,L+1,K)=.5D0*(CFV(L+1)+CFV(L))                               LEC2-279
   29 CVF(I,L+2,K)=.5D0*(CFV(L+1)-CFV(L))                               LEC2-280
      GO TO 32                                                          LEC2-281
   30 DO 31 L=1,4,3                                                     LEC2-282
      CVF(I,L,K)=CFV(L+1)                                               LEC2-283
      CVF(I,L+1,K)=CFV(L)                                               LEC2-284
   31 CVF(I,L+2,K)=CFV(L+1)-CFV(L)                                      LEC2-285
   32 DO 33 L=1,6                                                       LEC2-286
      KTF(I,L,K)=0                                                      LEC2-287
      IF (CVF(I,L,K).NE.0.D0) KTF(I,L,K)=1                              LEC2-288
   33 CONTINUE                                                          LEC2-289
      KTF(I,7,K)=0                                                      LEC2-290
      GO TO 55                                                          LEC2-291
   34 INX=INM                                                           LEC2-292
      HX=H                                                              LEC2-293
      IF (KTF(I,7,K).GE.0) GO TO 35                                     LEC2-294
      INX=2*INX                                                         LEC2-295
      HX=0.5D0*HX                                                       LEC2-296
C INTERPOLATION OF T=1 FOR PROTONS, T=1 AND T=0 FOR NEUTRONS OR         LEC2-297
C INTERPOLATION OF VPP FOR PROTONS, VPP AND VPN FOR NEUTRONS            LEC2-298
   35 KDV=IMN/INX                                                       LEC2-299
      IP=0                                                              LEC2-300
      KY2=KY1                                                           LEC2-301
      DO 41 M=1,2                                                       LEC2-302
      DO 40 LL=1,M                                                      LEC2-303
      L=LL                                                              LEC2-304
      IF (LOO(3)) L=3-L                                                 LEC2-305
      AC=1.D0                                                           LEC2-306
      IF (KTF(I,5-L,K).GT.0) AC=-AC                                     LEC2-307
      IP=IP+1                                                           LEC2-308
      IR=KY0+KTF(I,7-L,K)+1                                             LEC2-309
      IRL=IR                                                            LEC2-310
      IRM=IR+3*IABS(KTF(I,5-L,K))-12                                    LEC2-311
      KF(IP)=KY+1                                                       LEC2-312
      KF(IP+3)=0                                                        LEC2-313
      IF (KTF(I,3-L,K).NE.2) KF(IP+3)=KZ+1                              LEC2-314
      DO 39 IS=1,INX                                                    LEC2-315
      X0=IS*HX                                                          LEC2-316
      Y0=X0                                                             LEC2-317
      IF (KTF(I,5-L,K).GT.0) X0=VR(KY2+IS*KDV)                          LEC2-318
   36 IF (AC*X0.LT.AC*VR(IR+6).OR.IR.GE.IRM) GO TO 37                   LEC2-319
      IR=IR+3                                                           LEC2-320
      GO TO 36                                                          LEC2-321
   37 IF (AC*X0.GT.AC*VR(IR+3).OR.IR.LE.IRL) GO TO 38                   LEC2-322
      IR=IR-3                                                           LEC2-323
      GO TO 36                                                          LEC2-324
   38 X1=(X0-VR(IR+3))*(X0-VR(IR+6))*(X0-VR(IR+9))/((VR(IR)-VR(IR+3))*(VLEC2-325
     1R(IR)-VR(IR+6))*(VR(IR)-VR(IR+9)))                                LEC2-326
      X2=(X0-VR(IR))*(X0-VR(IR+6))*(X0-VR(IR+9))/((VR(IR+3)-VR(IR))*(VR(LEC2-327
     1IR+3)-VR(IR+6))*(VR(IR+3)-VR(IR+9)))                              LEC2-328
      X3=(X0-VR(IR))*(X0-VR(IR+3))*(X0-VR(IR+9))/((VR(IR+6)-VR(IR))*(VR(LEC2-329
     1IR+6)-VR(IR+3))*(VR(IR+6)-VR(IR+9)))                              LEC2-330
      X4=(X0-VR(IR))*(X0-VR(IR+3))*(X0-VR(IR+6))/((VR(IR+9)-VR(IR))*(VR(LEC2-331
     1IR+9)-VR(IR+3))*(VR(IR+9)-VR(IR+6)))                              LEC2-332
      IF (KTF(I,3-L,K).NE.2) VV(IS,KZ)=X1*VR(IR+2)+X2*VR(IR+5)+X3*VR(IR+LEC2-333
     18)+X4*VR(IR+11)                                                   LEC2-334
   39 VV(IS,KY)=X1*VR(IR+1)+X2*VR(IR+4)+X3*VR(IR+7)+X4*VR(IR+10)        LEC2-335
      KY=KY+INX/INM                                                     LEC2-336
      IF (KTF(I,3-L,K).NE.2) KZ=KZ-INX/INM                              LEC2-337
   40 CONTINUE                                                          LEC2-338
   41 KY2=KY2+IMN                                                       LEC2-339
C PROTON-PROTON AND PROTON-NEUTRON INTERACTIONS                         LEC2-340
      IT=3                                                              LEC2-341
      IF (KTF(I,1,K).NE.2) IT=6                                         LEC2-342
      AC=1.D0                                                           LEC2-343
      IF (KTF(I,7,K).GT.0) AC=.5D0                                      LEC2-344
      DO 46 IS=1,INX                                                    LEC2-345
      DO 42 L=1,IT                                                      LEC2-346
   42 CFV(L)=AC*VV(IS,KF(L)-1)                                          LEC2-347
      VV(IS,KF(1)-1)=CFV(1)                                             LEC2-348
      IF (LOO(3)) GO TO 43                                              LEC2-349
      VV(IS,KF(2)-1)=0.5D0*(CFV(2)+CFV(3))                              LEC2-350
      VV(IS,KF(3)-1)=0.5D0*(CFV(2)-CFV(3))                              LEC2-351
      GO TO 44                                                          LEC2-352
   43 VV(IS,KF(2)-1)=CFV(2)                                             LEC2-353
      VV(IS,KF(3)-1)=CFV(3)-CFV(2)                                      LEC2-354
   44 IF (KTF(I,1,K).EQ.2) GO TO 46                                     LEC2-355
      VV(IS,KF(4)-1)=CFV(4)                                             LEC2-356
      IF (LOO(3)) GO TO 45                                              LEC2-357
      VV(IS,KF(5)-1)=0.5D0*(CFV(5)+CFV(6))                              LEC2-358
      VV(IS,KF(6)-1)=0.5D0*(CFV(5)-CFV(6))                              LEC2-359
      GO TO 46                                                          LEC2-360
   45 VV(IS,KF(5)-1)=CFV(5)                                             LEC2-361
      VV(IS,KF(6)-1)=CFV(6)-CFV(5)                                      LEC2-362
   46 CONTINUE                                                          LEC2-363
      LOO(10)=KTF(I,1,K).NE.-2                                          LEC2-364
      DO 47 L=1,3                                                       LEC2-365
      KTF(I,L,K)=KF(L)                                                  LEC2-366
      KTF(I,L+3,K)=0                                                    LEC2-367
      IF (LOO(10)) KTF(I,L+3,K)=KF(L+3)                                 LEC2-368
      CVF(I,L,K)=1.D0                                                   LEC2-369
   47 CVF(I,L+3,K)=0.D0                                                 LEC2-370
      IF (KTF(I,7,K).NE.0) GO TO 53                                     LEC2-371
      DO 52 L=1,3                                                       LEC2-372
      M=KF(L)-1                                                         LEC2-373
      IF (LOO(10)) GO TO 50                                             LEC2-374
      AC=1.D0                                                           LEC2-375
      IF (VV(1,M).GT.0.D0) GO TO 48                                     LEC2-376
      AC=-AC                                                            LEC2-377
      CVF(I,L,K)=-CVF(I,L,K)                                            LEC2-378
   48 DO 49 IS=1,INX                                                    LEC2-379
      IF (AC*VV(IS,M).GT.0.D0) GO TO 49                                 LEC2-380
      WRITE (6,1020) I,K,L                                              LEC2-381
      IF (L.LT.3.AND..NOT.LOO(4)) GO TO 69                              LEC2-382
      WRITE (6,1021)                                                    LEC2-383
      GO TO 52                                                          LEC2-384
   49 VV(IS,M)=DSQRT(AC*VV(IS,M))                                       LEC2-385
      GO TO 52                                                          LEC2-386
   50 MM=KF(L+3)-1                                                      LEC2-387
      BA=1.D0                                                           LEC2-388
      CD=1.D0                                                           LEC2-389
      AC=1.D0                                                           LEC2-390
      DO 51 IS=1,INX                                                    LEC2-391
      IF (VV(IS,M).LT.0.D0.AND.BA*VV(IS,MM).LT.0.D0) CD=-CD             LEC2-392
      BR=CD*(VV(IS,M)**2+VV(IS,MM)**2)**.25D0                           LEC2-393
      BT=DATAN2(VV(IS,MM),VV(IS,M))*.5D0                                LEC2-394
      IF (VV(IS,MM).NE.0.D0) BA=VV(IS,MM)                               LEC2-395
      VV(IS,M)=BR*DCOS(BT)                                              LEC2-396
   51 VV(IS,MM)=BR*DSIN(BT)                                             LEC2-397
   52 CONTINUE                                                          LEC2-398
   53 IF (.NOT.LOO(8)) GO TO 55                                         LEC2-399
      I1=I                                                              LEC2-400
      IF (K.GT.KS) I1=I1+7                                              LEC2-401
      WRITE (6,1022) (LG1(L,I1),L=1,3),CMU(K),(LG2(L,KTF(I,7,K)+2),L=1,5LEC2-402
     1),KF                                                              LEC2-403
      DO 54 IS=1,INX                                                    LEC2-404
      R=IS*HX                                                           LEC2-405
   54 WRITE (6,1023) IS,R,(VV(IS,KF(L)-1),L=1,IT)                       LEC2-406
   55 CONTINUE                                                          LEC2-407
   56 CONTINUE                                                          LEC2-408
      IF (LOO(9)) GO TO 58                                              LEC2-409
      IF (KS.EQ.0) GO TO 57                                             LEC2-410
      WRITE (6,1024) ((LG1(K,L),K=1,3),L=1,7),(K,CMU(K),(KTF(I,7,K),I=1,LEC2-411
     17),((KTF(I,L,K),KTF(I,L+3,K),I=1,7),(CVF(I,L,K),I=1,7),(CVF(I,L+3,LEC2-412
     2K),I=1,7),L=1,3),K=1,KS)                                          LEC2-413
   57 IF (LO(23)) WRITE (6,1025) ((LG1(K,L),K=1,3),L=8,14),(KTF(I,7,KS+1LEC2-414
     1),I=1,7),((KTF(I,L,KS+1),KTF(I,L+3,KS+1),I=1,7),(CVF(I,L,KS+1),I=1LEC2-415
     2,7),(CVF(I,L+3,KS+1),I=1,7),L=1,3)                                LEC2-416
   58 NTOT=IDT                                                          LEC2-417
      RETURN                                                            LEC2-418
   59 WRITE (6,1026) I,K,KTF(I,1,K)                                     LEC2-419
      GO TO 70                                                          LEC2-420
   60 WRITE (6,1027) I,K,KTF(I,2,K),I,K,KTF(I,1,K)                      LEC2-421
      GO TO 70                                                          LEC2-422
   61 WRITE (6,1028) K,KV                                               LEC2-423
      GO TO 70                                                          LEC2-424
   62 WRITE (6,1029) I1,I2,I3,I7,KV                                     LEC2-425
      GO TO 70                                                          LEC2-426
   63 WRITE (6,1030) I1,I2,I3,I7                                        LEC2-427
      GO TO 70                                                          LEC2-428
   64 WRITE (6,1031) I1,I2,I3,KTF(I1,I2+4,I3),I4,I7                     LEC2-429
      GO TO 70                                                          LEC2-430
   65 WRITE (6,1032) I6                                                 LEC2-431
      GO TO 70                                                          LEC2-432
   66 WRITE (6,1033) I1,I3,I1,I3,I5,KTF(I1,7,I3),I8,I5                  LEC2-433
      GO TO 70                                                          LEC2-434
   67 WRITE (6,1034) I1,I2,I3,(VR(KY-3*I7+3*I-2),I=1,I7)                LEC2-435
      GO TO 70                                                          LEC2-436
   68 WRITE (6,1035) I1,I2,I3,(VR(KY-3*I7+3*I-2),I=1,I7)                LEC2-437
      GO TO 70                                                          LEC2-438
   69 WRITE (6,1036)                                                    LEC2-439
   70 LO(19)=.TRUE.                                                     LEC2-440
   71 WRITE (6,1037)                                                    LEC2-441
      RETURN                                                            LEC2-442
 1000 FORMAT (72L1)                                                     LEC2-443
 1001 FORMAT (/9H LO(16) =,L2,20H COULOMB INTERACTION/9H LO(25) =,L2,57HLEC2-444
     1 USE OF (L.S)**2-L**2 INSTEAD OF THE QUADRATIC SPIN ORBIT/9H LOO(1LEC2-445
     2) =,L2,27H READ THE COULOMB POTENTIAL/9H LOO(2) =,L2,46H YUKAWA FOLEC2-446
     3RM-FACTORS MULTIPLIED BY THEIR RANGE/9H LOO(3) =,L2,44H PROTON-PROLEC2-447
     4ON AND PROTON-NEUTRON INTERACTION/9H LOO(4) =,L2,31H NO USE OF EXCLEC2-448
     5HANGE INTERACTION/9H LOO(5) =,L2,49H DENSITY DEPENDENCE DEFINED BYLEC2-449
     6 OCCUPATION NUMBERS/9H LOO(6) =,L2,61H USE OF PROTON+NEUTRON DENSILEC2-450
     7TY FOR PROTON-NEUTRON INTERACTION/9H LOO(7) =,L2,40H LISTING OF THLEC2-451
     8E INPUT OF THE INTERACTION/9H LOO(8) =,L2,35H LISTING OF THE INTERLEC2-452
     9POLATED VALUES/9H LOO(9) =,L2,35H NO LISTING OF THE INTERACTION USLEC2-453
     AED)                                                               LEC2-454
 1002 FORMAT (6F10.5)                                                   LEC2-455
 1003 FORMAT (14I5)                                                     LEC2-456
 1004 FORMAT (30H TWO-BODY COULOMB INTERACTION:,4D15.8)                 LEC2-457
 1005 FORMAT (2F20.10)                                                  LEC2-458
 1006 FORMAT (/5X,11HINTERACTION,3A4,7H FOR T=,I1,16H (DEFINED BY I7=,I2LEC2-459
     1,11H) AND RANGE,I3,F10.4,/10X,32HREAL AND CONSTANT WITH STRENGTH:,LEC2-460
     24X,1P,D15.7)                                                      LEC2-461
 1007 FORMAT (/5X,11HINTERACTION,3A4,7H FOR T=,I1,16H (DEFINED BY I7=,I2LEC2-462
     1,11H) AND RANGE,I3,F10.4,/10X,31HCOMPLEX CONSTANT WITH STRENGTH:,5LEC2-463
     2X,1P,D15.7,4H + I,D15.7)                                          LEC2-464
 1008 FORMAT (/5X,11HINTERACTION,3A4,7H FOR T=,I1,16H (DEFINED BY I7=,I2LEC2-465
     1,11H) AND RANGE,I3,F10.4,/10X,37HREAL DENSITY DEPENDENT WITH STRENLEC2-466
     2GTH:,2X,1P,D15.7)                                                 LEC2-467
 1009 FORMAT (/5X,11HINTERACTION,3A4,7H FOR T=,I1,16H (DEFINED BY I7=,I2LEC2-468
     1,11H) AND RANGE,I3,F10.4,/10X,41HCOMPLEX DENSITY DEPENDENCE WITH SLEC2-469
     2TRENGTH:,3X,1P,2D15.7)                                            LEC2-470
 1010 FORMAT (10X,53HTHE RADIAL DEPENDENCES ARE MULTIPLIED BY THE STRENGLEC2-471
     1TH)                                                               LEC2-472
 1011 FORMAT (13X,6HRADIUS,10X,10HVALUE READ,10X,10HVALUE USED)         LEC2-473
 1012 FORMAT (13X,7HDENSITY,9X,10HVALUE READ,10X,10HVALUE USED)         LEC2-474
 1013 FORMAT (13X,6HRADIUS,20X,10HVALUE READ,20X,10HVALUE USED)         LEC2-475
 1014 FORMAT (13X,7HDENSITY,19X,10HVALUE READ,20X,10HVALUE USED)        LEC2-476
 1015 FORMAT (F10.5,2F20.10)                                            LEC2-477
 1016 FORMAT (10X,F10.5,4F20.10)                                        LEC2-478
 1017 FORMAT (5X,2A4,34HDEPENDENCE PARAMETRISED BY DENSITY,F10.5,5X,7H RLEC2-479
     1ADIUS,F10.5,5X,19HSURFACE DIFFUSENESS,F10.5/5X,14HREDUCED RADIUS,FLEC2-480
     210.5,5X,4HMASS,F10.5)                                             LEC2-481
 1018 FORMAT (//19H INTERPOLATION WITH,6X,11HFOR PROTONS,18X,12HFOR NEUTLEC2-482
     1RONS/(5X,I5,2D30.10))                                             LEC2-483
 1019 FORMAT (//21H COULOMB INTERACTION:,4F20.5)                        LEC2-484
 1020 FORMAT (24H CHANGE OF SIGN AT POINT,I4,19H OF THE FORM FACTOR,I2,8LEC2-485
     1H OF KIND,I2,10H AND RANGE,I3)                                    LEC2-486
 1021 FORMAT (46H FORM FACTOR NOT NECESSARY IN THIS COMPUTATION)        LEC2-487
 1022 FORMAT (//47H RESULT OF THE INTERPOLATION OF THE INTERACTION,3A4,1LEC2-488
     13HFOR THE RANGE,F8.4,12H  DEFINED AS,2X,5A4//38X,4HREAL,47X,9HIMAGLEC2-489
     2INARY/13X,2(7X,47HPROTON        DIRECT NEUTRON   EXCHANGE NEUTRON)LEC2-490
     3/5X,6I18)                                                         LEC2-491
 1023 FORMAT (1X,I3,F8.4,1P,6D18.8)                                     LEC2-492
 1024 FORMAT (/25H FINITE RANGE INTERACTION/1X,24(1H*)//6X,10HRANGE    |LEC2-493
     1,7(2X,3A4,2H |)/8(15X,1H|)/(1X,I3,0P,F8.4,3X,1H|,7(I8,7X,1H|)/11X,LEC2-494
     23HP-P,7(2H |,2I6,2X),2H |/12X,4HRE |,7(1P,D14.6,2H |)/12X,4HIM |,7LEC2-495
     3(1P,D14.6,2H |)/7X,7HDIR P-N,7(2H |,2I6,2X),2H |/12X,4HRE |,7(1P,DLEC2-496
     414.6,2H |)/12X,4HIM |,7(1P,D14.6,2H |)/7X,7HEXC P-N,7(2H |,2I6,2X)LEC2-497
     5,2H |/12X,4HRE |,7(1P,D14.6,2H |)/12X,4HIM |,7(1P,D14.6,2H |)))   LEC2-498
 1025 FORMAT (/23H ZERO RANGE INTERACTION/1X,22(1H*)//15X,1H|,7(2X,3A4,2LEC2-499
     1H |)/8(15X,1H|)/15X,1H|,7(I8,7X,1H|)/11X,3HP-P,7(2H |,2I6,2X),2H |LEC2-500
     2/12X,4HRE |,7(1P,D14.6,2H |)/12X,4HIM |,7(1P,D14.6,2H |)/11X,3HP-NLEC2-501
     3,7(2H |,2I6,2X),2H |/12X,4HRE |,7(1P,D14.6,2H |)/12X,4HIM |,7(1P,DLEC2-502
     414.6,2H |)/11X,3HP-N,7(2H |,2I6,2X),2H |/12X,4HRE |,7(1P,D14.6,2H LEC2-503
     5|)/12X,4HIM |,7(1P,D14.6,2H |))                                   LEC2-504
 1026 FORMAT (/5X,4HKTF(,I1,3H,1,,I2,3H) =,I4,39H  ILLEGAL (POSSIBLE VALLEC2-505
     1UES FROM 0 TO 5))                                                 LEC2-506
 1027 FORMAT (/5X,4HKTF(,I1,3H,2,,I2,3H) =,I2,9H AND KTF(,I1,3H,1,,I2,3HLEC2-507
     1) =,I2,15H  MUST BE EQUAL)                                        LEC2-508
 1028 FORMAT (15H THE ZERO RANGE,I2,5X,17HMUST BE READ LAST,I2)         LEC2-509
 1029 FORMAT (/5X,4HKTF(,I1,1H,,I1,1H,,I2,41H) DOES NOT EXIST (POSSIBLE LEC2-510
     1VALUES OF I7 =,I2,25H FROM 1 TO 14 AND OF I3 =,I2,10H FROM 1 TO,I2LEC2-511
     2,1H))                                                             LEC2-512
 1030 FORMAT (/5X,4HKTF(,I1,1H,,I1,1H,,I2,20H) READ BEFORE ( I7 =,I3,2H LEC2-513
     1))                                                                LEC2-514
 1031 FORMAT (/5X,4HKTF(,I1,1H,,I1,1H,,I2,3H) =,I4,19H  IS DIFFERENT FROLEC2-515
     1M,I3,8H  ( I7 =,I3,2H ))                                          LEC2-516
 1032 FORMAT (/5X,I5,38H INSUFFICIENT POINTS FOR INTERPOLATION)         LEC2-517
 1033 FORMAT (/5X,37HDIFFERENT DENSITY DEPENDANCE FOR KTF(,I1,3H,1,,I2,1LEC2-518
     10H) AND KTF(,I1,3H,2,,I2,3H) :,I3,4H AND,I3,9H GIVEN BY,I3)       LEC2-519
 1034 FORMAT (/5X,54HNON DECREASING DENSITY GIVEN FOR INTERPOLATION OF KLEC2-520
     1TF(,I1,1H,,I1,1H,,I2,1H)/(5X,6D15.8))                             LEC2-521
 1035 FORMAT (/5X,52HNON INCREASING RADII GIVEN FOR INTERPOLATION OF KTFLEC2-522
     1(,I1,1H,,I1,1H,,I2,1H)/(5X,6D15.8))                               LEC2-523
 1036 FORMAT (42H FORM FACTOR NECESSARY IN THIS COMPUTATION)            LEC2-524
 1037 FORMAT (25H ***** STOP IN LEC2 *****)                             LEC2-525
      END                                                               LEC2-526
