C 20/03/97                                                      DWBA98  YFCL-000
      SUBROUTINE YFCL(ETA,RO,U,UP,V,VP,SIGMA,IDIV,NN)                   YFCL-001
      IMPLICIT REAL*8 (A-H,O-Z)                                         YFCL-002
      IDIV=0                                                            YFCL-003
      ETAP=ETA+ETA                                                      YFCL-004
      RO2=RO*RO                                                         YFCL-005
      IF (NN.EQ.1) GO TO 4                                              YFCL-006
C          ASYMPTOTIC CLENSHAW                                          YFCL-007
      E2=ETA*ETA                                                        YFCL-008
      M=40.D0+ETA/4.D0                                                  YFCL-009
      M=2*(M/2)                                                         YFCL-010
      I=1                                                               YFCL-011
      R=M                                                               YFCL-012
      D4=4.D0*R                                                         YFCL-013
      TM1=1.D0                                                          YFCL-014
      T=4.D0*ETA/RO-1.D0                                                YFCL-015
      Z=T+T                                                             YFCL-016
      DO 1 J=1,M                                                        YFCL-017
      TP1=Z*T-TM1                                                       YFCL-018
      TM1=T                                                             YFCL-019
    1 T=TP1                                                             YFCL-020
      T=TM1                                                             YFCL-021
      GR=0.D0                                                           YFCL-022
      GPR=0.D0                                                          YFCL-023
      SCR=0.D0                                                          YFCL-024
      EP1R=0.D0                                                         YFCL-025
      ER=0.D0                                                           YFCL-026
      DP1R=0.D0                                                         YFCL-027
      DR=1.D-25                                                         YFCL-028
      C1R=R+1.D0                                                        YFCL-029
      C0R=E2-R*(R+1.D0)                                                 YFCL-030
      GI=0.D0                                                           YFCL-031
      GPI=0.D0                                                          YFCL-032
      SCI=0.D0                                                          YFCL-033
      EP1I=0.D0                                                         YFCL-034
      EI=0.D0                                                           YFCL-035
      DP1I=0.D0                                                         YFCL-036
      DI=0.D0                                                           YFCL-037
      C1I=-3.D0*ETA                                                     YFCL-038
      C0I=-(R+R+1.D0)*ETA                                               YFCL-039
C          DOWNWARDS RECURRENCE                                         YFCL-040
    2 SCZ=C0R*C0R+C0I*C0I                                               YFCL-041
      C2R=C1R*DR-C1I*DI+0.5D0*(DP1R+ER+EP1R)-ETA*DP1I                   YFCL-042
      C2I=C1R*DI+C1I*DR+0.5D0*(DP1I+EI+EP1I)+ETA*DP1R                   YFCL-043
      CR=(C2R*C0R+C2I*C0I)/SCZ                                          YFCL-044
      CI=(C0R*C2I-C0I*C2R)/SCZ                                          YFCL-045
      GR=GR+CR*T                                                        YFCL-046
      GPR=GPR+DR*T                                                      YFCL-047
      SCR=SCR+I*CR                                                      YFCL-048
      GI=GI+CI*T                                                        YFCL-049
      GPI=GPI+DI*T                                                      YFCL-050
      SCI=SCI+I*CI                                                      YFCL-051
      IF (R.EQ.0.D0) GO TO 3                                            YFCL-052
      EM1R=D4*DR+EP1R                                                   YFCL-053
      DM1R=D4*CR+DP1R                                                   YFCL-054
      EP1R=ER                                                           YFCL-055
      ER=EM1R                                                           YFCL-056
      DP1R=DR                                                           YFCL-057
      DR=DM1R                                                           YFCL-058
      EM1I=D4*DI+EP1I                                                   YFCL-059
      DM1I=D4*CI+DP1I                                                   YFCL-060
      EP1I=EI                                                           YFCL-061
      EI=EM1I                                                           YFCL-062
      DP1I=DI                                                           YFCL-063
      DI=DM1I                                                           YFCL-064
      TM1=Z*T-TP1                                                       YFCL-065
      TP1=T                                                             YFCL-066
      T=TM1                                                             YFCL-067
      C0R=C0R+R+R                                                       YFCL-068
      C0I=C0I+ETAP                                                      YFCL-069
      C1R=C1R-1.D0                                                      YFCL-070
      I=-I                                                              YFCL-071
      D4=D4-4.D0                                                        YFCL-072
      R=R-1.D0                                                          YFCL-073
      GO TO 2                                                           YFCL-074
    3 SCR=SCR-0.5D0*CR                                                  YFCL-075
      GR=GR-0.5D0*CR                                                    YFCL-076
      GPR=GPR-0.5D0*DR                                                  YFCL-077
      SCI=SCI-0.5D0*CI                                                  YFCL-078
      GI=GI-0.5D0*CI                                                    YFCL-079
      GPI=GPI-0.5D0*DI                                                  YFCL-080
      Z=SIGMA+RO-ETA*DLOG(RO+RO)                                        YFCL-081
      SCZ=SCR*SCR+SCI*SCI                                               YFCL-082
      CR=DCOS(Z)                                                        YFCL-083
      CI=DSIN(Z)                                                        YFCL-084
      DR=(CR*SCR+CI*SCI)/SCZ                                            YFCL-085
      DI=(CI*SCR-CR*SCI)/SCZ                                            YFCL-086
      SCI=1.D0-ETA/RO                                                   YFCL-087
      SCR=ETAP/RO2                                                      YFCL-088
      CR=-GI*SCI-GPR*SCR                                                YFCL-089
      CI=GR*SCI-GPI*SCR                                                 YFCL-090
      VP=DR*CR-DI*CI                                                    YFCL-091
      UP=DR*CI+DI*CR                                                    YFCL-092
      V=DR*GR-DI*GI                                                     YFCL-093
      U=DR*GI+DI*GR                                                     YFCL-094
      RETURN                                                            YFCL-095
C          SERIES ORIGIN                                                YFCL-096
    4 PI=3.141592653589793D0                                            YFCL-097
      PIETA=PI*ETA                                                      YFCL-098
      IF (DABS(PIETA).GT.36.D0) GO TO 5                                 YFCL-099
      P=DSQRT((DEXP(2.D0*PIETA)-1.D0)/(2.D0*PIETA))                     YFCL-100
      GO TO 7                                                           YFCL-101
    5 IF (PIETA.GT.0.D0) GO TO 6                                        YFCL-102
      P=1.D0/DSQRT(-PIETA-PIETA)                                        YFCL-103
      GO TO 7                                                           YFCL-104
    6 Z=34.588776394910686D0                                            YFCL-105
      IDIV=PIETA/Z                                                      YFCL-106
      P=DEXP(PIETA-IDIV*Z)/DSQRT(PIETA+PIETA)                           YFCL-107
      IDIV=15*IDIV                                                      YFCL-108
    7 Z1=ETAP*(PSI(ETA)+.6931471805599453D0)                            YFCL-109
      U0=0.D0                                                           YFCL-110
      U1=RO                                                             YFCL-111
      V0=1.D0                                                           YFCL-112
      V1=Z1*RO                                                          YFCL-113
      U=U0+U1                                                           YFCL-114
      V=V0+V1                                                           YFCL-115
      UP=1.D0                                                           YFCL-116
      VP=Z1                                                             YFCL-117
      XN=2.D0                                                           YFCL-118
      DO 9 N=2,10000                                                    YFCL-119
      XN1=XN*(XN-1.D0)                                                  YFCL-120
      U2=(ETAP*RO*U1-RO2*U0)/XN1                                        YFCL-121
      U=U+U2                                                            YFCL-122
      V2=(ETAP*RO*V1-RO2*V0-ETAP*(XN+XN-1.D0)*U2)/XN1                   YFCL-123
      V=V+V2                                                            YFCL-124
      UP=UP+XN*U2/RO                                                    YFCL-125
      VP=VP+XN*V2/RO                                                    YFCL-126
      IF (DABS(U2).GT.1.D-14*DABS(U)) GO TO 8                           YFCL-127
      IF (DABS(V2).LE.1.D-14*DABS(V)) GO TO 10                          YFCL-128
    8 U0=U1                                                             YFCL-129
      U1=U2                                                             YFCL-130
      V0=V1                                                             YFCL-131
      V1=V2                                                             YFCL-132
    9 XN=XN+1.D0                                                        YFCL-133
   10 PP=V+ETAP*U*DLOG(RO)                                              YFCL-134
      W=U/P                                                             YFCL-135
      WP=UP/P                                                           YFCL-136
      V=P*PP                                                            YFCL-137
      VP=P*(VP+ETAP*(UP*DLOG(RO)+U/RO))                                 YFCL-138
      U=W                                                               YFCL-139
      UP=WP                                                             YFCL-140
      RETURN                                                            YFCL-141
      END                                                               YFCL-142
