C 29/03/98                                                      DWBA98  YFIR-000
      SUBROUTINE YFIR(ETA,RO,G0,GP0,SIGMA)                              YFIR-001
C IRREGULAR COULOMB FUNCTION                                            YFIR-002
      IMPLICIT REAL*8(A-H,O-Z)                                          YFIR-003
      IF (ETA.LE.0.D0) GO TO 9                                          YFIR-004
      IF ((RO.LE.(54.D0-ETA)/80.D0).OR.(ETA.LE.22.D0.AND.RO.LE.(30.D0-ETYFIR-005
     1A)/20.D0).OR.(ETA.LE.18.D0.AND.RO.LE.0.075D0*(26.D0-ETA)).OR.(ETA.YFIR-006
     2LE.10.D0.AND.RO.LE..15D0*(18.D0-ETA)).OR.(ETA.LE.3.D0.AND.RO.LE.2.YFIR-007
     325D0+7.35D0*(3.D0-ETA))) GO TO 5                                  YFIR-008
C   TAYLOR SERIES STARTING AT RAU0                                      YFIR-009
    1 RAU0=1.666666666666667D0*DABS(ETA)+7.5D0                          YFIR-010
      CALL YFAS(ETA,RAU0,F0,FP0,G0,GP0,SIGMA)                           YFIR-011
      X=RAU0-RO                                                         YFIR-012
      X2=X*X                                                            YFIR-013
      X3=X*X2                                                           YFIR-014
      UNR=1.D0/RAU0                                                     YFIR-015
      ETR0=1.D0-2.D0*ETA*UNR                                            YFIR-016
      U0=G0                                                             YFIR-017
      U1=-X*GP0                                                         YFIR-018
      U2=-0.5D0*ETR0*X2*U0                                              YFIR-019
      S=U0+U1+U2                                                        YFIR-020
      V1=U1/X                                                           YFIR-021
      V2=2.D0*U2/X                                                      YFIR-022
      T=V1+V2                                                           YFIR-023
      XN=3.D0                                                           YFIR-024
      DO 3 N=3,10000                                                    YFIR-025
      XN1=XN-1.D0                                                       YFIR-026
      XN1=XN*XN1                                                        YFIR-027
      U3=X*U2*UNR*(1.D0-2.D0/XN)-ETR0*U1*X2/XN1+X3*U0*UNR/XN1           YFIR-028
      S=S+U3                                                            YFIR-029
      V3=XN*U3/X                                                        YFIR-030
      T=T+V3                                                            YFIR-031
      IF (DABS(U3).GT.1.D-11*DABS(S)) GO TO 2                           YFIR-032
      IF (DABS(V3).LE.1.D-11*DABS(T)) GO TO 4                           YFIR-033
    2 U0=U1                                                             YFIR-034
      U1=U2                                                             YFIR-035
      U2=U3                                                             YFIR-036
    3 XN=XN+1.D0                                                        YFIR-037
    4 G0=S                                                              YFIR-038
      GP0=-T                                                            YFIR-039
      RETURN                                                            YFIR-040
C   SERIES ORIGIN                                                       YFIR-041
    5 PI=3.141592653589793D0                                            YFIR-042
      RO2=RO*RO                                                         YFIR-043
      ETAP=ETA+ETA                                                      YFIR-044
      PIETA=PI*ETA                                                      YFIR-045
      PIETA2=0.5D0*PIETA                                                YFIR-046
      B=DEXP(PIETA)                                                     YFIR-047
      B=DEXP(PIETA2)*DSQRT((B-1.D0/B)/(2.D0*PIETA))                     YFIR-048
      C1=ETAP*(PSI(ETA)+.6931471805599453D0)                            YFIR-049
      U0=0.D0                                                           YFIR-050
      U1=RO                                                             YFIR-051
      V0=1.D0                                                           YFIR-052
      V1=C1*RO                                                          YFIR-053
      U=U0+U1                                                           YFIR-054
      V=V0+V1                                                           YFIR-055
      UP=1.D0                                                           YFIR-056
      VP=C1                                                             YFIR-057
      XN=2.D0                                                           YFIR-058
      DO 7 N=2,10000                                                    YFIR-059
      XN1=XN*(XN-1.D0)                                                  YFIR-060
      U2=(ETAP*RO*U1-RO2*U0)/XN1                                        YFIR-061
      U=U+U2                                                            YFIR-062
      V2=(ETAP*RO*V1-RO2*V0-ETAP*(XN+XN-1.D0)*U2)/XN1                   YFIR-063
      V=V+V2                                                            YFIR-064
      UP=UP+XN*U2/RO                                                    YFIR-065
      VP=VP+XN*V2/RO                                                    YFIR-066
      IF (DABS(U2).GT.1.D-14*DABS(U)) GO TO 6                           YFIR-067
      IF (DABS(V2).LE.1.D-14*DABS(V)) GO TO 8                           YFIR-068
    6 U0=U1                                                             YFIR-069
      U1=U2                                                             YFIR-070
      V0=V1                                                             YFIR-071
      V1=V2                                                             YFIR-072
    7 XN=XN+1.D0                                                        YFIR-073
    8 GP=V+ETAP*U*DLOG(RO)                                              YFIR-074
      G0=B*GP                                                           YFIR-075
      GP0=B*(VP+ETAP*(UP*DLOG(RO)+U/RO))                                YFIR-076
      RETURN                                                            YFIR-077
    9 IF (RO.LE.0.5D0*ETA+9.D0) GO TO 5                                 YFIR-078
      GO TO 1                                                           YFIR-079
      END                                                               YFIR-080
