C 29/03/98                                                      DWBA98  XYIS-000
      SUBROUTINE XYIS(NQUA,VBCS,NCHE,X,NBCONF,MPAR,ID)                  XYIS-001
C CHANGING CONVENTIONS.                                                 XYIS-002
C INPUTS:                                                               XYIS-003
C  NQUA(I,J),VBCS(I,J) SINGLE PARTICLE STATES.                          XYIS-004
C             N ,ANGULAR MOMENTUM, 2*(J-L) FOR NQUA.                    XYIS-005
C             U AND V OF BCS FOR VBCS.                                  XYIS-006
C  NCHE(I,J),X(I,J)  DESCRIPTION OF CONFIGURATIONS:                     XYIS-007
C             ADDRESSES OF PARTICLE AND HOLE FOR NCHE;                  XYIS-008
C             VALUES OF X AND Y FOR X.                                  XYIS-009
C  NBCONF     NUMBER OF CONFIGURATIONS.                                 XYIS-010
C  MPAR       1/-1 FOR A NATURAL/UNNATURAL PARITY STATE.                XYIS-011
C  ID         TRANSFORMATION REQUIRED:                                  XYIS-012
C  ID=1   THE NUMBER OF CONFIGURATIONS IS EVEN: THE FIRST HALF ARE T=1, XYIS-013
C         THE SECOND T=0 . CHANGE TO PROTONS AND NEUTRONS.              XYIS-014
C  ID=2   PHASE '1' OF GILLET. MULTIPLICATION BY (-)**(JP+1/2).         XYIS-015
C  ID=3   PHASE '2' OF GILLET.MULTIPLICATION BY (-)**INT((LP-LT)/2).    XYIS-016
C  ID=4   FUNDAMENTAL BCS. CALCULATE X AND Y AS FUNCTIONS OF U AND V.   XYIS-017
C                                                                       XYIS-018
C  THE CONVENTION ADOPTED IS:                                           XYIS-019
C         (+)   K,Q           JH-MH                    (+)              XYIS-020
C      ( A     )     = SUM (-)     (JP JH MP -MH|K Q) A      A          XYIS-021
C         JP JH                                          JP MP  JH MH   XYIS-022
C                                                                       XYIS-023
C***********************************************************************XYIS-024
      IMPLICIT REAL*8 (A-H,O-Z)                                         XYIS-025
      DIMENSION NQUA(3,1),VBCS(2,1),NCHE(2,1),X(2,1)                    XYIS-026
      GO TO ( 1 , 3 , 4 , 8 ) , ID                                      XYIS-027
    1 WRITE (6,1000)                                                    XYIS-028
      NBT=NBCONF/2                                                      XYIS-029
      DO 2 K=1,NBT                                                      XYIS-030
      KN=K+NBT                                                          XYIS-031
      UPX=(X(1,K)+X(1,KN))/1.414213562D0                                XYIS-032
      UPY=(X(2,K)+X(2,KN))/1.414213562D0                                XYIS-033
      UNX=-(X(1,K)-X(1,KN))/1.414213562D0                               XYIS-034
      UNY=-(X(2,K)-X(2,KN))/1.414213562D0                               XYIS-035
      X(1,K)=UPX                                                        XYIS-036
      X(2,K)=UPY                                                        XYIS-037
      X(1,KN)=UNX                                                       XYIS-038
    2 X(2,KN)=UNY                                                       XYIS-039
      RETURN                                                            XYIS-040
    3 WRITE (6,1001)                                                    XYIS-041
      GO TO 5                                                           XYIS-042
    4 WRITE (6,1002)                                                    XYIS-043
      RJ=MPAR                                                           XYIS-044
    5 DO 7 K=1,NBCONF                                                   XYIS-045
      NPAR=NCHE(1,K)                                                    XYIS-046
      NTRO=NCHE(2,K)                                                    XYIS-047
      JP=(2*NQUA(2,NPAR)+NQUA(3,NPAR)+1)/2                              XYIS-048
      JT=(2*NQUA(2,NTRO)+NQUA(3,NTRO)+1)/2                              XYIS-049
      SP=1-2*MOD(JP,2)                                                  XYIS-050
      ST=1-2*MOD(JT,2)                                                  XYIS-051
      IF (ID.EQ.3) GO TO 6                                              XYIS-052
      X(1,K)=X(1,K)*ST                                                  XYIS-053
      X(2,K)=X(2,K)*SP                                                  XYIS-054
      GO TO 7                                                           XYIS-055
    6 X(2,K)=X(2,K)*ST*SP*RJ                                            XYIS-056
      LLL=(NQUA(2,NPAR)-NQUA(2,NTRO)+40)/2                              XYIS-057
      PLL=1-2*MOD(LLL,2)                                                XYIS-058
      X(1,K)=PLL*X(1,K)                                                 XYIS-059
      X(2,K)=X(2,K)*PLL                                                 XYIS-060
    7 CONTINUE                                                          XYIS-061
      RETURN                                                            XYIS-062
    8 WRITE (6,1003)                                                    XYIS-063
      DO 9 K=1,NBCONF                                                   XYIS-064
      NPAR=NCHE(1,K)                                                    XYIS-065
      NTRO=NCHE(2,K)                                                    XYIS-066
      UX=VBCS(2,NPAR)*VBCS(1,NTRO)                                      XYIS-067
      UY=VBCS(2,NTRO)*VBCS(1,NPAR)                                      XYIS-068
      XA=X(1,K)*UX+X(2,K)*UY                                            XYIS-069
      X(2,K)=X(1,K)*UY+X(2,K)*UX                                        XYIS-070
      X(1,K)=XA                                                         XYIS-071
      IF (NPAR.NE.NTRO) GO TO 9                                         XYIS-072
      X(1,K)=1.414213562D0*X(1,K)                                       XYIS-073
      X(2,K)=0.D0                                                       XYIS-074
    9 CONTINUE                                                          XYIS-075
      RETURN                                                            XYIS-076
 1000 FORMAT (29H NUCLEUS DESCRIBED BY ISOSPIN)                         XYIS-077
 1001 FORMAT (18H PHASE 1 OF GILLET)                                    XYIS-078
 1002 FORMAT (18H PHASE 2 OF GILLET)                                    XYIS-079
 1003 FORMAT (11H SIMPLE BCS)                                           XYIS-080
      END                                                               XYIS-081
