C 29/03/98                                                      DWBA98  PTCI-000
      SUBROUTINE PTCI(KTF,KS,H,S0,S1,S2)                                PTCI-001
C CONSTANTS FOR (L.S1)(L.S2) AND L**2(S1.S2) FOR NON NATURAL PARITY.    PTCI-002
C INPUT:  KTF   USED TO SEE IF SUCH INTERACTIONS ARE USED.              PTCI-003
C         KS    NUMBER OF RANGES.                                       PTCI-004
C         H     STEP SIZE.                                              PTCI-005
C DATA PASSED OVER BY THE COMMON /GABJ/:  ( SEE MULT )                  PTCI-006
C  AJ,BJ,CJ,DJ  SPIN TRANSFER J, J*(J+1), 2*J+1, 1./(J*(J+1)).          PTCI-007
C  XG           VARIOUS DEPENDENCES ON QUANTUM NUMBERS                  PTCI-008
C OUTPUT: S0    NON DERIVATIVE TERMS IN THE ORDER C6,C9,C7,C8 AND C5    PTCI-009
C         S1    FIRST DERIVATIVE TERMS IN THE ORDER D2,C3,D4,C4,C2,D3   PTCI-010
C         S2    SECOND DERIVATIVE TERMS  C1 ( SEE NOTES )               PTCI-011
C***********************************************************************PTCI-012
      IMPLICIT REAL*8 (A-H,O-Z)                                         PTCI-013
      DIMENSION KTF(7,7,1),S0(2,11,18),S1(2,6,19),S2(2,2,4)             PTCI-014
      COMMON /GABJ/ AA,AB,AJ,BJ,CJ,DJ,XG(11),JX                         PTCI-015
      DO 2 K=1,KS                                                       PTCI-016
      DO 1 I=5,7                                                        PTCI-017
      IF (KTF(I,1,K).NE.0) GO TO 3                                      PTCI-018
    1 CONTINUE                                                          PTCI-019
    2 CONTINUE                                                          PTCI-020
      RETURN                                                            PTCI-021
    3 DO 10 L=1,2                                                       PTCI-022
      DO 5 K=1,18                                                       PTCI-023
      DO 4 I=1,11                                                       PTCI-024
    4 S0(L,I,K)=0.D0                                                    PTCI-025
    5 CONTINUE                                                          PTCI-026
      DO 7 K=1,11                                                       PTCI-027
      DO 6 I=1,6                                                        PTCI-028
    6 S1(L,I,K)=0.D0                                                    PTCI-029
    7 CONTINUE                                                          PTCI-030
      DO 9 K=1,4                                                        PTCI-031
      DO 8 I=1,2                                                        PTCI-032
    8 S2(L,I,K)=0.D0                                                    PTCI-033
    9 CONTINUE                                                          PTCI-034
   10 CONTINUE                                                          PTCI-035
C FOR J=0 ONLY 1-2-5-6-7-10                                             PTCI-036
      S0(1,1,3)=-.0625D0*((AJ+1.D0)*(4.D0*AJ+4.D0-(AJ+2.D0)*XG(1))-3.D0*PTCI-037
     1XG(2)+XG(7))                                                      PTCI-038
      S0(1,1,6)=-CJ*(BJ*(2.D0*BJ-1.D0)+(BJ-1.D0)*XG(1)-2.D0*BJ*XG(2)-(BJPTCI-039
     1-3.D0)*XG(4)-(2.D0*BJ-3.D0)*XG(6)+XG(7)+3.D0*XG(5)+2.D0*XG(9))/((2PTCI-040
     2.D0*AJ+3.D0)*(32.D0*AJ-16.D0))                                    PTCI-041
      S0(1,1,7)=((AJ+2.D0)*((AJ+1.D0)**2*(AJ+3.D0-XG(1))-(AJ+3.D0)*(XG(2PTCI-042
     1)+AJ*XG(4))-AJ*XG(6)+XG(7))+(AJ+3.D0)*XG(5)+XG(9))/(32.D0*AJ+48.D0PTCI-043
     2)                                                                 PTCI-044
      S0(1,1,14)=(AJ+3.D0)*((AJ+2.D0)*((AJ+1.D0)*(AJ+1.D0-XG(1))+AJ*XG(4PTCI-045
     1))-XG(5))/(32.D0*AJ+48.D0)                                        PTCI-046
      S0(2,1,3)=-.0625D0*(((AJ+1.D0)*(14.D0*BJ**2+40.D0*AJ*BJ+78.D0*BJ+1PTCI-047
     12.D0*AJ-84.D0)-(10.D0*BJ**2+22.D0*AJ*BJ+52.D0*BJ+22.D0*AJ-74.D0)*XPTCI-048
     2G(1)+(6.D0*AJ*BJ+16.D0*BJ-6.D0*AJ-18.D0)*(XG(3)-XG(4))-(2.D0*AJ**2PTCI-049
     3-14.D0)*XG(5))/((2.D0*AJ-1.D0)*(2.D0*AJ+5.D0))-(AJ+3.D0)*XG(2)-(AJPTCI-050
     4+1.D0)*XG(6)+XG(7)+XG(8))                                         PTCI-051
      S0(2,7,3)=.0625D0*(AJ+1.D0-XG(1))                                 PTCI-052
      S0(2,1,4)=-(AJ+3.D0)**2*((AJ+2.D0)*((AJ+3.D0)*(AJ+1.D0-XG(1))+XG(3PTCI-053
     1)-XG(4))-XG(5))/((2.D0*AJ+5.D0)*(16.D0*AJ+24.D0))                 PTCI-054
      S0(2,1,6)=CJ*(2.D0*BJ*(BJ-1.D0)+(3.D0*BJ-2.D0)*XG(1)-(2.D0*BJ-3.D0PTCI-055
     1)*(XG(3)+XG(2)-XG(4))-(2.D0*BJ-1.D0)*XG(6)-3.D0*XG(5)-XG(7)-XG(8))PTCI-056
     2/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0))                                 PTCI-057
      S0(2,1,10)=-((AJ+3.D0)*((AJ**2-4.D0)*BJ-(6.D0*BJ+2.D0*AJ-10.D0)*(XPTCI-058
     1G(3)-XG(4))+(2.D0*AJ-10.D0)*XG(5))-(3.D0*BJ**2+4.D0*AJ*BJ+6.D0*AJ+PTCI-059
     212.D0)*XG(1)-(4.D0*AJ*BJ+17.D0*BJ+3.D0*AJ-18.D0)*XG(2)-(4.D0*AJ*BJPTCI-060
     3+9.D0*BJ-5.D0*AJ-8.D0)*XG(6)+(4.D0*BJ+3.D0*AJ-6.D0)*XG(7)+(4.D0*BJPTCI-061
     4+AJ-8.D0)*XG(8)+(AJ+4.D0)*XG(9)-3.D0*XG(10))/((2.D0*AJ+5.D0)*(32.DPTCI-062
     50*AJ-16.D0))                                                      PTCI-063
      S0(2,1,11)=((AJ+2.D0)*((AJ+3.D0)*((AJ+5.D0)*((AJ+1.D0)*(AJ+4.D0)+2PTCI-064
     1.D0*XG(3)-2.D0*XG(4))+XG(2)+XG(6))-(((AJ+12.D0)*AJ+49.D0)*AJ+62.D0PTCI-065
     2)*XG(1)-XG(7)-3.D0*XG(8))+(AJ+3.D0)*(XG(9)-(2.D0*AJ+10.D0)*XG(5))-PTCI-066
     3XG(10))/((32.D0*AJ+48.D0)*(2.D0*AJ+5.D0))                         PTCI-067
      S0(2,1,18)=(AJ+2.D0)*(AJ+3.D0)*(AJ+4.D0)*(AJ+5.D0)*(AJ+1.D0-XG(1))PTCI-068
     1/((2.D0*AJ+5.D0)*(32.D0*AJ+48.D0))                                PTCI-069
      S2(2,1,3)=((3.D0*BJ+4.D0*AJ-2.D0)*XG(1)-(AJ+1.D0)*(BJ+AJ-2.D0))/((PTCI-070
     12.D0*AJ+5.D0)*(8.D0*AJ-4.D0))/H**2                                PTCI-071
      S2(2,1,4)=(AJ+2.D0)*(AJ+3.D0)*(AJ+1.D0-XG(1))/((8.D0*AJ+12.D0)*(2.PTCI-072
     1D0*AJ+5.D0))/H**2                                                 PTCI-073
      IF (JX.NE.0) GO TO 11                                             PTCI-074
      S0(1,5,3)=.0625D0*XG(4)                                           PTCI-075
      S0(1,5,6)=-XG(4)/48.D0                                            PTCI-076
      S0(1,5,7)=(6.D0-XG(4))/96.D0                                      PTCI-077
      S0(1,5,13)=-XG(4)/48.D0                                           PTCI-078
      S0(1,7,13)=1.D0/48.D0                                             PTCI-079
      S0(1,5,14)=-(6.D0+XG(4))/96.D0                                    PTCI-080
      S0(1,7,14)=-1.D0/48.D0                                            PTCI-081
      S1(1,1,11)=-XG(4)/24.D0/H                                         PTCI-082
      S1(1,5,11)=1.D0/24.D0/H                                           PTCI-083
      S0(2,5,3)=.0125D0*(4.D0-9.D0*XG(4))                               PTCI-084
      S0(2,5,4)=-S0(2,1,4)/6.D0                                         PTCI-085
      S0(2,5,6)=XG(4)/24.D0                                             PTCI-086
      S0(2,1,7)=(6.D0+3.D0*XG(4)-2.D0*XG(6))/24.D0                      PTCI-087
      S0(2,5,7)=-(6.D0-XG(4))/48.D0                                     PTCI-088
      S0(2,5,13)=XG(4)/24.D0                                            PTCI-089
      S0(2,7,13)=-1.D0/24.D0                                            PTCI-090
      S0(2,1,14)=.125D0*(2.D0-XG(4))                                    PTCI-091
      S0(2,5,14)=(6.D0+XG(4))/48.D0                                     PTCI-092
      S0(2,7,14)=-1.D0/12.D0                                            PTCI-093
      S0(2,7,17)=.05D0                                                  PTCI-094
      S0(2,5,18)=-.25D0*S0(2,1,18)                                      PTCI-095
      S0(2,7,18)=-.1D0*S0(2,5,18)                                       PTCI-096
      S1(2,1,11)=XG(4)/12.D0/H                                          PTCI-097
      S1(2,5,11)=-1.D0/12.D0/H                                          PTCI-098
      S1(2,1,3)=.2D0/H                                                  PTCI-099
      S1(2,5,3)=.05D0/H                                                 PTCI-100
      S1(2,1,4)=.3D0/H                                                  PTCI-101
      S1(2,5,4)=-.05D0/H                                                PTCI-102
      S1(2,1,7)=-.05D0*(XG(4)+2.D0)/H                                   PTCI-103
      S1(2,1,8)=-.05D0*(8.D0-XG(4))/H                                   PTCI-104
      GO TO 12                                                          PTCI-105
C FOR J=1 ONLY 1-2-3-4-5-7-8-9                                          PTCI-106
   11 S0(1,1,2)=.0625D0*(AJ*(4.D0*AJ-(AJ-1.D0)*XG(1))-3.D0*XG(2)+XG(7)) PTCI-107
      S0(1,2,2)=-.0625D0*(AJ*(AJ-1.D0+2.D0*XG(1)-XG(4))+((AJ+1.D0)*(3.D0PTCI-108
     1*XG(2)-XG(7))+AJ*(2.D0*XG(1)+XG(3)+XG(4)+XG(5)))*DJ)              PTCI-109
      S0(1,4,2)=.0625D0*(XG(4)-(AJ*XG(1)-2.D0*XG(3)+XG(4)+XG(5))*DJ)    PTCI-110
      S0(1,5,2)=.0625D0*(AJ*XG(1)+XG(3)-2.D0*XG(4)-(XG(3)-(2.D0*AJ+4.D0)PTCI-111
     1*(XG(4)+XG(5))+AJ*XG(1))*DJ)                                      PTCI-112
      S0(1,8,2)=.0625D0*(AJ+XG(1))/AJ                                   PTCI-113
      S0(1,3,2)=-3.D0*S0(1,8,2)                                         PTCI-114
      S0(1,2,3)=.0625D0*((AJ+1.D0)*(AJ+2.D0-2.D0*XG(1)+XG(4))-((AJ+1.D0)PTCI-115
     1*(2.D0*XG(1)+XG(3)+XG(4)+XG(5))+AJ*(3.D0*XG(2)-XG(7)))*DJ)        PTCI-116
      S0(1,4,3)=-.0625D0*(XG(4)+((AJ+1.D0)*XG(1)+2.D0*XG(3)-XG(4)-XG(5))PTCI-117
     1*DJ)                                                              PTCI-118
      S0(1,5,3)=.0625D0*((AJ+1.D0)*XG(1)-XG(3)+2.D0*XG(4)-((AJ+1.D0)*XG(PTCI-119
     11)-XG(3)-(2.D0*AJ-2.D0)*(XG(4)+XG(5)))*DJ)                        PTCI-120
      S0(1,8,3)=-.0625D0*(AJ+1.D0-XG(1))/(AJ+1.D0)                      PTCI-121
      S0(1,3,3)=-3.D0*S0(1,8,3)                                         PTCI-122
      S0(1,2,6)=-CJ*(13.D0*BJ-9.D0-(6.D0*BJ-16.D0)*XG(1)-19.D0*XG(2)-2.DPTCI-123
     10*(BJ-1.D0)*XG(4)+2.D0*XG(5)-XG(6)+6.D0*XG(7)-3.D0*(3.D0*XG(1)-4.DPTCI-124
     20*XG(2)-XG(4)-XG(5)-XG(6)+XG(7)-XG(9))*DJ)/((2.D0*AJ+3.D0)*(32.D0*PTCI-125
     3AJ-16.D0))                                                        PTCI-126
      S0(1,5,6)=-CJ*(BJ-3.D0+2.D0*(BJ-1.D0)*XG(1)-XG(3)+5.D0*XG(4)+2.D0*PTCI-127
     1XG(5)-3.D0*(XG(1)-XG(3)+2.D0*XG(4)+2.D0*XG(5))*DJ)/((2.D0*AJ+3.D0)PTCI-128
     2*(32.D0*AJ-16.D0))                                                PTCI-129
      S0(1,2,7)=-S0(1,1,7)/(AJ+1.D0)                                    PTCI-130
      S0(1,5,7)=AJ*((AJ+2.D0)*((AJ+3.D0)*(AJ+1.D0-XG(1))+XG(3)-XG(4))-XGPTCI-131
     1(5))/((AJ+1.D0)*(32.D0*AJ+48.D0))                                 PTCI-132
      S0(1,2,9)=-.0625D0*((AJ-1.D0)*(AJ-2.D0+XG(1))+(AJ-2.D0)*XG(4)-XG(6PTCI-133
     1)-((AJ-2.D0)*(XG(3)+XG(4)+XG(5)-(AJ-1.D0)*XG(1))+((AJ-2.D0)*AJ-1.DPTCI-134
     20)*XG(2)+AJ*XG(7)-XG(6)-XG(9))*DJ)                                PTCI-135
      S0(1,2,10)=.0625D0*((AJ+3.D0)*(AJ+2.D0-XG(4))-XG(6)+(XG(6)+XG(9)-(PTCI-136
     1AJ+2.D0)*(AJ**2-3.D0)*XG(1)-((AJ+4.D0)*AJ+2.D0)*XG(2)+(AJ+3.D0)*(XPTCI-137
     2G(3)+XG(4)+XG(5))+(AJ+1.D0)*XG(7))*DJ)                            PTCI-138
      S0(1,1,12)=(AJ-2.D0)*((AJ-1.D0)*(AJ*(AJ+XG(1))-(AJ+1.D0)*XG(4))+XGPTCI-139
     1(5))/(32.D0*AJ-16.D0)                                             PTCI-140
      S0(1,2,12)=(AJ*((AJ-1.D0)*(AJ+XG(1))-(AJ-2.D0)*XG(4))+(AJ-2.D0)*(XPTCI-141
     1G(4)+XG(5))/AJ)/(32.D0*AJ-16.D0)                                  PTCI-142
      S0(1,4,12)=-(AJ**2*XG(4)-(XG(4)+XG(5)))/(AJ*(32.D0*AJ-16.D0))     PTCI-143
      S0(1,1,13)=-CJ*(BJ*(2.D0*BJ-1.D0+13.D0*XG(1)+XG(4))-3.D0*(XG(4)+XGPTCI-144
     1(5)+3.D0*XG(1)))/((2.D0*AJ+3.D0)*(32.D0*AJ-16.D0))                PTCI-145
      S0(1,2,13)=-CJ*(BJ-1.D0-(6.D0*BJ-16.D0)*XG(1)+2.D0*(BJ-1.D0)*XG(4)PTCI-146
     1-2.D0*XG(5)-3.D0*(XG(4)+XG(5)+3.D0*XG(1))*DJ)/((2.D0*AJ+3.D0)*(32.PTCI-147
     2D0*AJ-16.D0))                                                     PTCI-148
      S0(1,3,13)=CJ*(2.D0*BJ+(19.D0-12.D0*DJ)*XG(1))/((2.D0*AJ+3.D0)*(32PTCI-149
     2.D0*AJ-16.D0))                                                    PTCI-150
      S0(1,4,13)=CJ*(XG(4)-3.D0*(XG(4)+XG(5))*DJ)/((2.D0*AJ+3.D0)*(32.D0PTCI-151
     1*AJ-16.D0))                                                       PTCI-152
      S0(1,5,13)=CJ*(BJ-3.D0+2.D0*(BJ-1.D0)*XG(1)-5.D0*XG(4)-4.D0*XG(5)-PTCI-153
     1(3.D0*XG(1)-6.D0*XG(4)-6.D0*XG(5))*DJ)/((2.D0*AJ+3.D0)*(32.D0*AJ-1PTCI-154
     26.D0))                                                            PTCI-155
      S0(1,7,13)=CJ*(2.D0*BJ-3.D0+(1.D0-3.D0*DJ)*XG(1))/((2.D0*AJ+3.D0)*PTCI-156
     1(32.D0*AJ-16.D0))                                                 PTCI-157
      S0(1,8,13)=-CJ*(1.D0+(6.D0-3.D0*DJ)*XG(1))/((2.D0*AJ+3.D0)*(32.D0*PTCI-158
     1AJ-16.D0))                                                        PTCI-159
      S0(1,2,14)=-((AJ+2.D0)*((AJ+1.D0)**2*(AJ+1.D0-XG(1))+AJ*(AJ+3.D0)*PTCI-160
     1XG(4))-(AJ+3.D0)*XG(5))/((AJ+1.D0)*(32.D0*AJ+48.D0))              PTCI-161
      S0(1,3,14)=-(AJ+2.D0)*(AJ+3.D0)*(AJ+1.D0-XG(1))/((AJ+1.D0)*(32.D0*PTCI-162
     1AJ+48.D0))                                                        PTCI-163
      S0(1,4,14)=(AJ*(AJ+2.D0)*XG(4)-XG(5))/((AJ+1.D0)*(32.D0*AJ+48.D0))PTCI-164
      S0(1,5,14)=-(AJ*(AJ+2.D0)*((AJ+3.D0)*(AJ+1.D0-XG(1))+XG(4))-XG(5))PTCI-165
     1/((AJ+1.D0)*(32.D0*AJ+48.D0))                                     PTCI-166
      S0(1,7,14)=-AJ*(AJ+2.D0)*(AJ+1.D0-XG(1))/((AJ+1.D0)*(32.D0*AJ+48.DPTCI-167
     10))                                                               PTCI-168
      S0(1,8,14)=(AJ+2.D0)*(AJ+1.D0-XG(1))/((AJ+1.D0)*(32.D0*AJ+48.D0)) PTCI-169
      S0(1,8,16)=.0625D0*XG(1)/(AJ+1.D0)                                PTCI-170
      S0(1,7,16)=(BJ-1.D0)*S0(1,8,16)/AJ                                PTCI-171
      S0(1,3,16)=((AJ-2.D0)*AJ-1.D0)*S0(1,8,16)/AJ                      PTCI-172
      S0(1,4,16)=(AJ-2.D0)*S0(1,8,16)/AJ                                PTCI-173
      S0(1,5,16)=(1.D0-BJ)*S0(1,4,16)                                   PTCI-174
      S0(1,8,17)=.0625D0*XG(1)/AJ                                       PTCI-175
      S0(1,4,17)=(AJ+3.D0)*S0(1,8,17)/(AJ+1.D0)                         PTCI-176
      S0(1,5,17)=(1.D0-BJ)*S0(1,4,17)                                   PTCI-177
      S0(1,7,17)=S0(1,5,17)/(AJ+3.D0)                                   PTCI-178
      S0(1,1,17)=BJ*(AJ+2.D0)*S0(1,4,17)                                PTCI-179
      S0(1,2,17)=-.0625D0*(AJ+2.D0)*(AJ**2-3.D0)*XG(1)*DJ               PTCI-180
      S0(1,3,17)=-.0625D0*((AJ+4.D0)*AJ+2.D0)*XG(1)*DJ                  PTCI-181
      S1(1,2,2)=.25D0*XG(1)/(AJ+1.D0)/H                                 PTCI-182
      S1(1,4,2)=-.5D0*S1(1,2,2)/AJ                                      PTCI-183
      S1(1,5,2)=(1.D0-BJ)*S1(1,4,2)                                     PTCI-184
      S1(1,2,3)=.25D0*XG(1)/AJ/H                                        PTCI-185
      S1(1,4,3)=.5D0*S1(1,2,3)/(AJ+1.D0)                                PTCI-186
      S1(1,5,3)=(1.D0-BJ)*S1(1,4,3)                                     PTCI-187
      S1(1,2,6)=.125D0*(-2.D0*(AJ-1.D0)*XG(1)+XG(3)-(BJ-1.D0)*XG(4)+XG(5PTCI-188
     1))*DJ/H                                                           PTCI-189
      S1(1,2,7)=.125D0*(-2.D0*(AJ+2.D0)*XG(1)-XG(3)+(BJ-1.D0)*XG(4)-XG(5PTCI-190
     1))*DJ/H                                                           PTCI-191
      S1(1,1,9)=-((AJ**2-1.D0)*XG(4)-XG(5))/(16.D0*AJ-8.D0)/H           PTCI-192
      S1(1,2,9)=S1(1,1,9)/AJ                                            PTCI-193
      S1(1,1,11)=-(AJ*(AJ+2.D0)*XG(4)-XG(5))/(16.D0*AJ+24.D0)/H         PTCI-194
      S1(1,5,11)=AJ*(AJ+2.D0)*(AJ+1.D0-XG(1))/((AJ+1.D0)*(16.D0*AJ+24.D0PTCI-195
     1))/H                                                              PTCI-196
      S1(1,2,11)=-S1(1,1,11)/(AJ+1.D0)                                  PTCI-197
      S2(1,2,2)=-.25D0*XG(1)*DJ/H**2                                    PTCI-198
      S2(1,2,3)=-S2(1,2,2)                                              PTCI-199
      S0(2,1,2)=-.0625D0*((AJ*((((14.D0*AJ-12.D0)*AJ+12.D0)*AJ+26.D0)*AJPTCI-200
     1-96.D0)+((((10.D0*AJ-2.D0)*AJ+18.D0)*AJ+8.D0)*AJ-96.D0)*XG(1)-(((6PTCI-201
     2.D0*AJ-4.D0)*AJ-16.D0)*AJ+12.D0)*(XG(4)-XG(3))+((2.D0*AJ+4.D0)*AJ-PTCI-202
     312.D0)*XG(5))/(4.D0*AJ**2-9.D0)-(AJ-2.D0)*XG(2)-AJ*XG(6)-XG(7)-XG(PTCI-203
     48))                                                               PTCI-204
      S0(2,2,2)=-.0625D0*(((((10.D0*AJ-2.D0)*AJ+18.D0)*AJ+8.D0)*AJ-96.D0PTCI-205
     1+((14.D0*AJ**2+18.D0)*AJ-10.D0)*XG(1)-((2.D0*AJ-2.D0)*AJ-6.D0)*(XGPTCI-206
     2(4)-XG(3))+(6.D0*AJ-6.D0)*XG(5)+((2.D0*AJ+12.D0)*(XG(3)-XG(4)-XG(5PTCI-207
     3))-(96.D0*AJ+96.D0)*XG(1))*DJ)/(4.D0*AJ**2-9.D0)-((AJ-2.D0)*XG(2)+PTCI-208
     4AJ*XG(6)+XG(7)+XG(8))/AJ)                                         PTCI-209
      S0(2,4,2)=-(((3.D0*AJ-2.D0)*AJ-8.D0)*AJ+6.D0+((AJ-1.D0)*AJ-3.D0)*XPTCI-210
     1G(1)+(7.D0*AJ-6.D0)*XG(3)+(AJ+2.D0)*XG(4)+5.D0*XG(5)+((AJ+6.D0)*XGPTCI-211
     2(1)-(8.D0*AJ+3.D0)*XG(3)-(6.D0*AJ+6.D0)*(XG(4)+XG(5)))*DJ)/(32.D0*PTCI-212
     3AJ**2-72.D0)                                                      PTCI-213
      S0(2,5,2)=(((3.D0*AJ-2.D0)*AJ-8.D0)*AJ+6.D0+((AJ-1.D0)*AJ-3.D0)*XGPTCI-214
     1(1)-(AJ+2.D0)*XG(3)-(((8.D0*AJ+4.D0)*AJ-27.D0)*AJ-7.D0)*XG(4)+(8.DPTCI-215
     20*AJ+1.D0)*XG(5)+((AJ+6.D0)*XG(1)+(6.D0*AJ+6.D0)*XG(3)-(20.D0*AJ+1PTCI-216
     35.D0)*(XG(4)+XG(5)))*DJ)/(32.D0*AJ**2-72.D0)                      PTCI-217
      S0(2,7,2)=.0625D0*(AJ+XG(1))                                      PTCI-218
      S0(2,8,2)=S0(2,7,2)/AJ                                            PTCI-219
      S0(2,9,2)=S0(2,8,2)                                               PTCI-220
      S0(2,3,2)=(AJ-2.D0)*S0(2,8,2)                                     PTCI-221
      S0(2,2,3)=.0625D0*((10.D0*BJ**2+22.D0*AJ*BJ+52.D0*BJ+22.D0*AJ-74.DPTCI-222
     10-(((14.D0*AJ+42.D0)*AJ+60.D0)*AJ+42.D0)*XG(1)+((2.D0*AJ+6.D0)*AJ-PTCI-223
     22.D0)*(XG(3)-XG(4))-6.D0*(AJ+2.D0)*XG(5)-((2.D0*AJ-10.D0)*(XG(3)-XPTCI-224
     3G(4)-XG(5))-96.D0*AJ*XG(1))*DJ)/((2.D0*AJ+5.D0)*(2.D0*AJ-1.D0))-((PTCI-225
     4AJ+3.D0)*XG(2)-XG(7)-XG(8))/(AJ+1.D0)-XG(6))                      PTCI-226
      S0(2,4,3)=-(3.D0*AJ*BJ+8.D0*BJ-3.D0*AJ-9.D0-(BJ+2.D0*AJ-1.D0)*XG(1PTCI-227
     1)+(7.D0*AJ+13.D0)*XG(3)+(AJ-1.D0)*XG(4)-5.D0*XG(5)+((AJ-5.D0)*XG(1PTCI-228
     2)-(8.D0*AJ+5.D0)*XG(3)-6.D0*AJ*(XG(4)+XG(5)))*DJ)/((16.D0*AJ-8.D0)PTCI-229
     3*(2.D0*AJ+5.D0))                                                  PTCI-230
      S0(2,5,3)=(((3.D0*AJ+11.D0)*AJ+5.D0)*AJ-9.D0-((AJ+3.D0)*AJ-1.D0)*XPTCI-231
     1G(1)-(AJ-1.D0)*XG(3)-(((8.D0*AJ+20.D0)*AJ-11.D0)*AJ-16.D0)*XG(4)+(PTCI-232
     28.D0*AJ+7.D0)*XG(5)+((AJ-5.D0)*XG(1)+6.D0*AJ*XG(3)-(20.D0*AJ+5.D0)PTCI-233
     3*(XG(4)+XG(5)))*DJ)/((2.D0*AJ+5.D0)*(16.D0*AJ-8.D0))              PTCI-234
      S0(2,8,3)=-.0625D0*(AJ+1.D0-XG(1))/(AJ+1.D0)                      PTCI-235
      S0(2,9,3)=-.0625D0*(AJ+1.D0-XG(1))/(AJ+1.D0)                      PTCI-236
      S0(2,3,3)=.0625D0*(AJ+3.D0)*(AJ+1.D0-XG(1))/(AJ+1.D0)             PTCI-237
      S0(2,2,4)=-S0(2,1,4)/(AJ+1.D0)                                    PTCI-238
      S0(2,4,4)=-S0(2,2,4)/(AJ+3.D0)                                    PTCI-239
      S0(2,5,4)=-S0(2,4,4)                                              PTCI-240
      S0(2,2,6)=-CJ*(BJ-(2.D0*BJ-1.D0)*XG(1)-3.D0*XG(2)+XG(3)-XG(4)+2.D0PTCI-241
     1*XG(5)+XG(6)+2.D0*XG(7)+2.D0*XG(8)-3.D0*(XG(3)-XG(4)-XG(5))*DJ)/((PTCI-242
     22.D0*AJ+3.D0)*(16.D0*AJ-8.D0))                                    PTCI-243
      S0(2,4,6)=CJ*(2.D0*BJ-3.D0+XG(1)+2.D0*XG(3)+2.D0*XG(4)-3.D0*(XG(4)PTCI-244
     1+XG(5)+XG(1))*DJ)/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0))                PTCI-245
      S0(2,5,6)=-CJ*(2.D0*BJ-3.D0+XG(1)-2.D0*XG(3)-(4.D0*BJ-9.D0)*XG(4)+PTCI-246
     14.D0*XG(5)-3.D0*(2.D0*XG(4)+2.D0*XG(5)+XG(1)-XG(3))*DJ)/((2.D0*AJ+PTCI-247
     23.D0)*(16.D0*AJ-8.D0))                                            PTCI-248
      S0(2,1,7)=((AJ+2.D0)*((AJ+1.D0)*((AJ+1.D0)*(AJ+3.D0-XG(1))-XG(6))-PTCI-249
     1(AJ+3.D0)*(XG(3)+XG(2)-XG(4))+XG(7)+XG(8))+(AJ+3.D0)*XG(5))/(16.D0PTCI-250
     2*AJ+24.D0)                                                        PTCI-251
      S0(2,2,7)=-S0(2,1,7)/(AJ+1.D0)                                    PTCI-252
      S0(2,5,7)=-((AJ+2.D0)*((AJ+3.D0)*(AJ+1.D0-XG(1))+XG(3)-XG(4))-XG(5PTCI-253
     1))/((AJ+1.D0)*(16.D0*AJ+24.D0))                                   PTCI-254
      S0(2,4,7)=-S0(2,5,7)                                              PTCI-255
      S0(2,1,9)=-((AJ-2.D0)*(BJ*(AJ-1.D0)*(AJ+3.D0)-((6.D0*AJ+4.D0)*AJ-1PTCI-256
     12.D0)*(XG(3)-XG(4))-(2.D0*AJ+12.D0)*XG(5))+((((3.D0*AJ+2.D0)*AJ-5.PTCI-257
     2D0)*AJ-10.D0)*AJ+6.D0)*XG(1)-(((4.D0*AJ-9.D0)*AJ-10.D0)*AJ+21.D0)*PTCI-258
     3XG(2)-(((4.D0*AJ-1.D0)*AJ-10.D0)*AJ+3.D0)*XG(6)-((4.D0*AJ+1.D0)*AJPTCI-259
     4-9.D0)*XG(7)-((4.D0*AJ+3.D0)*AJ-9.D0)*XG(8)+(AJ-3.D0)*XG(9)+3.D0*XPTCI-260
     5G(10))/(64.D0*AJ**2-144.D0)                                       PTCI-261
      S0(2,2,9)=-((AJ-2.D0)*(3.D0*BJ*(AJ-1.D0)-(2.D0*AJ+6.D0)*(XG(3)-XG(PTCI-262
     14))-6.D0*XG(5))+(((AJ+11.D0)*AJ-14.D0)*AJ-6.D0)*XG(1)-((4.D0*AJ-7.PTCI-263
     2D0)*AJ-7.D0)*XG(2)-((4.D0*AJ+1.D0)*AJ-15.D0)*XG(6)-(4.D0*AJ-1.D0)*PTCI-264
     3XG(7)-(4.D0*AJ+5.D0)*XG(8)+3.D0*XG(9)+((AJ+6.D0)*((2.D0*AJ-4.D0)*(PTCI-265
     4XG(3)-XG(4)-XG(5))-2.D0*XG(6)-2.D0*XG(9)+XG(10))+6.D0*(AJ+1.D0)*(XPTCI-266
     5G(7)-2.D0*XG(2))+(8.D0*AJ+18.D0)*XG(8))*DJ)/(64.D0*AJ**2-144.D0)  PTCI-267
      S0(2,2,10)=((AJ+3.D0)*(3.D0*BJ*(AJ+2.D0)-(2.D0*AJ-4.D0)*(XG(3)-XG(PTCI-268
     14))+6.D0*XG(5))-(((AJ-8.D0)*AJ-33.D0)*AJ-18.D0)*XG(1)-((4.D0*AJ+15PTCI-269
     2.D0)*AJ+4.D0)*XG(2)-((4.D0*AJ+7.D0)*AJ-12.D0)*XG(6)+(4.D0*AJ+5.D0)PTCI-270
     3*XG(7)+(4.D0*AJ-1.D0)*XG(8)+3.D0*XG(9)+((AJ-5.D0)*((2.D0*AJ+6.D0)*PTCI-271
     4(XG(3)-XG(4)-XG(5))+2.D0*XG(6)+2.D0*XG(9)-XG(10))+6.D0*AJ*(2.D0*XGPTCI-272
     5(2)-XG(7))-(8.D0*AJ-10.D0)*XG(8))*DJ)/((2.D0*AJ+5.D0)*(32.D0*AJ-16PTCI-273
     6.D0))                                                             PTCI-274
      S0(2,2,11)=-S0(2,1,11)/(AJ+1.D0)                                  PTCI-275
      S0(2,1,12)=(AJ-2.D0)*((AJ-1.D0)*(AJ*(AJ+XG(1))+XG(3)-XG(4))+XG(5))PTCI-276
     1/(16.D0*AJ-8.D0)                                                  PTCI-277
      S0(2,2,12)=((AJ-1.D0)*(AJ**2*(AJ+XG(1))+(AJ-2.D0)*(XG(3)-XG(4)))+(PTCI-278
     1AJ-2.D0)*XG(5))/(AJ*(16.D0*AJ-8.D0))                              PTCI-279
      S0(2,4,12)=-((AJ-1.D0)*((AJ-2.D0)*(AJ+XG(1))-XG(3)+XG(4))-XG(5))/(PTCI-280
     1AJ*(16.D0*AJ-8.D0))                                               PTCI-281
      S0(2,5,12)=-S0(2,4,12)                                            PTCI-282
      S0(2,1,13)=CJ*(2.D0*BJ*(BJ-1.D0)-BJ*XG(1)+(2.D0*BJ-3.D0)*(XG(3)-XGPTCI-283
     1(4))+3.D0*XG(5))/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0))                 PTCI-284
      S0(2,2,13)=CJ*(3.D0*BJ-2.D0+(2.D0*BJ-1.D0)*XG(1)+(1.D0-3.D0*DJ)*(XPTCI-285
     1G(3)-XG(4))+(2.D0+3.D0*DJ)*XG(5))/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0))PTCI-286
      S0(2,3,13)=-CJ*(2.D0*BJ-3.D0-3.D0*XG(1))/((2.D0*AJ+3.D0)*(16.D0*AJPTCI-287
     1-8.D0))                                                           PTCI-288
      S0(2,4,13)=-CJ*(2.D0*BJ-3.D0+XG(1)-2*XG(3)-2*XG(4)-3.D0*(XG(1)-XG(PTCI-289
     14)-XG(5))*DJ)/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0))                    PTCI-290
      S0(2,5,13)=CJ*(2.D0*BJ-3.D0+XG(1)+2*XG(3)+(4.D0*BJ-9.D0)*XG(4)-4.DPTCI-291
     10*XG(5)-3.D0*(XG(1)+XG(3)-2.D0*XG(4)-2.D0*XG(5))*DJ)/((2.D0*AJ+3.DPTCI-292
     20)*(16.D0*AJ-8.D0))                                               PTCI-293
      S0(2,7,13)=-CJ*(2.D0*BJ-1.D0+XG(1))/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0PTCI-294
     1))                                                                PTCI-295
      S0(2,8,13)=-CJ*(1.D0+2.D0*XG(1))/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0)) PTCI-296
      S0(2,9,13)=S0(2,8,13)                                             PTCI-297
      S0(2,1,14)=(AJ+3.D0)*((AJ+2.D0)*((AJ+1.D0)*(AJ+1.D0-XG(1))+XG(3)-XPTCI-298
     1G(4))-XG(5))/(16.D0*AJ+24.D0)                                     PTCI-299
      S0(2,2,14)=-((AJ+2.D0)*((AJ+1.D0)**2*(AJ+1.D0-XG(1))+(AJ+3.D0)*(XGPTCI-300
     1(3)-XG(4)))-(AJ+3.D0)*XG(5))/((AJ+1.D0)*(16.D0*AJ+24.D0))         PTCI-301
      S0(2,3,14)=-(AJ+2.D0)*(AJ+3.D0)*(AJ+1.D0-XG(1))/((AJ+1.D0)*(16.D0*PTCI-302
     1AJ+24.D0))                                                        PTCI-303
      S0(2,4,14)=-((AJ+2.D0)*((AJ+3.D0)*(AJ+1.D0-XG(1))-XG(3)+XG(4))+XG(PTCI-304
     15))/((AJ+1.D0)*(16.D0*AJ+24.D0))                                  PTCI-305
      S0(2,5,14)=((AJ+2.D0)*((AJ+3.D0)*(AJ+1.D0-XG(1))-XG(3)+XG(4))+XG(5PTCI-306
     1))/((AJ+1.D0)*(16.D0*AJ+24.D0))                                   PTCI-307
      S0(2,7,14)=-(AJ+2.D0)*(AJ+1.D0-XG(1))/(16.D0*AJ+24.D0)            PTCI-308
      S0(2,8,14)=-S0(2,7,14)/(AJ+1.D0)                                  PTCI-309
      S0(2,9,14)=S0(2,8,14)                                             PTCI-310
      S0(2,2,16)=-(3.D0*BJ**2-4.D0*AJ*BJ-4.D0*BJ-6.D0*AJ+6.D0+(AJ*BJ+10*PTCI-311
     1BJ-24.D0*AJ-6.D0)*XG(1))/(64.D0*AJ**2-144.D0)                     PTCI-312
      S0(2,3,16)=(((4.D0*AJ-9.D0)*AJ-10.D0)*AJ+21.D0+((4.D0*AJ-7.D0)*AJ-PTCI-313
     17.D0+12.D0/AJ)*XG(1))/(64.D0*AJ**2-144.D0)                        PTCI-314
      S0(2,4,16)=(AJ-2.D0)*((3.D0*AJ+2.D0)*AJ-6.D0+(AJ+3.D0-(AJ+6.D0)*DJPTCI-315
     1)*XG(1))/(32.D0*AJ**2-72.D0)                                      PTCI-316
      S0(2,5,16)=-S0(2,4,16)                                            PTCI-317
      S0(2,7,16)=(((4.D0*AJ-1.D0)*AJ-10.D0)*AJ+3.D0+((4.D0*AJ+1.D0)*AJ-1PTCI-318
     15.D0+(2.D0*AJ+12.D0)*DJ)*XG(1))/(64.D0*AJ**2-144.D0)              PTCI-319
      S0(2,8,16)=((4.D0*AJ+1.D0)*AJ-9.D0+(4.D0*AJ-1.D0-6.D0/AJ)*XG(1))/(PTCI-320
     164.D0*AJ**2-144.D0)                                               PTCI-321
      S0(2,9,16)=((4.D0*AJ+3.D0)*AJ-9.D0+(((4.D0*AJ+9.D0)*AJ-3.D0)*AJ-18PTCI-322
     1.D0)*XG(1)*DJ)/(64.D0*AJ**2-144.D0)                               PTCI-323
      S0(2,1,17)=-BJ*(AJ+2.D0)*(AJ+3.D0)*(AJ-2.D0-3.D0*XG(1))/((32.D0*AJPTCI-324
     1-16.D0)*(2.D0*AJ+5.D0))                                           PTCI-325
      S0(2,2,17)=(3.D0*BJ**2+4.D0*BJ*AJ+6.D0*AJ+12.D0-(((AJ-8.D0)*AJ-33.PTCI-326
     1D0)*AJ-18.D0)*XG(1))/((32.D0*AJ-16.D0)*(2.D0*AJ+5.D0))            PTCI-327
      S0(2,3,17)=(4.D0*AJ*BJ+17.D0*BJ+3.D0*AJ-18.D0-(4.D0*BJ+11.D0*AJ+4.PTCI-328
     1D0-12.D0*AJ*DJ)*XG(1))/((32.D0*AJ-16.D0)*(2.D0*AJ+5.D0))          PTCI-329
      S0(2,4,17)=(AJ+3.D0)*(3.D0*BJ+AJ-5.D0-(AJ-2.D0-(AJ-5.D0)*DJ)*XG(1)PTCI-330
     1)/((16.D0*AJ-8.D0)*(2.D0*AJ+5.D0))                                PTCI-331
      S0(2,5,17)=-S0(2,4,17)                                            PTCI-332
      S0(2,7,17)=(4.D0*AJ*BJ+9.D0*BJ-5.D0*AJ-8.D0-(4.D0*BJ+3.D0*AJ-12.D0PTCI-333
     1-(2.D0*AJ-10.D0)*DJ)*XG(1))/((32.D0*AJ-16.D0)*(2.D0*AJ+5.D0))     PTCI-334
      S0(2,8,17)=-(4.D0*BJ+3.D0*AJ-6.D0-(4.D0*AJ+5.D0-6.D0/(AJ+1.D0))*XGPTCI-335
     1(1))/((32.D0*AJ-16.D0)*(2.D0*AJ+5.D0))                            PTCI-336
      S0(2,9,17)=-(4.D0*BJ+AJ-8.D0-(4.D0*AJ-1.D0-(8.D0*AJ-10.D0)*DJ)*XG(PTCI-337
     11))/((32.D0*AJ-16.D0)*(2.D0*AJ+5.D0))                             PTCI-338
      S0(2,5,18)=-2.D0*S0(2,1,18)/(AJ+1.D0)/(AJ+4.D0)                   PTCI-339
      S0(2,4,18)=-S0(2,5,18)                                            PTCI-340
      S0(2,3,18)=-.5D0*S0(2,5,18)/(AJ+5.D0)                             PTCI-341
      S0(2,7,18)=S0(2,3,18)                                             PTCI-342
      S0(2,8,18)=-S0(2,7,18)/(AJ+3.D0)                                  PTCI-343
      S0(2,2,18)=(((AJ+12.D0)*AJ+49.D0)*AJ+62.D0)*S0(2,8,18)            PTCI-344
      S0(2,9,18)=3.D0*S0(2,8,18)                                        PTCI-345
      S1(2,1,2)=(AJ*(AJ-3.D0)*(2.D0-AJ**2)+(((AJ+2.D0)*AJ-1.D0)*AJ-6.D0)PTCI-346
     1*XG(1))/(16.D0*AJ**2-36.D0)/H                                     PTCI-347
      S1(2,2,2)=(((AJ+2.D0)*AJ-1.D0)*AJ-6.D0-(((AJ-5.D0)*AJ+1.D0)*AJ+6.DPTCI-348
     10)*XG(1)/AJ)/(16.D0*AJ**2-36.D0)/H                                PTCI-349
      S1(2,4,2)=-(BJ-3.D0-(((AJ-1.D0)*AJ-4.D0)*AJ+3.D0)*XG(1)*DJ)/(16.D0PTCI-350
     1*AJ**2-36.D0)/H                                                   PTCI-351
      S1(2,5,2)=-S1(2,4,2)                                              PTCI-352
      S1(2,1,3)=((AJ+1.D0)*(AJ+4.D0)*(BJ+AJ-1.D0)+(AJ*BJ-2.D0*AJ+4.D0)*XPTCI-353
     1G(1))/((2.D0*AJ+5.D0)*(8.D0*AJ-4.D0))/H                           PTCI-354
      S1(2,2,3)=(AJ*BJ-2.D0*AJ+4.D0+(((AJ+8.D0)*AJ+14.D0)*AJ+1.D0)*XG(1)PTCI-355
     1/(AJ+1.D0))/((2.D0*AJ+5.D0)*(8.D0*AJ-4.D0))/H                     PTCI-356
      S1(2,4,3)=(BJ-3.D0+(((AJ+4.D0)*AJ+1.D0)*AJ-5.D0)*XG(1)*DJ)/((2.D0*PTCI-357
     1AJ+5.D0)*(8.D0*AJ-4.D0))/H                                        PTCI-358
      S1(2,5,3)=-S1(2,4,3)                                              PTCI-359
      S1(2,5,4)=-(AJ+2.D0)*(AJ+3.D0)*(AJ+1.D0-XG(1))/((AJ+1.D0)*(2.D0*AJPTCI-360
     1+5.D0)*(8.D0*AJ+12.D0))/H                                         PTCI-361
      S1(2,4,4)=-S1(2,5,4)                                              PTCI-362
      S1(2,2,4)=-(AJ+3.D0)*S1(2,4,4)                                    PTCI-363
      S1(2,1,4)=-(AJ+1.D0)*S1(2,2,4)                                    PTCI-364
      S1(2,1,6)=(AJ*(AJ-1.D0)*((AJ-1.D0)*AJ-3.D0-AJ*XG(1))+(BJ-3.D0)*(XGPTCI-365
     1(3)-XG(4))-(AJ-3.D0)*XG(5))/(16.D0*AJ**2-36.D0)/H                 PTCI-366
      S1(2,2,6)=((AJ-1.D0)*((AJ-3.D0)*XG(1)-AJ**2)-((((AJ-1.D0)*AJ-4.D0)PTCI-367
     1*AJ+3.D0)*(XG(3)-XG(4))-((AJ-1.D0)*AJ+3.D0)*XG(5))*DJ)/(16.D0*AJ**PTCI-368
     22-36.D0)/H                                                        PTCI-369
      S1(2,1,7)=-((AJ+1.D0)*(AJ+2.D0)*(BJ+2.D0*AJ-1.D0+(AJ+1.D0)*XG(1))+PTCI-370
     1(BJ-3.D0)*(XG(3)-XG(4))+(AJ+4.D0)*XG(5))/((2.D0*AJ+5.D0)*(8.D0*AJ-PTCI-371
     24.D0))/H                                                          PTCI-372
      S1(2,2,7)=-((AJ+2.D0)*((AJ+1.D0)**2+(AJ+4.D0)*XG(1))+((((AJ+4.D0)*PTCI-373
     1AJ+1.D0)*AJ-5.D0)*(XG(3)-XG(4))+((AJ+3.D0)*AJ+5.D0)*XG(5))*DJ)/((2PTCI-374
     2.D0*AJ+5.D0)*(8.D0*AJ-4.D0))/H                                    PTCI-375
      S1(2,1,8)=(AJ+3.D0)*((AJ+2.D0)*((AJ+4.D0)*(XG(1)-AJ-1.D0)-XG(3)+XGPTCI-376
     1(4))+XG(5))/((2.D0*AJ+5.D0)*(8.D0*AJ+12.D0))/H                    PTCI-377
      S1(2,2,8)=-S1(2,1,8)/(AJ+1.D0)                                    PTCI-378
      S1(2,1,11)=((AJ+2.D0)*(XG(4)-XG(3))+XG(5))/(8.D0*AJ+12.D0)/H      PTCI-379
      S1(2,5,11)=-(AJ+2.D0)*(AJ+1.D0-XG(1))/((AJ+1.D0)*(8.D0*AJ+12.D0))/PTCI-380
     1H                                                                 PTCI-381
      S1(2,2,11)=-S1(2,1,11)/(AJ+1.D0)                                  PTCI-382
      S1(2,6,11)=S1(2,5,11)/(AJ+2.D0)                                   PTCI-383
      S1(2,4,11)=-S1(2,5,11)                                            PTCI-384
      S2(2,1,2)=(AJ*(AJ**2-3.D0)+((3.D0*AJ-1.D0)*AJ-6.D0)*XG(1))/(36.D0-PTCI-385
     116.D0*AJ**2)/H**2                                                 PTCI-386
      S2(2,2,2)=((3.D0*AJ-1.D0)*AJ-6.D0+((AJ+2.D0)*AJ-6.D0)*XG(1)/AJ)/(3PTCI-387
     16.D0-16.D0*AJ**2)/H**2                                            PTCI-388
      S2(2,2,3)=((AJ+1.D0)*(3.D0*BJ+4.D0*AJ-2.D0)-(AJ**2-7.D0)*XG(1))/((PTCI-389
     1AJ+1.D0)*(2.D0*AJ+5.D0)*(8.D0*AJ-4.D0))/H**2                      PTCI-390
      S2(2,2,4)=-S2(2,1,4)/(AJ+1.D0)                                    PTCI-391
      IF (JX.LE.1) GO TO 12                                             PTCI-392
      S0(1,6,2)=-.0625D0*(AJ*XG(1)+XG(3)-(2.D0*AJ+4.D0)*XG(4)+4.D0*XG(5)PTCI-393
     1/(AJ-1.D0))*DJ                                                    PTCI-394
      S0(1,6,3)=-.0625D0*((AJ+1.D0)*XG(1)-XG(3)-(2.D0*AJ-2.D0)*XG(4)+4.DPTCI-395
     10*XG(5)/(AJ+2.D0))*DJ                                             PTCI-396
      S0(1,1,5)=((AJ-1.D0)*(AJ**2*(AJ-2.D0+XG(1))-(AJ-2.D0)*(XG(2)-(AJ+1PTCI-397
     1.D0)*XG(4))-(AJ+1.D0)*XG(6)-XG(7))-(AJ-2.D0)*XG(5)+XG(9))/(32.D0*APTCI-398
     2J-16.D0)                                                          PTCI-399
      S0(1,2,5)=S0(1,1,5)/AJ                                            PTCI-400
      S0(1,5,5)=-(AJ+1.D0)*((AJ-1.D0)*((AJ-2.D0)*(AJ+XG(1))+XG(3)-XG(4))PTCI-401
     1+XG(5))/(AJ*(32.D0*AJ-16.D0))                                     PTCI-402
      S0(1,6,5)=-S0(1,5,5)/(AJ**2-1.D0)                                 PTCI-403
      S0(1,6,6)=CJ*(3.D0+2.D0*XG(1)-4.D0*XG(4)+3.D0*(XG(1)-XG(3)+2.D0*XGPTCI-404
     1(4)+2.D0*XG(5))*DJ)/((2.D0*AJ+3.D0)*(32.D0*AJ-16.D0))             PTCI-405
      S0(1,6,7)=-S0(1,5,7)/(AJ*(AJ+2.D0))                               PTCI-406
      S0(1,10,12)=(AJ+XG(1))/(AJ*(32.D0*AJ-16.D0))                      PTCI-407
      S0(1,8,12)=-(AJ-1.D0)*S0(1,10,12)                                 PTCI-408
      S0(1,7,12)=(AJ+1.D0)*S0(1,8,12)                                   PTCI-409
      S0(1,5,12)=((AJ-1.D0)*(((AJ-1.D0)*AJ-2.D0)*(AJ+XG(1))+(AJ+1.D0)*XGPTCI-410
     1(4))-XG(5))/(AJ*(32.D0*AJ-16.D0))                                 PTCI-411
      S0(1,6,12)=-((AJ-2.D0)*(AJ+XG(1))+(AJ+1.D0)*XG(4)-XG(5)/(AJ-1.D0))PTCI-412
     1/(AJ*(32.D0*AJ-16.D0))                                            PTCI-413
      S0(1,6,13)=-CJ*(3.D0+2.D0*XG(1)+2.D0*XG(4)+(3.D0*XG(1)-6.D0*XG(4)-PTCI-414
     16.D0*XG(5))*DJ)/((2.D0*AJ+3.D0)*(32.D0*AJ-16.D0))                 PTCI-415
      S0(1,10,13)=-CJ*(2.D0+3.D0*DJ*XG(1))/((2.D0*AJ+3.D0)*(32.D0*AJ-16.PTCI-416
     1D0))                                                              PTCI-417
      S0(1,6,14)=((AJ+2.D0)*((AJ+3.D0)*(AJ+1.D0-XG(1))-AJ*XG(4))+XG(5))/PTCI-418
     1((AJ+1.D0)*(AJ+2.D0)*(32.D0*AJ+48.D0))                            PTCI-419
      S0(1,10,14)=(AJ+1.D0-XG(1))/((AJ+1.D0)*(32.D0*AJ+48.D0))          PTCI-420
      S0(1,10,16)=-S0(1,8,16)/AJ                                        PTCI-421
      S0(1,6,16)=S0(1,4,16)                                             PTCI-422
      S0(1,1,16)=-BJ*(AJ-1.D0)*S0(1,6,16)                               PTCI-423
      S0(1,2,16)=(AJ-1.D0)*(BJ+AJ-2.D0)*S0(1,10,16)                     PTCI-424
      S0(1,6,17)=S0(1,4,17)                                             PTCI-425
      S0(1,10,17)=S0(1,6,17)/(AJ+3.D0)                                  PTCI-426
      S1(1,6,2)=S1(1,4,2)                                               PTCI-427
      S1(1,6,3)=S1(1,4,3)                                               PTCI-428
      S1(1,6,9)=-(AJ+XG(1))/(AJ*(16.D0*AJ-8.D0))/H                      PTCI-429
      S1(1,5,9)=(1.D0-AJ)*(1.D0+AJ)*S1(1,6,9)                           PTCI-430
      S1(1,6,11)=-S1(1,5,11)/AJ/(AJ+2.D0)                               PTCI-431
      S0(2,6,2)=-((AJ+2.D0)*AJ-6.D0+(3.D0*AJ-3.D0)*XG(1)+5.D0*XG(3)-(8.DPTCI-432
     10*AJ+1.D0)*XG(4)-((6.D0*AJ+6.D0)*XG(3)+(AJ+6.D0)*XG(1)-(20.D0*AJ+1PTCI-433
     25.D0)*XG(4))*DJ+(15.D0-(25.D0*AJ+15.D0)*DJ)*XG(5)/(AJ-1.D0))/(32.DPTCI-434
     30*AJ**2-72.D0)                                                    PTCI-435
      S0(2,6,3)=(2.D0*AJ**2-14.D0-(6.D0*AJ+12.D0)*XG(1)+10.D0*XG(3)+(16.PTCI-436
     1D0*AJ+14.D0)*XG(4)+((2.D0*AJ-10.D0)*XG(1)+12.D0*AJ*XG(3)-(40.D0*AJPTCI-437
     2+10.D0)*XG(4))*DJ-(30.D0+(50.D0*AJ+20.D0)*DJ)*XG(5)/(AJ+2.D0))/((3PTCI-438
     32.D0*AJ-16.D0)*(2.D0*AJ+5.D0))                                    PTCI-439
      S0(2,6,4)=S0(2,5,4)/(AJ+2.D0)                                     PTCI-440
      S0(2,1,5)=((AJ-1.D0)*(AJ**2*(AJ-2.D0+XG(1))-(AJ-2.D0)*(XG(3)+XG(2)PTCI-441
     1-XG(4))-AJ*XG(6)-XG(7)-XG(8))-(AJ-2.D0)*XG(5))/(16.D0*AJ-8.D0)    PTCI-442
      S0(2,2,5)=S0(2,1,5)/AJ                                            PTCI-443
      S0(2,6,5)=((AJ-1.D0)*((AJ-2.D0)*(AJ+XG(1))+XG(3)-XG(4))+XG(5))/(AJPTCI-444
     1*(AJ-1.D0)*(16.D0*AJ-8.D0))                                       PTCI-445
      S0(2,4,5)=(AJ-1.D0)*S0(2,6,5)                                     PTCI-446
      S0(2,5,5)=-S0(2,4,5)                                              PTCI-447
      S0(2,6,6)=CJ*(3.D0+2.D0*XG(1)-4.D0*XG(4)+3.D0*(XG(1)-XG(3)+2.D0*XGPTCI-448
     1(4)+2.D0*XG(5))*DJ)/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0))              PTCI-449
      S0(2,6,7)=S0(2,5,7)/(AJ+2.D0)                                     PTCI-450
      S0(2,6,12)=S0(2,4,12)/(AJ-1.D0)                                   PTCI-451
      S0(2,8,12)=-(AJ-1.D0)*(AJ+XG(1))/(AJ*(16.D0*AJ-8.D0))             PTCI-452
      S0(2,9,12)=S0(2,8,12)                                             PTCI-453
      S0(2,7,12)=AJ*S0(2,8,12)                                          PTCI-454
      S0(2,6,13)=-CJ*(3.D0+2.D0*XG(1)+4.D0*XG(4)+3.D0*(XG(1)+XG(3)-2.D0*PTCI-455
     1XG(4)-2.D0*XG(5))*DJ)/((2.D0*AJ+3.D0)*(16.D0*AJ-8.D0))            PTCI-456
      S0(2,6,14)=S0(2,5,14)/(AJ+2.D0)                                   PTCI-457
      S0(2,11,15)=(AJ+XG(1))/(AJ*(32.D0*AJ-16.D0)*(2.D0*AJ-3.D0))       PTCI-458
      S0(2,8,15)=-(AJ-1.D0)*S0(2,11,15)                                 PTCI-459
      S0(2,9,15)=3.D0*S0(2,8,15)                                        PTCI-460
      S0(2,2,15)=-(((AJ-9.D0)*AJ+28.D0)*AJ-24.D0)*S0(2,8,15)            PTCI-461
      S0(2,10,16)=-(AJ-3.D0+((3.D0*AJ+1.D0)*AJ-12.D0)*XG(1)*DJ)/(64.D0*APTCI-462
     1J**2-144.D0)                                                      PTCI-463
      S0(2,11,16)=-(3.D0+(AJ+6.D0)*XG(1)*DJ)/(64.D0*AJ**2-144.D0)       PTCI-464
      S0(2,6,17)=-(AJ+3.D0)*(AJ-5.D0-(3.D0-(AJ-5.D0)*DJ)*XG(1))/((16.D0*PTCI-465
     1AJ-8.D0)*(2.D0*AJ+5.D0))                                          PTCI-466
      S0(2,10,17)=-(AJ+4.D0-(3.D0+(2.D0*AJ-10.D0)*DJ)*XG(1))/((32.D0*AJ-PTCI-467
     116.D0)*(2.D0*AJ+5.D0))                                            PTCI-468
      S0(2,11,17)=(3.D0-(AJ-5.D0)*XG(1)*DJ)/((32.D0*AJ-16.D0)*(2.D0*AJ+5PTCI-469
     1.D0))                                                             PTCI-470
      S0(2,10,18)=S0(2,3,18)/(AJ+2.D0)                                  PTCI-471
      S0(2,11,18)=-S0(2,10,18)/(AJ+3.D0)                                PTCI-472
      S0(2,6,18)=-2.D0*(AJ+5.D0)*S0(2,10,18)                            PTCI-473
      S1(2,6,2)=(AJ-3.D0-((AJ-1.D0)*AJ+3.D0)*XG(1)*DJ)/(16.D0*AJ**2-36.DPTCI-474
     10)/H                                                              PTCI-475
      S1(2,6,3)=(AJ+4.D0+(BJ+2.D0*AJ+5.D0)*XG(1)*DJ)/((2.D0*AJ+5.D0)*(8.PTCI-476
     1D0*AJ-4.D0))/H                                                    PTCI-477
      S1(2,6,4)=S1(2,5,4)/(AJ+2.D0)                                     PTCI-478
      S1(2,1,9)=((AJ-1.D0)*(XG(3)-XG(4))+XG(5))/(8.D0*AJ-4.D0)/H        PTCI-479
      S1(2,2,9)=S1(2,1,9)/AJ                                            PTCI-480
      S1(2,6,9)=-(AJ+XG(1))/(AJ*(8.D0*AJ-4.D0))/H                       PTCI-481
      S1(2,4,9)=(AJ-1.D0)*S1(2,6,9)                                     PTCI-482
      S1(2,5,9)=-S1(2,4,9)                                              PTCI-483
      IF (JX.LE.2) GO TO 12                                             PTCI-484
      S0(2,1,1)=-(AJ-2.D0)**2*((AJ-1.D0)*((AJ-2.D0)*(AJ+XG(1))+XG(3)-XG(PTCI-485
     14))+XG(5))/((2.D0*AJ-3.D0)*(16.D0*AJ-8.D0))                       PTCI-486
      S0(2,2,1)=S0(2,1,1)/AJ                                            PTCI-487
      S0(2,4,1)=S0(2,2,1)/(AJ-2.D0)                                     PTCI-488
      S0(2,5,1)=-S0(2,4,1)                                              PTCI-489
      S0(2,6,1)=S0(2,4,1)/(AJ-1.D0)                                     PTCI-490
      S0(2,1,8)=((AJ-1.D0)*((AJ-2.D0)*((AJ-4.D0)*(AJ*(AJ-3.D0)+2.D0*XG(3PTCI-491
     1)-2.D0*XG(4))-XG(2)-XG(6))+(((AJ-9.D0)*AJ+28.D0)*AJ-24.D0)*XG(1)-3PTCI-492
     2.D0*XG(8)-XG(7))+(AJ-2.D0)*(XG(9)+(2.D0*AJ-8.D0)*XG(5))+XG(10))/((PTCI-493
     32.D0*AJ-3.D0)*(32.D0*AJ-16.D0))                                   PTCI-494
      S0(2,2,8)=S0(2,1,8)/AJ                                            PTCI-495
      S0(1,3,12)=(AJ-2.D0)*S0(1,8,12)                                   PTCI-496
      S0(2,3,12)=-(AJ-1.D0)*(AJ-2.D0)*(AJ+XG(1))/(AJ*(16.D0*AJ-8.D0))   PTCI-497
      S0(2,10,15)=(AJ-2.D0)*S0(2,11,15)                                 PTCI-498
      S0(2,3,15)=-(AJ-1.D0)*S0(2,10,15)                                 PTCI-499
      S0(2,7,15)=S0(2,3,15)                                             PTCI-500
      S0(2,6,15)=2.D0*(AJ-4.D0)*S0(2,10,15)                             PTCI-501
      S0(2,4,15)=(AJ-1.D0)*S0(2,6,15)                                   PTCI-502
      S0(2,5,15)=-S0(2,4,15)                                            PTCI-503
      S0(2,1,15)=-.5D0*AJ*(AJ-3.D0)*S0(2,5,15)                          PTCI-504
      S0(2,1,16)=-BJ*(AJ-1.D0)*(AJ-2.D0)*(AJ+3.D0+3.D0*XG(1))/(64.D0*AJ*PTCI-505
     1*2-144.D0)                                                        PTCI-506
      S0(2,6,16)=(AJ-2.D0)*(AJ+6.D0+(3.D0+(AJ+6.D0)*DJ)*XG(1))/(32.D0*AJPTCI-507
     1**2-72.D0)                                                        PTCI-508
      S1(2,6,1)=-(AJ-2.D0)*(AJ+XG(1))/(AJ*(2.D0*AJ-3.D0)*(8.D0*AJ-4.D0))PTCI-509
     1/H                                                                PTCI-510
      S1(2,5,1)=-(AJ-1.D0)*S1(2,6,1)                                    PTCI-511
      S1(2,4,1)=-S1(2,5,1)                                              PTCI-512
      S1(2,2,1)=(AJ-2.D0)*S1(2,4,1)                                     PTCI-513
      S1(2,1,1)=AJ*S1(2,2,1)                                            PTCI-514
      S1(2,1,5)=(AJ-2.D0)*((AJ-1.D0)*((AJ-3.D0)*(AJ+XG(1))+XG(3)-XG(4))+PTCI-515
     1XG(5))/((2.D0*AJ-3.D0)*(8.D0*AJ-4.D0))/H                          PTCI-516
      S1(2,2,5)=S1(2,1,5)/AJ                                            PTCI-517
      S2(2,1,1)=(AJ-1.D0)*(AJ-2.D0)*(AJ+XG(1))/((8.D0*AJ-4.D0)*(2.D0*AJ-PTCI-518
     13.D0))/H**2                                                       PTCI-519
      S2(2,2,1)=S2(2,1,1)/AJ                                            PTCI-520
   12 DO 16 L=1,2                                                       PTCI-521
      DO 13 I=1,6                                                       PTCI-522
   13 S1(L,I,10)=-S1(L,I,9)-S1(L,I,11)                                  PTCI-523
      DO 15 K=1,8                                                       PTCI-524
      K1=K                                                              PTCI-525
      IF (K1.GT.4) K1=K1-4                                              PTCI-526
      DO 14 I=3,6                                                       PTCI-527
   14 S1(L,I,K+11)=-S1(L,I,K)                                           PTCI-528
      S1(L,1,K+11)=-S1(L,1,K)-H*S2(L,1,K1)                              PTCI-529
      S1(L,2,K+11)=-S1(L,2,K)-H*S2(L,2,K1)                              PTCI-530
   15 CONTINUE                                                          PTCI-531
   16 CONTINUE                                                          PTCI-532
      RETURN                                                            PTCI-533
      END                                                               PTCI-534
