C 03/04/98                                                      DWBA98  PTI0-000
      SUBROUTINE PTI0(KTF,CVF,VX,VS,VD,VT,WT,XT,INM,NT,CA)              PTI0-001
C CALCULATION OF THE FORM-FACTORS FOR A ZERO RANGE INTERACTION.         PTI0-002
C DATA PASSED OVER BY ARGUMENT:                                         PTI0-003
C  KTF(7,7),CVF(7,6),VX,VS,VD,VT,INM,NT,CA  SAME AS IN PTIP.            PTI0-004
C  WT,XT     PARTICLE AND HOLE FUNCTIONS FOR THE CALCULATION OF THE     PTI0-005
C            EXCHANGE FORM-FACTORS FOR  THE SKYRME FORCE.               PTI0-006
C DATA PASSED OVER BY THE COMMON /NOMBR/: SAME AS IN PTIP.              PTI0-007
C RESULTS:   VD(INM,I) FORM-FACTORS                                     PTI0-008
C WORKING AREA:  VS(INM,I) WITH I=7 TO 16.                              PTI0-009
C MEANING OF INTERNAL VARIABLES:                                        PTI0-010
C LOO(1) ARITHMETIC AVERAGE   LOO(2) SECOND TIME FOR ARITHM. AVERAGE    PTI0-011
C LOO(3) PREVIOUS STEPS WERE NOT DONE AGAIN  LOO(4) SAME FORM FACTOR    PTI0-012
C FOR I=1,2   X0(I) * F * G * V * V /R**2 FROM VD(1)                    PTI0-013
C FOR I=14,15 X0(I) * F * G * V * V /R**2 FROM VD(37)                   PTI0-014
C FOR I=21,25 X0(I) * F * G * V * V /R**3 FROM VD(25)                   PTI0-015
C FOR I=3,11  X0(I) * F * G * V * V /R**4 FROM VD(1)                    PTI0-016
C FOR I=12,13 X0(I) * V/R D**2/DR**2 ( 1/R * F * G * V ) FROM VD(1)     PTI0-017
C FOR I=16,20 X0(I) * V/R**2 * D/DR ( 1/R * F * G * V ) FROM VD(1)      PTI0-018
C FOR I=14,15 X0(I) * F * V/R D**2/DR**2 ( 1/R * G * V ) FROM VD(1)     PTI0-019
C FOR I=14,15 X0(I) * F * 2 * V/R D/DR ( 1/R * G * V ) FROM VD(25)      PTI0-020
C FOR I=21,25 X0(I) * F * V/R**2 * D/DR ( 1/R  * G * V ) FROM VD(1)     PTI0-021
C***********************************************************************PTI0-022
      IMPLICIT REAL*8 (A-H,O-Z)                                         PTI0-023
      LOGICAL LO,LOO(4)                                                 PTI0-024
      DIMENSION KTF(7,7),CVF(7,6),VX(INM,1),VS(INM,1),VD(INM,1),VA(2,10)PTI0-025
     1,R0(3,4),S0(4,9),X0(2,25),SL(2,10),WT(1),XT(1),VT(INM,8),IBD(9),IBPTI0-026
     2F(9),IBA(9),IDD(9),IB1(9),IB2(9),IBT(9),BB(9),IBK(7),ABK(7)       PTI0-027
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),PTI0-028
     1LO(40)                                                            PTI0-029
      DATA IBD /1,14,21,3,12,16,14,14,21/                               PTI0-030
      DATA IBF /2,15,25,11,13,20,15,15,25/                              PTI0-031
      DATA IBA,IK,IS1 /6*1,3*7,2*0/                                     PTI0-032
      DATA IDD /4*1,3,2,3,2,2/                                          PTI0-033
      DATA IB1 /4*2,5*1/                                                PTI0-034
      DATA IB2 /2*0,1,2,1,2,2*1,2/                                      PTI0-035
      DATA IBT /1,37,25,4*1,25,1/                                       PTI0-036
      DATA IBK /6,9,6,9,3,7,10/                                         PTI0-037
      DATA ABK /-1.D0,1.D0,1.5D0,-1.5D0,-2.D0,2*-96.D0/                 PTI0-038
      DATA BB /7*1.,2.,1./                                              PTI0-039
      CALL PTC0(R0,S0,SL)                                               PTI0-040
C LOOP OVER RADIAL DEPENDENCES                                          PTI0-041
      DO 31 KX=1,KY                                                     PTI0-042
      KZ=KX-1                                                           PTI0-043
C LOOP OVER THE RANGES                                                  PTI0-044
      DO 1 I=1,20                                                       PTI0-045
    1 VA(I,1)=0.D0                                                      PTI0-046
      IX=0                                                              PTI0-047
C LOOP OVER THE INTERACTIONS FOR THE SUM OF THEIR STRENGTHS             PTI0-048
      DO 4 III=1,10                                                     PTI0-049
      II=III                                                            PTI0-050
      NZ=NT                                                             PTI0-051
      CCA=CA                                                            PTI0-052
      IF (III.GT.7) II=II-3                                             PTI0-053
      IF (KTF(II,NZ).NE.KX) GO TO 4                                     PTI0-054
      IF (II.NE.III) NZ=2*NT-1                                          PTI0-055
      IX=II                                                             PTI0-056
      KW=KTF(IX,NZ+3)-1                                                 PTI0-057
      IF (III.EQ.4) GO TO 2                                             PTI0-058
      VA(1,III)=VA(1,III)+CCA*CVF(II,NZ)                                PTI0-059
      VA(2,III)=VA(2,III)+CCA*CVF(II,NZ+3)                              PTI0-060
      GO TO 4                                                           PTI0-061
    2 NS=3                                                              PTI0-062
      IF (LO(25)) NS=1                                                  PTI0-063
      DO 3 K=NS,7                                                       PTI0-064
      L=IBK(K)                                                          PTI0-065
      VA(1,L)=VA(1,L)+CCA*CVF(4,NT)/ABK(K)                              PTI0-066
    3 VA(2,L)=VA(2,L)+CCA*CVF(4,NT+3)/ABK(K)                            PTI0-067
    4 CONTINUE                                                          PTI0-068
      IF (IX.EQ.0) GO TO 31                                             PTI0-069
C COMPUTATION OF THE TABLE OF COEFFICIENTS X0:                          PTI0-070
      DO 8 L=1,2                                                        PTI0-071
      X0(L,1)=R0(1,1)*VA(L,1)+R0(2,1)*VA(L,2)                           PTI0-072
      X0(L,2)=R0(1,2)*VA(L,1)+R0(2,2)*VA(L,2)                           PTI0-073
      DO 5 I=1,9                                                        PTI0-074
    5 X0(L,I+2)=-S0(1,I)*VA(L,8)-S0(2,I)*VA(L,9)+S0(3,I)*VA(L,10)+S0(4,IPTI0-075
     1)*VA(L,3)                                                         PTI0-076
      DO 6 I=1,2                                                        PTI0-077
      X0(L,I+2)=X0(L,I+2)+R0(1,I+2)*VA(L,5)+R0(2,I+2)*VA(L,6)+R0(3,I+2)*PTI0-078
     1VA(L,7)                                                           PTI0-079
      X0(L,I+11)=(R0(1,I)*VA(L,5)+R0(2,I)*VA(L,6)+R0(3,I)*VA(L,7))/H**2 PTI0-080
    6 X0(L,I+13)=(R0(2,I)*VA(L,9)-R0(1,I)*VA(L,8)-R0(3,I)*VA(L,10))/H**2PTI0-081
      DO 7 I=1,5                                                        PTI0-082
      X0(L,I+15)=(SL(2,I)*VA(L,3)+SL(1,I)*VA(L,7))/H                    PTI0-083
    7 X0(L,I+20)=(SL(2,I+5)*VA(L,3)+SL(1,I+5)*VA(L,10))/H               PTI0-084
    8 CONTINUE                                                          PTI0-085
      LOO(1)=KTF(IX,7).NE.0                                             PTI0-086
      LOO(2)=.FALSE.                                                    PTI0-087
    9 LOO(3)=.FALSE.                                                    PTI0-088
      IA=0                                                              PTI0-089
C LOOP ON COEFFICIENTS                                                  PTI0-090
      DO 30 JJ=1,9                                                      PTI0-091
      J1=IBD(JJ)                                                        PTI0-092
      J2=IBF(JJ)                                                        PTI0-093
      LOO(4)=.FALSE.                                                    PTI0-094
      DO 29 JB=J1,J2                                                    PTI0-095
      IF ((X0(1,JB).EQ.0.).AND.(X0(2,JB).EQ.0.)) GO TO 29               PTI0-096
      IF (LOO(4)) GO TO 27                                              PTI0-097
      LOO(3)=IA.EQ.IBA(JJ)                                              PTI0-098
      IF (LOO(3)) GO TO 16                                              PTI0-099
      IA=IBA(JJ)                                                        PTI0-100
      IF (IA.EQ.1) GO TO 11                                             PTI0-101
      DO 10 I=1,INM                                                     PTI0-102
      VT(I,7)=WT(I)                                                     PTI0-103
   10 VT(I,8)=0.D0                                                      PTI0-104
   11 IB=IA                                                             PTI0-105
      IF (KZ.EQ.0.OR.LOO(2)) GO TO 16                                   PTI0-106
C MULTIPLICATION BY THE RADIAL DEPENDENCES                              PTI0-107
      IB=9                                                              PTI0-108
      IKX=1                                                             PTI0-109
      IX=IA                                                             PTI0-110
      IY=IB                                                             PTI0-111
   12 DO 13 I=1,INM                                                     PTI0-112
      VT(I,IY)=VT(I,IX)*VX(I,KZ)                                        PTI0-113
   13 VT(I,IY+1)=VT(I,IX+1)*VX(I,KZ)                                    PTI0-114
      IF (KW.EQ.KZ) GO TO 15                                            PTI0-115
      DO 14 I=1,INM                                                     PTI0-116
      VT(I,IY)=VT(I,IY)-VT(I,IX+1)*VX(I,KW)                             PTI0-117
   14 VT(I,IY+1)=VT(I,IY+1)+VT(I,IX)*VX(I,KW)                           PTI0-118
   15 IF (IKX.EQ.2) GO TO 25                                            PTI0-119
   16 LOO(3)=LOO(3).AND.(IS1.EQ.IB1(JJ))                                PTI0-120
      IF (LOO(3)) GO TO 19                                              PTI0-121
      IS1=IB1(JJ)                                                       PTI0-122
      IX=IB                                                             PTI0-123
      IY=11                                                             PTI0-124
      IS=IS1                                                            PTI0-125
      IC=11                                                             PTI0-126
      IKX=1                                                             PTI0-127
C DIVISION BY POWER OF R                                                PTI0-128
   17 DO 18 I=1,INM                                                     PTI0-129
      VT(I,IY)=VT(I,IX)/VS(I,IS)                                        PTI0-130
   18 VT(I,IY+1)=VT(I,IX+1)/VS(I,IS)                                    PTI0-131
      IF (IKX.EQ.2) GO TO 27                                            PTI0-132
   19 LOO(3)=LOO(3).AND.(IK.EQ.IDD(JJ))                                 PTI0-133
      IF (LOO(3)) GO TO 26                                              PTI0-134
      IK=IDD(JJ)                                                        PTI0-135
      ID=11                                                             PTI0-136
      IF (IK.GT.1) ID=ID+2                                              PTI0-137
      GO TO ( 24 , 21 , 20 ) , IK                                       PTI0-138
   20 CALL DER2(VT(1,IC),VT(1,ID),INM)                                  PTI0-139
      CALL DER2(VT(1,IC+1),VT(1,ID+1),INM)                              PTI0-140
      GO TO 22                                                          PTI0-141
   21 CALL DERI(VT(1,IC),VT(1,ID),INM)                                  PTI0-142
      CALL DERI(VT(1,IC+1),VT(1,ID+1),INM)                              PTI0-143
   22 IF (IA.EQ.1) GO TO 24                                             PTI0-144
      DO 23 I=1,INM                                                     PTI0-145
      VT(I,ID)=VT(I,ID)*XT(I)                                           PTI0-146
   23 VT(I,ID+1)=VT(I,ID+1)*XT(I)                                       PTI0-147
   24 IKX=2                                                             PTI0-148
      IE=ID                                                             PTI0-149
      IF ((KZ.EQ.0).OR.(LOO(1).AND.(.NOT.LOO(2)))) GO TO 25             PTI0-150
      IE=15                                                             PTI0-151
      IX=ID                                                             PTI0-152
      IY=15                                                             PTI0-153
      GO TO 12                                                          PTI0-154
   25 IS2=-1                                                            PTI0-155
   26 LOO(3)=LOO(3).AND.(IS2.EQ.IB2(JJ))                                PTI0-156
      IE=ID                                                             PTI0-157
      ISA=IS2                                                           PTI0-158
      IS2=IB2(JJ)                                                       PTI0-159
      IS=IS2                                                            PTI0-160
      IF (ISA.NE.-1) IS=IS-ISA                                          PTI0-161
      IF (IS.EQ.0) GO TO 27                                             PTI0-162
      IY=IE                                                             PTI0-163
      IX=IE                                                             PTI0-164
      IE=IY                                                             PTI0-165
      GO TO 17                                                          PTI0-166
   27 IG=IBT(JJ)+2*(JB-J1)                                              PTI0-167
      LOO(4)=.TRUE.                                                     PTI0-168
      Z1=BB(JJ)*X0(1,JB)                                                PTI0-169
      Y1=BB(JJ)*X0(2,JB)                                                PTI0-170
      DO 28 I=1,INM                                                     PTI0-171
      VD(I,IG)=VD(I,IG)+Z1*VT(I,IE)-Y1*VT(I,IE+1)                       PTI0-172
   28 VD(I,IG+1)=VD(I,IG+1)+Z1*VT(I,IE+1)+Y1*VT(I,IE)                   PTI0-173
   29 CONTINUE                                                          PTI0-174
   30 CONTINUE                                                          PTI0-175
      IF (.NOT.LOO(1)) GO TO 31                                         PTI0-176
      LOO(2)=.NOT.LOO(2)                                                PTI0-177
      IF (LOO(2)) GO TO 9                                               PTI0-178
   31 CONTINUE                                                          PTI0-179
      RETURN                                                            PTI0-180
      END                                                               PTI0-181
