C 24/03/97                                                      DWBA98  CORA-000
      SUBROUTINE CORA(L,B,C,D,E,F,T,LL,LQ,LT)                           CORA-001
C CALCULATE THE INTEGRAL COEFFICIENTS (0,2;L) AND THE COULOMB FUNCTIONS CORA-002
C AT THE MATCHING POINT TO OBTAIN (LQ,LL+1;L) FOR LL<5                  CORA-003
C INPUTS:          L    ANGULAR MOMENTUM                                CORA-004
C                  D    AVERAGE VALUE OF E AND F                        CORA-005
C                  E,F  EI,EF   COULOMB PARAMETERS                      CORA-006
C                  T    RADIUS                                          CORA-007
C                  LT   LOGICAL, LT=.TRUE. FOR INTEGRALS BEGINNING AT 0 CORA-008
C OUTPUTS:         B    COEFFICIENTS FOR THE HOMOGENEOUS TERM           CORA-009
C                  C    COEFFICIENTS FOR THE INHOMOGENEOUS TERM         CORA-010
C***********************************************************************CORA-011
      IMPLICIT REAL*8 (A-H,O-Z)                                         CORA-012
      LOGICAL LT                                                        CORA-013
      DIMENSION B(4),C(4)                                               CORA-014
      A=L                                                               CORA-015
      G=F**2                                                            CORA-016
      H=E**2                                                            CORA-017
      X=T/D                                                             CORA-018
      Y=T**2                                                            CORA-019
      GO TO ( 1 , 2 , 4 , 6 ),LL                                        CORA-020
C CALCULATION FOR LF=LI+1 AND IQ=1                                      CORA-021
    1 IF (E.EQ.F) GO TO 10                                              CORA-022
      B1=(H-G)*(A+2.D0)                                                 CORA-023
      B2=(A+2.D0)**2+G                                                  CORA-024
      B3=2.D0*(A+1.D0)*H*B2+(A+2.D0)*B1                                 CORA-025
      B(1)=-(2.D0*A+1.D0)*B3*DSQRT((A+1.D0)**2+G)/(B1*F*(4.D0*A+6.D0))  CORA-026
      B(2)=(B3*((6.D0*A+13.D0)*G*H+(A+1.D0)*((A+1.D0)*(2.D0*A+5.D0)*H+((CORA-027
     14.D0*A+19.D0)*A+23.D0)*G))+(A+3.D0)**2*G**2*((4.D0*A+5.D0)*H-(2.D0CORA-028
     2*A+3.D0)*H**2/G+2.D0*(A+1.D0)*(A+2.D0)**2))/(2.D0*B1*E*G*(2.D0*A+5CORA-029
     3.D0)*DSQRT((A+1.D0)**2+H))                                        CORA-030
      B(3)=-(A+1.D0)*(3.D0*B3+5.D0*G*H+(2.D0*A+3.D0)*((A+2.5D0)*A+.5D0)*CORA-031
     1(G-H)+((9.D0*A+36.D0)*A+35.D0)*G)*DSQRT(B2*((A+2.D0)**2+H)/((A+1.DCORA-032
     20)**2+H))/(F*B1*(2.D0*A+3.D0))                                    CORA-033
      B(4)=(2.D0*A+7.D0)*(A+1.D0)*E*DSQRT(B2*((A+2.D0)**2+H)*((A+3.D0)**CORA-034
     12+G)*((A+3.D0)**2+H)/((A+1.D0)**2+H))/(B1*(2.D0*A+5.D0))          CORA-035
      IF (LT) RETURN                                                    CORA-036
      C1=Y*H/(D*B1)                                                     CORA-037
      C2=(A+1.D0)*(A+3.D0)**2                                           CORA-038
      C(1)=C1*(((2.D0*A+8.D0)*A+10.D0)*B2+.5D0*(A+1.D0)*(A+2.D0)*B1/H)  CORA-039
      C(2)=-C1*F*(A+4.D0+X*(A+2.D0)*(A+3.D0)**2)*(2.D0*A+5.D0)*DSQRT(B2)CORA-040
      C(3)=-C1*E*B2*(2.D0*A+3.D0)*(A+5.D0+X*C2)/DSQRT((A+1.D0)**2+H)    CORA-041
      C(4)=C1*(((2.D0*A+18.D0)*A+25.D0)*G*H-(A+1.D0)*(A+2.D0)*((A+1.D0)*CORA-042
     1(A+1.5D0)*(H+G)+(3.D0*A+7.D0)*G)+X*H*G*((2.D0*A+11.D0)*A+13.D0+X*CCORA-043
     22*(A+2.D0))*4.D0*(A+1.5D0)*(A+2.5D0))*DSQRT(B2/((A+1.D0)**2+H))/(ECORA-044
     3*F)                                                               CORA-045
      RETURN                                                            CORA-046
    2 IF (LQ.NE.0) GO TO 3                                              CORA-047
C CALCULATION FOR LF=LI AND IQ=2                                        CORA-048
      B(1)=-.5D0*(2.D0*A-1.D0)*(A+1.D0)*DSQRT((A**2+G)*(A**2+H))/(D*A*(2CORA-049
     1.D0*A+1.D0))                                                      CORA-050
      B(2)=.5D0*((E/F+F/E)*A*(A+1.D0)+E*F*((A+1.D0)*2.D0*A-1.D0)/(A*(A+1CORA-051
     1.D0)))/D                                                          CORA-052
      B(3)=-.5D0*(2.D0*A+3.D0)*A*DSQRT(((A+1.D0)**2+H)*((A+1.D0)**2+G))/CORA-053
     1(D*(2.D0*A+1.D0)*(A+1.D0))                                        CORA-054
      B(4)=0.D0                                                         CORA-055
      IF (LT) RETURN                                                    CORA-056
      C(1)=Y*(A-.5D0+X*A*(A+1.D0)*(A+.5D0))                             CORA-057
      C(2)=-Y*A*DSQRT((A+1.D0)**2+G)/(2.D0*F)                           CORA-058
      C(3)=-Y*A*DSQRT((A+1.D0)**2+H)/(2.D0*E)                           CORA-059
      C(4)=0.D0                                                         CORA-060
      RETURN                                                            CORA-061
C CALCULATION FOR LF=LI+2 AND IQ=2                                      CORA-062
    3 B(1)=-(2.D0*A+1.D0)*DSQRT(((A+2.D0)**2+G)*((A+1.D0)**2+G))*D/(6.D0CORA-063
     1*G)                                                               CORA-064
      B1=(A+1.D0)*((4.D0*A+19.D0)*A+23.D0)                              CORA-065
      B(2)=(6.D0*(A+2.D0)*H+(A+1.D0)**2*(2.D0*A+5.D0)*H/G+B1)*(2.D0*A+3.CORA-066
     1D0)*DSQRT(((A+2.D0)**2+G)/((A+1.D0)**2+H))/(D*(12.D0*A+30.D0))    CORA-067
      B(3)=-(3.D0*(2.D0*A+3.D0)*E*F+2.D0*(A+1.D0)*(A+3.D0)**2*F/E+B1*E/FCORA-068
     1)*DSQRT(((A+2.D0)**2+H)/((A+1.D0)**2+H))/(6.D0*D)                 CORA-069
      B(4)=(2.D0*A+7.D0)*(A+1.D0)*DSQRT(((A+2.D0)**2+H)*((A+3.D0)**2+G)*CORA-070
     1((A+3.D0)**2+H)/((A+1.D0)**2+H))/(D*(6.D0*A+15.D0))               CORA-071
      IF (LT) RETURN                                                    CORA-072
      C1=(4.D0*A+17.D0)*A+3.D0                                          CORA-073
      C2=Y/(6.D0*F*(A+3.D0))                                            CORA-074
      C(1)=C2*(((A+4.D0)*4.D0*A+7.D0)*A-21.D0+X*(A+1.D0)*(A+2.D0)*(A+3.DCORA-075
     10)*(2.D0*A+3.D0)*(2.D0*A+5.D0))*F                                 CORA-076
      C(2)=-C2*(A+2.D0)*(C1+18.D0)*DSQRT((A+3.D0)**2+G)                 CORA-077
      C(3)=-C2*(A+2.D0)*(E*F*C1+(A+1.D0)*(A+3.D0)*((A+1.D0)*(2.D0*A+3.D0CORA-078
     1)*E/F+2.D0*(A+3.D0)**2*F/E))/DSQRT((A+1.D0)**2+H)                 CORA-079
      C(4)=2.D0*C2*(A+5.D0+X*(A+1.D0)*(A+3.D0)**2)*(2*A+3.D0)*(A+2.D0)*DCORA-080
     1SQRT(((A+3.D0)**2+G)/((A+1.D0)**2+H))*E                           CORA-081
      RETURN                                                            CORA-082
    4 IF (LQ.GT.1) GO TO 5                                              CORA-083
C CALCULATION FOR LF=LI+1 AND IQ=3                                      CORA-084
      B1=2.D0*(A+2.D0)*A+1.D0                                           CORA-085
      B(1)=-(2.D0*A-1.D0)*DSQRT((A**2+G)*(A**2+H)*((A+1.D0)**2+G))/(6.D0CORA-086
     1*F*A*(2.D0*A+1.D0))                                               CORA-087
      B(2)=(3.D0*(B1-A-2.D0)*G*H+A*(A+1.D0)*(A*(2.D0*A+3.D0)*H+2.D0*B1*GCORA-088
     1))*DSQRT((A+1.D0)**2+G)/(6.D0*E*G*A*(A+1.D0)*(2.D0*A+3.D0))       CORA-089
      B(3)=-(3.D0*(B1+A)*H*G+(A+1.D0)*(A+2.D0)*(2.D0*B1*H+(B1+A+1.D0)*G)CORA-090
     1)*DSQRT((A+1.D0)**2+H)/(6.D0*F*H*(A+1.D0)*(A+2.D0)*(2.D0*A+1.D0)) CORA-091
      B(4)=(2.D0*A+5.D0)*DSQRT(((A+1.D0)**2+H)*((A+2.D0)**2+G)*((A+2.D0)CORA-092
     1**2+H))/(6.D0*E*(A+2.D0)*(2.D0*A+3.D0))                           CORA-093
      IF (LT) RETURN                                                    CORA-094
      C1=Y/(6.D0*D*(A+2.D0))                                            CORA-095
      C2=A*(A+2.D0)*(2.D0*A+3.D0)                                       CORA-096
      C(1)=C1*(((A-1.D0)*2.D0*A-7.D0)/(A+1.D0)-(A+1.D0)*(A+2.D0)*(A/G+(ACORA-097
     1+2.D0)/H)+X*(4.D0*C2-(A+1.D0)*(8.D0*A+10.D0-X*C2*(2.D0*A+1.D0))))*CORA-098
     2E*F                                                               CORA-099
      C(2)=-E*C1*((2.D0*A-1.D0)+A*(B1-A)*X)*DSQRT((A+2.D0)**2+G)        CORA-100
      C(3)=-F*C1*(((2.D0*A+1.D0)*A-4.D0)/(A+1.D0)+C2*X)*DSQRT((A+1.D0)**CORA-101
     12+H)                                                              CORA-102
      C(4)=2.D0*C1*(A+1.D0)*DSQRT(((A+1.D0)**2+H)*((A+2.D0)**2+G))      CORA-103
      RETURN                                                            CORA-104
C CALCULATION FOR LF=LI+3 AND IQ=3                                      CORA-105
    5 B1=(A+2.D0)*(A+3.D0)                                              CORA-106
      B2=2.D0*(A+1.D0)*B1                                               CORA-107
      B3=3.D0*H*G+(B2+B1)*H-B2*G                                        CORA-108
      B4=(2.D0*A+3.D0)*(2.D0*A+5.D0)                                    CORA-109
      B5=(A+1.D0)*(A+2.D0)                                              CORA-110
      B(1)=-(2.D0*A+1.D0)*B3*DSQRT(((A+1.D0)**2+G)*((A+2.D0)**2+G)/((A+3CORA-111
     1.D0)**2+G))/(30.D0*(A+2.D0)*(2.D0*A+3.D0)*E*G)                    CORA-112
      B(2)=((36.D0*A+78.D0)*G*H+(B2*12.D0*(A+3.D0)+(6.D0*A+48.D0)*A+75.DCORA-113
     10)*H-(B2*12.D0*(A+1.D0)+(18.D0*A+42.D0)*A+9.D0)*G+B2*(B4*(A+1.D0)*CORA-114
     2H/G+(B4*(A+4.D0)-1.D0)-(2.D0*B4*(A+2.D0)-(A+1.D0)*(2.D0*A+5.D0))*GCORA-115
     3/H))*DSQRT(((A+2.D0)**2+G)/(((A+1.D0)**2+H)*((A+3.D0)**2+G)))/(60.CORA-116
     4D0*F*(A+2.D0)*(2.D0*A+5.D0))                                      CORA-117
      B(3)=-((36.D0*A+66.D0)*G*H+(B2*12.D0*(A+3.D0)+(18.D0*A+102.D0)*A+1CORA-118
     129.D0)*H-(B2*12.D0*(A+1.D0)+6.D0*A**2-21.D0)*G+B2*((B4*(2.D0*A+5.DCORA-119
     20)-(A+2.D0)*(2.D0*A+3.D0))*H/G-(A*B4+1.D0)-(A+3.D0)*B4*G/H))*DSQRTCORA-120
     3(((A+2.D0)**2+H)/(((A+1.D0)**2+H)*((A+3.D0)**2+G)))/(60.D0*E*(A+2.CORA-121
     4D0)*(2.D0*A+3.D0))                                                CORA-122
      B(4)=(2.D0*A+7.D0)*(3.D0*G+B2-(B2-B5)*G/H)*DSQRT(((A+2.D0)**2+H)*(CORA-123
     1(A+3.D0)**2+H)/((A+1.D0)**2+H))/(30.D0*F*(A+2.D0)*(2.D0*A+5.D0))  CORA-124
      IF (LT) RETURN                                                    CORA-125
      C1=Y/(30.D0*D*(A+1.D0)*(A+4.D0)*((A+3.D0)**2+G))                  CORA-126
      C2=(A+1.D0)*(A+3.D0)                                              CORA-127
      C(1)=C1*((A+3.D0)*(2.D0*(A-4.D0)*B3*G-((B1+2.D0)*A+4.D0)*G**2-(B1*CORA-128
     1(5.D0*A+16.D0)-6.D0*A-3.D0)*G*H+B2*(2.D0+.5D0*A)*((4.D0*C2+7.D0)*(CORA-129
     2G-H)-(A+2.D0)*(H+G)))+X*G*(((B2-2.5D0)*(4.D0*A+10.D0)-30.D0*B1)*B3CORA-130
     3+5.D0*(A+3.D0)*(A+4.D0)*(2.D0*B5*G-((A+2.D0)*2.D0*A-3.D0)*H)+X*C2*CORA-131
     4B3*(2.D0*A+5.D0)*(2.D0*A+7.D0)*(A+1.D0)*(A+4.D0)))/(E*F)          CORA-132
      C(2)=-C1*(((6.D0*A+9.D0)*A-12.D0)*G*H+C2*(((4.D0*C2-5.D0)*A-21.D0)CORA-133
     1*H-(2.D0*A+5.D0)*(2.D0*G*(A-1.D0)*(A+2.D0)-(A+1.D0)*X*B3)))*DSQRT(CORA-134
     2(A+4.D0)**2+G)/E                                                  CORA-135
      C(3)=-C1*((B3+3.D0*G*A*(A+2.D0))*((2.D0*A+3.D0)*A-19.D0+X*(A+4.D0)CORA-136
     1*(B2+(7.D0*A+18.D0)*A-14.D0))+(16.D0*B2+(18.D0*A+4.5D0)*A-73.5D0)*CORA-137
     2G-(16.D0*B2+40.D0*B1-22.5D0*A-52.5D0)*H+C2*((4.D0*A+42.D0)*A+74.D0CORA-138
     3-(A+2.D0)*(18.D0*A+66.D0)*H/G+B2*(2.D0*(A+3.D0)*(A+10.D0)+1.5D0-(ACORA-139
     4+3.5D0)*(13.D0*H/G+(2.D0*A+5.D0)*G/H)))+X*(A+4.D0)*((A+3.D0)*(32.5CORA-140
     5D0*A+57.5D0)*H-(10.5D0*B1+49.5D0*A+103.5D0)*G+B2*((7.D0*A+57.D0)*GCORA-141
     6-(7.D0*A+17.D0)*H+C2*(B2+(10.D0*A+53.5D0)*A+66.5D0-(A+3.D0)*(A+3.5CORA-142
     7D0)*(2.D0*A+5.D0)*G/H-((3.D0*A+15.5D0)*A+16.5D0)*H/G))))*F/DSQRT((CORA-143
     8A+1.D0)**2+H)                                                     CORA-144
      C(4)=C1*((6.D0*C2-15.D0)*G*H+C2*(2.D0*(B2-7.D0*A-14.D0)*(H-G)+(4.DCORA-145
     10*C2+5.5D0)*(G+H)+B2*((A+1.5D0)*(A+1.D0)*H/G+4.D0*A+8.D0-(A+3.D0)*CORA-146
     2(A+2.5D0)*G/H)))*DSQRT(((A+4.D0)**2+G)/((A+1.D0)**2+H))           CORA-147
      RETURN                                                            CORA-148
    6 IF (LQ-2) 7 , 8 , 9                                               CORA-149
C CALCULATION FOR LF=LI AND IQ=4                                        CORA-150
    7 B(1)=-(2.D0*A-3.D0)*DSQRT(((A-1.D0)**2+G)*((A-1.D0)**2+H)*(A**2+G)CORA-151
     1*(A**2+H))/(6.D0*D*A*(A-1.D0)*(A+2.D0)*(2.D0*A-1.D0))             CORA-152
      B1=(4.D0*A-6.D0)*G*H                                              CORA-153
      B(2)=(3.D0*B1+(A-1.D0)*((6.D0*A-1.D0)*A-3.D0)*(H+G))*DSQRT((A**2+HCORA-154
     1)*(A**2+G))/(12.D0*D*E*F*(A+2.D0)*A*(A-1.D0)*(2.D0*A+1.D0))       CORA-155
      B(3)=-(3.D0*B1+(((12.D0*A-2.D0)*A-14.D0)*A+3.D0)*(G+H)+A**2*(A+1.DCORA-156
     10)*(((2.D0*A+1.D0)*A-1.D0)*(G/H+H/G)+4.D0*(2.D0*A**2-1.D0)))/(12.DCORA-157
     20*D*A*(A+1.D0)*(A+2.D0)*(2.D0*A-1.D0))                            CORA-158
      B(4)=(B1+A**2*(2.D0*A+3.D0)*(H+G))*DSQRT(((A+1.D0)**2+H)*((A+1.D0)CORA-159
     1**2+G))/(12.D0*D*E*F*A*(A+1.D0)*(A+2.D0)*(2.D0*A+1.D0))           CORA-160
      IF (LT) RETURN                                                    CORA-161
      C1=Y/(6.D0*(A+1.D0)**2*(A+2.D0))                                  CORA-162
      C2=(2.D0*A-3)+A*(A-1.D0)*(2.D0*A-1.D0)*X                          CORA-163
      C3=(A+1.D0)*(2.D0*A+1.D0)*C2+A*((A-1.D0)*4.D0*A-2.D0)             CORA-164
      C(1)=(B1-(A+1.D0)*((6.D0*A-1.D0)*A-3.D0)*(H+G)+X*((((36.D0*A-6.D0)CORA-165
     1*A-54.D0)*A-24.D0)*H*G-A*(A+1.D0)**2*(2.D0*A+1.D0)*(3.D0*A-1.D0)*(CORA-166
     2H+G)+2.D0*X*G*H*(A+1.D0)*((((8.D0*A-4.D0)*A-8.D0)*A-5.D0)*A-3.D0+(CORA-167
     32.D0*A+1.D0)*C3)))*C1/(2.D0*E*F)                                  CORA-168
      C(2)=-((B1-A*(A+1.D0)*((A+1.D0)*H+(3.D0*A-1.D0)*G))/(2.D0*H*G)+C3*CORA-169
     1X)*E*DSQRT((A+1.D0)**2+G)*C1                                      CORA-170
      C(3)=-((B1-A*(A+1.D0)*((3.D0*A-1.D0)*H+(A+1.D0)*G))/(2.D0*H*G)+C3*CORA-171
     1X)*F*DSQRT((A+1.D0)**2+H)*C1                                      CORA-172
      C(4)=C1*C2*DSQRT(((A+1.D0)**2+H)*((A+1.D0)**2+G))                 CORA-173
      RETURN                                                            CORA-174
C CALCULATION FOR LF=LI+2 AND IQ=4                                      CORA-175
    8 B1=2.D0*(A+1.D0)*(A+2.D0)                                         CORA-176
      B2=3.D0*H*G+B1*((A+3.D0)*H-A*G)                                   CORA-177
      B3=(2.D0*A-1.D0)*B2                                               CORA-178
      B4=A*(A+1.D0)*(A+3.D0)                                            CORA-179
      B5=B1*(A+3.D0)                                                    CORA-180
      B(1)=-B3*DSQRT((A**2+H)*(A**2+G)*((A+1.D0)**2+G)/((A+2.D0)**2+G))*CORA-181
     2D/(60.D0*G*H*B4*(2.D0*A+1.D0))                                    CORA-182
      B(2)=(6.D0*B3*G*H+A*((((16.D0*A+62.D0)*A+65.D0)*H-((4.D0*A+28.D0)*CORA-183
     1A+25.D0)*G)*B2-B5*(((12.D0*A+14.D0)*A+2.D0)*(G-H)**2+(42.D0*A+63.DCORA-184
     20)*H*(H-G)+36.D0*H*G)))*DSQRT(((A+1.D0)**2+G)/((A+2.D0)**2+G))/(12CORA-185
     30.D0*D*G*H*B4*(2.D0*A+3.D0))                                      CORA-186
      B(3)=-(6.D0*B3*G*H+(A+2.D0)*((((32.D0*A+82.D0)*A+31.D0)*H-((20.D0*CORA-187
     1A+32.D0)*A+11.D0)*G)*B2-B1*(6.D0*A+3.D0)*(((2.D0*A+5.D0)*(G-H))**2CORA-188
     2+(14.D0*A+35.D0)*G*(H-G)+12.D0*G**2)))*DSQRT(((A+1.D0)**2+H)/((A+2CORA-189
     3.D0)**2+G))*D/(60.D0*G*H**2*B5*(2.D0*A+1.D0))                     CORA-190
      B(4)=(B3+1.5D0*B1*((6.D0*A+17.D0)*(H-G)+12.D0*G))*DSQRT(((A+1.D0)*CORA-191
     2*2+H)*((A+2.D0)**2+H))/(30.D0*D*H*B5*(2.D0*A+3.D0))               CORA-192
      IF (LT) RETURN                                                    CORA-193
      C1=Y/(60.D0*H*(A+1.D0)*(A+3.D0)**2*((A+2.D0)**2+G))               CORA-194
      C2=2.D0*(A+1.D0)*G-(2.D0*A+5.D0)*H                                CORA-195
      C3=(2.D0*A+3.D0)*(2.D0*A+5.D0)                                    CORA-196
      C(1)=C1*(B3*G*H+((A+1.D0)*(2.D0*A+5.D0)*(2.D0*A+6.5D0)*G-(5.D0*B5+CORA-197
     19.5D0*A+21.5D0)*H)*B2+B5*(2.D0*A+5.D0)*((A+1.D0)*(3.D0*A+1.D0)*(G-CORA-198
     2H)**2+(10.5D0*A+16.5D0)*H*(H-G)+9.D0*H*G)+X*((A+2.D0)*((2.D0*B2+(9CORA-199
     3.D0*A+18.D0)*B3+(A+3.D0)*((6.D0*G-15.D0*H)*B5+(A+1.D0)*(15.D0*A+35CORA-200
     4.5D0)*G+((12.D0*A-35.5D0)*A-107.5D0)*H))*G*H+.5D0*B5*(A+1.D0)*((A+CORA-201
     52.D0)*C3*(G-H)*(G+2.D0*H)+(2.D0*A+3.D0)*(6.D0*A+20.D0)*H*(H-4.D0*GCORA-202
     6)+(84.D0*A+120.D0)*G*H))+X*((49.D0*A+43.D0)*B2+(A+1.D0)*B3*(6.D0*BCORA-203
     75+4.D0*B1+27.D0*A+66.D0)+5.D0*B5*(A+3.D0)*C2+X*(2.D0*A+1.D0)*(A+2.CORA-204
     8D0)*C3*B2*B4)*G*H))/(E*F)                                         CORA-205
      C(2)=-C1*E*(B3+(A+2.D0)*(((A+1.D0)*(2.D0*A+6.5D0)/H-((4.D0*A+15.5DCORA-206
     10)*A+17.5D0)/G)*B2+B5*((A+1.D0)*(3.D0*A+1.D0)*(G/H+H/G-2.D0)+(10.5CORA-207
     2D0*A+16.5D0)*(H/G-1.D0)+9.D0))+X*((4.D0*A+3.D0)*B2+B1*(2.D0*B3+(A+CORA-208
     33.D0)*C2+X*A*(A+.5D0)*(2.D0*A+3.D0)*B2)))*DSQRT((A+3.D0)**2+G)    CORA-209
      C(3)=-C1*(B3*G+(A+2.D0)*(G*((A+1.D0)*(9.D0*A+39.D0)*G-(A+2.D0)*(15CORA-210
     1.D0*A+51.D0)*H)+B5*(((2.D0*A+3.5D0)*A+3.D0)*(G-H)-6.D0*(A+1.D0)*H)CORA-211
     2)+X*G*((4.D0*A+3.D0)*B2+(A+2.D0)*(A+3.D0)*(4.D0*B3+10.D0*(A+3.D0)*CORA-212
     3C2+X*A*B2*C3)))*DSQRT((A+1.D0)**2+H)/F                            CORA-213
      C(4)=C1*(6.D0*(A+2.D0)*C2+B2*((2.D0*A-1)+X*A*(A+2.D0)*(2.D0*A+3.D0CORA-214
     1)))*DSQRT(((A+3.D0)**2+G)*((A+1.D0)**2+H))                        CORA-215
      RETURN                                                            CORA-216
C CALCULATION FOR LF=LI+4 AND IQ=4                                      CORA-217
    9 B1=4.D0*(A+2.D0)*(A+3.D0)                                         CORA-218
      B2=(A+1.D0)*G-(A+4.D0)*H                                          CORA-219
      B3=2.D0*(A+1.D0)*(A+2.D0)                                         CORA-220
      B4=(A+2.D0)*(2.D0*A+3.D0)                                         CORA-221
      B5=B4+2.D0*(A+2.D0)                                               CORA-222
      B6=(A+1.D0)**2+H                                                  CORA-223
      B7=((A+3.D0)**2+G)*((A+4.D0)**2+G)                                CORA-224
      B8=3.D0*H*G*((14.D0*A+35.D0)*(H-G)+6.D0*(H+G))+B1*((A+4.D0)*(2.D0*CORA-225
     1A+3.D0)*H**2+(A+1.D0)*G*((2.D0*A+7.D0)*G-4.D0*(A+4.D0)*H))        CORA-226
      B9=B8-B1*(A+4.D0)*H**2+B3*((4.D0*A+19.D0)*H-(2.D0*A+7.D0)*G)*G    CORA-227
      B(1)=-(2.D0*A+1.D0)*B8*DSQRT(((A+1.D0)**2+G)*((A+2.D0)**2+G)/B7)/(CORA-228
     1840.D0*D*H*G*B4)                                                  CORA-229
      B(2)=((12.D0*A+26.D0+(2.D0*A+5.D0)*(((4.D0*A+13.D0)*A+11.D0)/H+2.DCORA-230
     10*(A+1.D0)**2/G))*B8+(2.D0*A+3.D0)*(3*B1*(A+3.D0)*B2-4.D0*B3*(A+2.CORA-231
     2D0)*(G-H)**2-(2.D0*A+5.D0)*(11.D0*A+61.D0)*H*(G-H)-12.D0*(A-1.D0)*CORA-232
     3G*H))*DSQRT(((A+2.D0)**2+G)/(B6*B7))*D/(1680.D0*H*G*B5)           CORA-233
      B(3)=-((12.D0*A+22.D0+(2.D0*A+3.D0)*(((4.D0*A+19.D0)*A+23.D0)/G+2.CORA-234
     1D0*(A+3.D0)**2/H))*B9+(2.D0*A+5.D0)*(6.D0*B6*(A+2.D0)*(5.D0*(H-G)-CORA-235
     22.D0*B2)+2.D0*B1*(A+4.D0)*(G-H)**2+G*(2.D0*A+1.D0)*(18.D0*G+17.D0*CORA-236
     3B2+21.D0*H)))*DSQRT(((A+2.D0)**2+H)/(B6*B7))/(1680.D0*D*H*B4)     CORA-237
      B(4)=(2.D0*A+7.D0)*B9*DSQRT(((A+3.D0)**2+H)*((A+2.D0)**2+H)/(B6*((CORA-238
     1A+4.D0)**2+G)))/(840.D0*D*E*F*H*B5)                               CORA-239
      IF (LT) RETURN                                                    CORA-240
      C1=Y/(840.D0*G*H**2*(A+1.D0)*(A+5.D0)*B7)                         CORA-241
      C2=(A+1.D0)*(A+3.D0)                                              CORA-242
      C3=(A+3.D0)*(A+4.D0)                                              CORA-243
      C4=(2.D0*A+5.D0)*(2.D0*A+7.D0)                                    CORA-244
      C5=60.D0*H**2*B7+(A+3.D0)*(2.D0*A-1.D0)*C4*B8                     CORA-245
      C6=-1.5D0*B2*B1*C3*H+G*(B3*(A+2.D0)*(2.D0*A+7.D0)*(G-H)**2+(A+3.5DCORA-246
     10)*((11.D0*A+93.D0)*A+172.D0)*H*(G-H)+6.D0*(A+2.D0)*(A+5.D0)*H**2)CORA-247
      C7=45.D0*G**2*H*(G-H)-B8*((A+4.D0)*((2.D0*A+7.5D0)*A+8.5D0)-G*(2.DCORA-248
     10*A-8.D0))+C6                                                     CORA-249
      C8=C5*G*H+C2*(45.D0*(2.D0*A+3.D0)*G**2*H**2*(G-H)+(.5D0*C3*C4*G-(ACORA-250
     1+4.D0)*(A+1.D0)*(3.D0*A+11.D0)*H-((6.D0*A+17.D0)*A-24.D0)*G*H)*B8-CORA-251
     25.D0*H*(C6+1.5D0*(A+4.D0)*H*(H-G)*((B1+4.D0*C3+4.D0)*G-B1*C3)))   CORA-252
      C9=(A+4.D0)*(A+5.D0)                                              CORA-253
      C(1)=C1*E*F*((2.D0*A+7.D0)*((30.D0*G*H+B1*(A+1.D0)*(A+3.5D0)*(G-H)CORA-254
     1+(A+4.5D0)*((11.D0*A+90.D0)*A+139.D0)*H)*G*(G-H)+6.D0*G*H**2*(A-3.CORA-255
     2D0)*(A+5.D0)-(((3.D0*A+22.5D0)*A+44.D0)*A+18.5D0-(A-7.D0)*G)*B8-6.CORA-256
     3D0*(A+3.D0)**2*((A+5.D0)*A+2.D0)*B2*H)+X*(G*C5+(A+3.D0)*(A+5.D0)*(CORA-257
     4(((10.D0*A+13.D0)*A-82.D0)*G-(A+4.D0)*((6.D0*C3+24.5D0)*A+81.5D0))CORA-258
     5*B8+(2.D0*A+9.D0)*(C6+45.D0*G**2*H*(G-H)))+G*X*(7.D0*(A+5.D0)*C5+CCORA-259
     62*C4*B8*((6.D0*A+29.D0)*A-1.D0+X*(A+1.D0)*C9*(2.D0*A+9.D0)))))    CORA-260
      C(2)=-C1*E*(C7*(A+3.D0)+X*G*(C5+X*(A+1.D0)**2*C3*C4*B8))*DSQRT((A+CORA-261
     15.D0)**2+G)                                                       CORA-262
      C(3)=-C1*F*(2.D1*G*H*(3.D0*H**2-39.D0*H*G-B8)+(A+3.D0)*(H*C7+3.D1*CORA-263
     1G*H**2*(G*(G-H)+45.D0*H-13.D0*G)-(A+1.D0)*(1.5D0*(A+5.D0)*B1*B2*C3CORA-264
     2*H+(((A+1.D0)**2*H/G+(A+2.5D0)*(A+3.D0))*C9-(A+4.D0)*(3.D0*A+7.5D0CORA-265
     3)*G+H*((A+33.D0)*A+97.5D0))*B8+((A+4.D0)*(((15.D0*A-201.5D0)*A-126CORA-266
     47.D0)*A-1666.5D0)*H+(((302.D0*A+2362.D0)*A+5542.D0)*A+3674.D0)*G)*CORA-267
     5H*(H-G)-((36.D0*A+588.D0)*A+132.D1)*G**2*H-(((58.D0*A+304.D0)*A+28CORA-268
     66.D0)*G**2-((95.D0*A+268.5D0)*A+1037.5D0)*G*H+((37.D0*A-53.5D0)*A+CORA-269
     7541.5D0)*H**2)*G*H))+X*(G*B6*C5+B8*((A+1.D0)*(C4*(A+3.D0)*(16.D0*ACORA-270
     8+37.D0)*G-(2.D0*A+9.D0)*(((16.D0*A+166.D0)*A+556.D0)*A+598.D0)*H)+CORA-271
     9G*H*(((32.D0*A+184.D0)*A+5.D1)*A-723.D0))+3.D0*G*H*(C2*(A+3.D0)*(8CORA-272
     A.D0*A+36.D0)*(C4*(A+5.D0)*(H-G)-((8.D0*A+25.D0)*A-1.D1)*H)-6.D1*G*CORA-273
     B*2*C2*(2.D0*A+7.D0)+H*(((((14.D1*A+2792.D0)*A+18257.D0)*A+4844.D1)CORA-274
     C*A+44595.D0)*G+96.D0*C3*C9*B2+((((2.D1*A+288.D0)*A+1867.D0)*A+594.CORA-275
     DD1)*A+7245.D0)*H+G*(((18.D1*A+134.D1)*A+2885.D0)*G+128.D0*C9*B2+((CORA-276
     E14.D1*A+15.D2)*A+3535.D0)*H)))+X*C8*((A+5.D0)**2+C9)))/DSQRT(B6)  CORA-277
      C(4)=C1*((H*G*((2.D0*A+3.D0)*A-19.D0)+(A+1.D0)*((A+3.D0)*.5D0*C4*GCORA-278
     1-(13.D0*(C3-A)-43.D0)*H))*B8-G*H*(6.D0*C2*(A+3.D0)*(2.D0*C4*G-(8.DCORA-279
     20*C3+A+4.D0)*H)-C2*(4.D0*A+14.D0)*(7.D0*A+8.D0)*(G-H)**2-(30.D0*(2CORA-280
     3.D0*A+5.D0)*G+((131.D0*A+1348.5D0)*A+4375.D0)*A+4417.5D0)*H*(G-H)+CORA-281
     4((30.D0*A+384.D0)*A+954.D0)*H**2)+X*C8)*DSQRT(((A+5.D0)**2+G)/B6) CORA-282
      RETURN                                                            CORA-283
C FORMULA FOR EI=EF AND IQ=1                                            CORA-284
   10 B(1)=0.D0                                                         CORA-285
      B(4)=0.D0                                                         CORA-286
      B1=DSQRT((A+1.D0)**2+H)                                           CORA-287
      B2=((A+2.D0)**2+H)/(2.D0*E*B1)                                    CORA-288
      B(2)=-(2.D0*A+3.D0)*B2                                            CORA-289
      B(3)=(2.D0*A+5.D0)*B2                                             CORA-290
      IF (LT) RETURN                                                    CORA-291
      C(1)=T/(2.D0*(A+1.D0))                                            CORA-292
      C1=DSQRT((A+2.D0)**2+H)                                           CORA-293
      C(2)=-C(1)*(A+2.D0)*C1/E                                          CORA-294
      C2=B1*(A+1.D0)*(A+2.D0)                                           CORA-295
      C(3)=0.5D0*X*((A+1.D0)*(A+2.D0)**3+H*((A+1.D0)*A-1.D0))/C2        CORA-296
      C(4)=T*C1*(A+1.5D0)*(1.D0+X*(A+1.D0)*(A+2.D0)**2)/C2              CORA-297
      RETURN                                                            CORA-298
      END                                                               CORA-299
