C 29/03/98                                                      DWBA98  ECHA-000
      SUBROUTINE ECHA(AM,VS,PH,FO,INM,SOM,NSOM,FAC,NFA,NQUA,NCHE,AX,KTF,ECHA-001
     1CMU,CVF,VX,JMX)                                                   ECHA-002
C CALCULATION OF THE EXCHANGE TERM.                                     ECHA-003
C DATA PASSED OVER BY ARGUMENT:                                         ECHA-004
C  VS(INM,I)    R FOR I=1, R**2 FOR I=2.                                ECHA-005
C  PH(INM,I)    WAVE FUNCTIONS, ORDERED WITH RESPECT TO INCREASING J.   ECHA-006
C               REAL PART THEN IMAGINARY PART, ANGULAR MOMENTUM L=J-1/2 ECHA-007
C               THEN J=L+1/2, ENTRANCE CHANNEL THEN EXIT CHANNEL.       ECHA-008
C  FO(INM,I)    SINGLE PARTICLE FUNCTIONS.                              ECHA-009
C  INM          NUMBER OF INTEGRATION POINTS.                           ECHA-010
C  SOM(4,NSOM,I)  DIRECT AMPLITUDES TO WHICH THE EXCHANGE WILL BE ADDED.ECHA-011
C  NSOM         DIMENSION OF SUM, EQUAL TO 2*J+1.                       ECHA-012
C  FAC(I)       TABLE OF THE LOGARITHMS OF FACTORIALS.                  ECHA-013
C  NFAC         LENGTH OF THE TABLE FAC.                                ECHA-014
C  NQUA(5,I)    TABLE OF THE QUANTUM NUMBERS OF THE SINGLE PARTICLE     ECHA-015
C               STATES.                                                 ECHA-016
C  NCHE(2,I),AX(2,I)   TABLE OF CONFIGURATIONS CONTAINING THE           ECHA-017
C               SPECIFICATION OF THE PARTICLE, THE HOLE                 ECHA-018
C               AND THE COEFFICIENTS X AND Y.                           ECHA-019
C  KTF,CMU,CVF  INTERACTION (SEE LEC2).                                 ECHA-020
C  VX(INM,I)    RADIAL DEPENDENCE OF THE INTERACTIONS.                  ECHA-021
C  JMX          MAXIMUM SPIN TRANSFER.                                  ECHA-022
C DATA PASSED OVER BY COMMON /NOMBR/:                                   ECHA-023
C  H            INTEGRATION STEP.                                       ECHA-024
C  JMAX         NUMBER OF PARTIAL WAVES.                                ECHA-025
C  NBCONF       NUMBER OF CONFIGURATIONS.                               ECHA-026
C  NBPROT       NUMBER OF SINGLE PARTICLE STATES OF THE SAME TYPE AS THEECHA-027
C               INCIDENT PARTICLE.                                      ECHA-028
C  J            SPIN TRANSFER ( DIRECT ).                               ECHA-029
C  LO LOGICAL CONTROLS: LO(20)=.TRUE. NATURAL PARITY EXCITATION.        ECHA-030
C                       LO(31)=.TRUE. NATURAL PARITY.                   ECHA-031
C DATA PASSED OVER BY COMMON /GABJ/:                                    ECHA-032
C  JX           EXCHANGE SPIN TRANSFER.                                 ECHA-033
C RESULTS:    SOM(4,NSOM,I)  WHERE THE EXCHANGE AMPLITUDE HAS BEEN ADDEDECHA-034
C             THE DIRECT AMPLITUDE.                                     ECHA-035
C WORKING AREAS: VS(INM,I) FOR I=3,23 (3 TO 52 IN PATR).                ECHA-036
C  AM(INM,12,I)  TABLES OF MULTIPOLES CALCULATED AND STORED IN THE      ECHA-037
C                SUBROUTINE MULT.                                       ECHA-038
C***********************************************************************ECHA-039
      IMPLICIT REAL*8 (A-H,O-Z)                                         ECHA-040
      LOGICAL LO,LOO                                                    ECHA-041
      DIMENSION VS(INM,48),AM(INM,18,1),FO(INM,1),PH(INM,1),KTF(7,7,1),VECHA-042
     1X(INM,1),AX(2,1),NCHE(2,1),NQUA(3,1),CMU(1),CVF(7,6,1),FAC(1),SOM(ECHA-043
     24,NSOM,1)                                                         ECHA-044
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),ECHA-045
     1LO(40)                                                            ECHA-046
      COMMON /GABJ/ AA,AB,AJ,BJ,CJ,DJ,XG(11),JX                         ECHA-047
C LOOP OVER THE VALUES OF J TRANSFER (J EXCHANGED)                      ECHA-048
      DO 23 JM=1,JMX                                                    ECHA-049
      JX=JM-1                                                           ECHA-050
      NTOT=0                                                            ECHA-051
C GET THE MULTIPOLES                                                    ECHA-052
      CALL MULT(AM,INM,CMU,JX-1)                                        ECHA-053
      WRITE (6,1000) JX                                                 ECHA-054
      CALL HORA                                                         ECHA-055
      BSIXJ=(2*JX+1)*(2*MOD(J+JX,2)-1)                                  ECHA-056
C LOOP OVER THE CONFIGURATIONS                                          ECHA-057
      DO 22 NK=1,NBCONF                                                 ECHA-058
      DO 21 MK=1,2                                                      ECHA-059
      AXA=AX(MK,NK)*BSIXJ                                               ECHA-060
      IF (AXA.EQ.0.D0) GO TO 21                                         ECHA-061
      NPAR=NCHE(MK,NK)                                                  ECHA-062
      NTRO=NCHE(-MK+3,NK)                                               ECHA-063
      IJP=2*NQUA(2,NPAR)+NQUA(3,NPAR)                                   ECHA-064
      IJZ=2*NQUA(2,NTRO)+NQUA(3,NTRO)                                   ECHA-065
C LOOP OVER THE WAVE FUNCTIONS IN THE INITIAL CHANNEL                   ECHA-066
      DO 20 JI=1,JMAX                                                   ECHA-067
      IJT=2*JI-1                                                        ECHA-068
      IF ((IABS(IJP-IJT).GT.2*JX).OR.((IJP+IJT).LT.2*JX)) GO TO 20      ECHA-069
      JFM=MAX0(JI-J,J-JI+1)                                             ECHA-070
      JFMIN=MAX0(JFM,(1+IJZ)/2-JX)                                      ECHA-071
      JFMAX=MIN0(JI+J,JMAX,(1+IJZ)/2+JX)                                ECHA-072
      IF (JFMIN.GT.JFMAX) GO TO 20                                      ECHA-073
C SEARCH FOR THE ANGULAR MOMENTUM CORRESPONDING TO NATURAL PARITY       ECHA-074
C LOO=.TRUE. SPIN ORBIT EVEN WITHOUT SKYRME.                            ECHA-075
      LOO=MOD(JI+NQUA(2,NPAR)+JX,2).NE.0                                ECHA-076
      JSR=2*IJT+1                                                       ECHA-077
      IF (LOO) JSR=JSR-2                                                ECHA-078
      DO 19 KX=1,2                                                      ECHA-079
      JSI=JSR+1                                                         ECHA-080
      KF=JFMIN-JFM                                                      ECHA-081
      NC1=ILL(1,KX+2)                                                   ECHA-082
      NC2=ILL(2,KX+2)                                                   ECHA-083
      NC3=ILL(3,KX+2)                                                   ECHA-084
      NC=NC1-1                                                          ECHA-085
C CALCULATION OF THE ENTRANCE CHANNEL GEOMETRY                          ECHA-086
      G=DCGS(2*JX,IJT,IJP,FAC,NFA)*AXA                                  ECHA-087
      IF (G.EQ.0.) GO TO 19                                             ECHA-088
      NP=1                                                              ECHA-089
      IF (NPAR.GT.NBPROT) NP=3                                          ECHA-090
      AP=0.5D0*DFLOAT(IJP+1)                                            ECHA-091
      AT=0.5D0*DFLOAT(IJT+1)                                            ECHA-092
      AK=1-MOD(IJT+IJP+2*JX,4)                                          ECHA-093
      AJT=-1.D0                                                         ECHA-094
      IF (LOO) AJT=1.D0                                                 ECHA-095
      IF (KX.EQ.2) AJT=-AJT                                             ECHA-096
      AB=AJT*(AT-AK*AP)                                                 ECHA-097
      AA=AJT*(AT+AK*AP)                                                 ECHA-098
      CALL GEOM                                                         ECHA-099
      LO(31)=KX.EQ.1                                                    ECHA-100
      DO 1 I=1,INM                                                      ECHA-101
      VS(I,43)=FO(I,NPAR)*PH(I,JSR)                                     ECHA-102
    1 VS(I,44)=FO(I,NPAR)*PH(I,JSI)                                     ECHA-103
      IF (NC2.EQ.0) GO TO 4                                             ECHA-104
      CALL DERI(PH(1,JSR),VS(1,45),INM)                                 ECHA-105
      CALL DERI(PH(1,JSI),VS(1,46),INM)                                 ECHA-106
      DO 2 I=1,INM                                                      ECHA-107
      VS(I,45)=VS(I,45)*FO(I,NPAR)                                      ECHA-108
    2 VS(I,46)=VS(I,46)*FO(I,NPAR)                                      ECHA-109
      IF (NC3.EQ.0) GO TO 4                                             ECHA-110
      CALL DER2(PH(1,JSR),VS(1,47),INM)                                 ECHA-111
      CALL DER2(PH(1,JSI),VS(1,48),INM)                                 ECHA-112
      DO 3 I=1,INM                                                      ECHA-113
      VS(I,47)=VS(I,47)*FO(I,NPAR)                                      ECHA-114
    3 VS(I,48)=VS(I,48)*FO(I,NPAR)                                      ECHA-115
    4 IF (KX.EQ.1) CALL PTIP(KTF,CMU,CVF,VX,AM,VS,VS(1,3),VS(1,43),INM,NECHA-116
     1P,G)                                                              ECHA-117
      IF (KX.EQ.2) CALL PTII(KTF,CMU,CVF,VX,AM,VS,VS(1,3),VS(1,43),INM,NECHA-118
     1P,G)                                                              ECHA-119
      NX=2+2*NC1                                                        ECHA-120
      DO 6 K=3,NX                                                       ECHA-121
      DO 5 I=1,INM                                                      ECHA-122
    5 VS(I,K)=VS(I,K)*FO(I,NTRO)                                        ECHA-123
    6 CONTINUE                                                          ECHA-124
      IF (NC2.EQ.0) GO TO 11                                            ECHA-125
      CALL DERI(FO(1,NTRO),VS(1,43),INM)                                ECHA-126
      NX=2+2*NC2                                                        ECHA-127
      DO 8 K=3,NX                                                       ECHA-128
      DO 7 I=1,INM                                                      ECHA-129
    7 VS(I,K)=VS(I,K)+VS(I,43)*VS(I,K+24)                               ECHA-130
    8 CONTINUE                                                          ECHA-131
      IF (NC3.EQ.0) GO TO 11                                            ECHA-132
      CALL DER2(FO(1,NTRO),VS(1,43),INM)                                ECHA-133
      DO 10 K=3,6                                                       ECHA-134
      DO 9 I=1,INM                                                      ECHA-135
    9 VS(I,K)=VS(I,K)+VS(I,43)*VS(I,K+36)                               ECHA-136
   10 CONTINUE                                                          ECHA-137
   11 CPH=1-MOD(IJT+IJZ,4)                                              ECHA-138
C LOOP OVER THE WAVE FUNCTIONS IN THE EXIT CHANNEL                      ECHA-139
      DO 18 JF=JFMIN,JFMAX                                              ECHA-140
      KF=KF+1                                                           ECHA-141
      KPAR=1-2*MOD(J+JI+JF,2)                                           ECHA-142
      IF (LO(20)) KPAR=-KPAR                                            ECHA-143
      IJF=2*JF-1                                                        ECHA-144
C CALCULATION OF THE OUTGOING PARTICLES GEOMETRY                        ECHA-145
      GX=CPH*DJ6J(IJT,IJP,2*JX,IJZ,IJF,2*J,FAC,NFA)                     ECHA-146
      IF (GX.EQ.0.) GO TO 18                                            ECHA-147
      GX=H*GX*DCGS(2*JX,IJF,IJZ,FAC,NFA)                                ECHA-148
      IF (KPAR.GT.0) GX=-GX                                             ECHA-149
      FX=GX                                                             ECHA-150
      IF (LOO) FX=-FX                                                   ECHA-151
      AP=0.5D0*DFLOAT(IJF+1)                                            ECHA-152
      AT=0.5D0*DFLOAT(IJZ+1)                                            ECHA-153
      AK=1-MOD(IJZ+IJF+2*JX,4)                                          ECHA-154
      AJT=NQUA(3,NTRO)                                                  ECHA-155
      AB=AJT*(AT-AK*AP)                                                 ECHA-156
      AA=AJT*(AT+AK*AP)                                                 ECHA-157
      CALL GEOM                                                         ECHA-158
      IF (KX.EQ.1) KPAR=-KPAR                                           ECHA-159
      JUR=4*JMAX+2*IJF+KPAR                                             ECHA-160
      IF (LOO) JUR=JUR-2*KPAR                                           ECHA-161
      JUI=JUR+1                                                         ECHA-162
C INTEGRATION                                                           ECHA-163
      TR=0.D0                                                           ECHA-164
      TI=0.D0                                                           ECHA-165
      DO 12 I=1,INM                                                     ECHA-166
      VS(I,43)=VS(I,3)                                                  ECHA-167
   12 VS(I,44)=VS(I,4)                                                  ECHA-168
      DO 14 K=1,NC                                                      ECHA-169
      DO 13 I=1,INM                                                     ECHA-170
      VS(I,43)=VS(I,43)+VS(I,2*K+3)*XG(K)                               ECHA-171
   13 VS(I,44)=VS(I,44)+VS(I,2*K+4)*XG(K)                               ECHA-172
   14 CONTINUE                                                          ECHA-173
      DO 15 I=1,INM                                                     ECHA-174
      TR=TR+VS(I,43)*PH(I,JUR)-VS(I,44)*PH(I,JUI)                       ECHA-175
   15 TI=TI+VS(I,44)*PH(I,JUR)+VS(I,43)*PH(I,JUI)                       ECHA-176
      IF (KX.EQ.2) GO TO 16                                             ECHA-177
      SOM(1,KF,JI)=SOM(1,KF,JI)-TR*FX                                   ECHA-178
      SOM(2,KF,JI)=SOM(2,KF,JI)-TI*FX                                   ECHA-179
      SOM(3,KF,JI)=SOM(3,KF,JI)-TR*GX                                   ECHA-180
      SOM(4,KF,JI)=SOM(4,KF,JI)-TI*GX                                   ECHA-181
      GO TO 17                                                          ECHA-182
   16 SOM(1,KF,JI)=SOM(1,KF,JI)+TR*FX                                   ECHA-183
      SOM(2,KF,JI)=SOM(2,KF,JI)+TI*FX                                   ECHA-184
      SOM(3,KF,JI)=SOM(3,KF,JI)-TR*GX                                   ECHA-185
      SOM(4,KF,JI)=SOM(4,KF,JI)-TI*GX                                   ECHA-186
   17 NTOT=NTOT+1                                                       ECHA-187
   18 CONTINUE                                                          ECHA-188
      JSR=4*IJT-JSR                                                     ECHA-189
   19 CONTINUE                                                          ECHA-190
   20 CONTINUE                                                          ECHA-191
   21 CONTINUE                                                          ECHA-192
   22 CONTINUE                                                          ECHA-193
C STOP THE LOOP OVER J TRANSFER IF THE LAST LOOP WAS EMPTY              ECHA-194
      IF (NTOT.EQ.0) RETURN                                             ECHA-195
   23 CONTINUE                                                          ECHA-196
      RETURN                                                            ECHA-197
 1000 FORMAT (6X,9H**** JX =,I2,6H  ****)                               ECHA-198
      END                                                               ECHA-199
