C 02/08/99                                                      DWBA98  SCEF-000
      SUBROUTINE SCEF(NK,AMPLI,NAMP,NBMP,AF,SOM,NSOM,TGS,TGX,NTGS,FAC,NFSCEF-001
     1A,J,MPAR,CATIE,Q,TETMIN,TETMAX,COEF,NG,MULTIJ,LO)                 SCEF-002
C CALCULATE THE CROSS SECTIONS AND POLARISATIONS.                       SCEF-003
C INPUTS:   NK      1 FOR DIRECT TERM, 2 AFTER THE EXCHANGE CALCULATION.SCEF-004
C           NAMP,NBMP   DIMENSIONS OF THE WORKING AREA AMPLI.           SCEF-005
C           SOM     INTEGRALS.                                          SCEF-006
C           NSOM    SECOND DIMENSION OF THE TABLE SOM.                  SCEF-007
C           FAC     LOGARITHMS OF FACTORIALS.                           SCEF-008
C           NFA     DIMENSION OF THE TABLE FAC                          SCEF-009
C           J       MULTIPOLARITY OF THE EXCITATION.                    SCEF-010
C           MPAR    PARITY OF THE EXCITATION.                           SCEF-011
C           CATIE   TITLE.                                              SCEF-012
C           Q       ENERGY OF THE EXCITATION.                           SCEF-013
C           TETMIN,TETMAX   FIRST AND LAST ANGLES FOR THE CALCULATION   SCEF-014
C                                      OF THE ANGULAR DISTRIBUTIONS.    SCEF-015
C           NTGS    NUMBER OF ANGLES.                                   SCEF-016
C           COEF    NORMALISATION COEFFICIENT FOR THE AMPLITUDES.       SCEF-017
C           NG      INDICES FOR THE GRAPH.                              SCEF-018
C           MULTIJ  INDEX FOR THE SUMMATION OVER  J TRANSFER.           SCEF-019
C           LO      LOGICAL CONTROLS - LO(15)=.TRUE. TO PUNCH AMPLITUDESSCEF-020
C WORKING AREAS:  AMPLI(4,NAMP,NMBP) USED FOR THE HELICITY AMPLITUDES   SCEF-021
C        WITH THE LAST INDEX FROM 1 TO NMBP-1 AND FOR THE AMPLITUDES AT SCEF-022
C        A FIXED ANGLE FOR NMBP; THE FIRST INDEX 1,2 FOR REAL PART AND  SCEF-023
C        3,4 FOR THE IMAGINARY PART.                                    SCEF-024
C    AF  3-J COEFFICIENTS  CALCULATED BY RECURSION.                     SCEF-025
C    TGS(NTGS,I) ANGLES FOR I=1,DIFF. CROSS SECTION FOR I=2, POLAR. FOR SCEF-026
C        I=3, ASYMMETRY FOR I=4, SPIN-FLIP FOR I=5, Q FOR I=6           SCEF-027
C    TGX(NTGS,5,I) FOR THE SUMS OB OBSERVABLES WITH MULTIJ, I=1 FOR     SCEF-028
C        DIRECT, I=2 FOR EXCHANGE FOLLOWED BY TWO TOTAL CROSS-SECTIONS  SCEF-029
C***********************************************************************SCEF-030
      IMPLICIT REAL*8 (A-H,O-Z)                                         SCEF-031
      LOGICAL LO(40)                                                    SCEF-032
      DIMENSION TGS(NTGS,6),SIGNE(2),TGX(NTGS,5,2),CATIE(12),NG(2,2),FACSCEF-033
     1(1),AF(1),SOM(4,NSOM,1),AMPLI(4,NAMP,1)                           SCEF-034
      DATA SIGNE/1H-,1H+/                                               SCEF-035
      KIM=1-2*MOD(J,2)                                                  SCEF-036
      KIP=KIM*MPAR                                                      SCEF-037
      IM=(KIP+1)/2+1                                                    SCEF-038
      WRITE (6,1000) Q,(CATIE(M),M=1,12),J,SIGNE(IM)                    SCEF-039
      NJ1=NSOM+1                                                        SCEF-040
      J1=J+1                                                            SCEF-041
      JIT=4*NAMP*NBMP                                                   SCEF-042
      JIMAX=NBMP-1                                                      SCEF-043
C CALCULATE THE HELICITY AMPLITUDES                                     SCEF-044
      IF (LO(15)) WRITE (7,1001) NK,J,MPAR,JIMAX                        SCEF-045
      DO 1 JI=1,JIT                                                     SCEF-046
    1 AMPLI(JI,1,1)=0.D0                                                SCEF-047
      DO 2 MJ=1,NJ1                                                     SCEF-048
    2 AF(MJ)=0.D0                                                       SCEF-049
      RC=NSOM                                                           SCEF-050
      RC=DSQRT(RC)*COEF                                                 SCEF-051
      SX=0.D0                                                           SCEF-052
      DO 9 JI=1,JIMAX                                                   SCEF-053
      A1=2*JI                                                           SCEF-054
      JFMAX=MIN0(JIMAX,JI+J)                                            SCEF-055
      JFMIN=MAX0(JI-J,J-JI+1)                                           SCEF-056
      DO 6 JF=JFMIN,JFMAX                                               SCEF-057
      IF (LO(15)) WRITE (7,1002) (SOM(MJ,JF+1-JFMIN,JI),MJ=1,4)         SCEF-058
      AF(J1)=RC*DCGS(2*J,2*JI-1,2*JF-1,FAC,NFA)                         SCEF-059
      AJ=JI                                                             SCEF-060
      AK=JF*(2*MOD(J+JI+JF,2)-1)                                        SCEF-061
      JZ=MIN0(J,JI)                                                     SCEF-062
      IF (JZ.EQ.0) GO TO 4                                              SCEF-063
      DO 3 I=1,JZ                                                       SCEF-064
      AX=(J1-I)*(J+I)                                                   SCEF-065
      AX=DSQRT(AX)                                                      SCEF-066
      BX=MAX0(JI**2-I**2,1)                                             SCEF-067
      BX=DSQRT(BX)                                                      SCEF-068
      AF(J1+I)=-(AJ*AF(J+I)+AK*AF(J1-I+1))/AX                           SCEF-069
      AF(J1-I)=-(AX*AF(J1-I+1)+AK*AF(J1+I))/BX                          SCEF-070
    3 AJ=BX                                                             SCEF-071
    4 SIMJ=KIM                                                          SCEF-072
      DO 5 MJ=1,NSOM                                                    SCEF-073
      SIMJ=-SIMJ                                                        SCEF-074
      AMPLI(1,MJ,JI)=AMPLI(1,MJ,JI)+AF(MJ)*SIMJ*SOM(1,JF+1-JFMIN,JI)    SCEF-075
      AMPLI(2,MJ,JI)=AMPLI(2,MJ,JI)+AF(MJ)*SIMJ*SOM(2,JF+1-JFMIN,JI)    SCEF-076
      AMPLI(3,MJ,JI)=AMPLI(3,MJ,JI)+AF(MJ)*SOM(3,JF+1-JFMIN,JI)         SCEF-077
    5 AMPLI(4,MJ,JI)=AMPLI(4,MJ,JI)+AF(MJ)*SOM(4,JF+1-JFMIN,JI)         SCEF-078
    6 CONTINUE                                                          SCEF-079
      DO 8 K=1,NSOM                                                     SCEF-080
      DO 7 L=1,4                                                        SCEF-081
    7 SX=SX+AMPLI(L,K,JI)**2/A1                                         SCEF-082
    8 CONTINUE                                                          SCEF-083
    9 CONTINUE                                                          SCEF-084
      SX=125.664D0*SX                                                   SCEF-085
      DTM=(TETMAX-TETMIN)/DFLOAT(NTGS-1)                                SCEF-086
      NSOM4=4*NAMP                                                      SCEF-087
C CALCULATION AT EQUIDISTANT ANGLES                                     SCEF-088
      DO 18 M=1,NTGS                                                    SCEF-089
      TTETA=TETMIN+DTM*(M-1)                                            SCEF-090
      DO 10 L=1,NSOM4                                                   SCEF-091
   10 AMPLI(L,1,NBMP)=0.D0                                              SCEF-092
      AX=DCOS(TTETA*.5D0)                                               SCEF-093
      BX=DSIN(TTETA*.5D0)                                               SCEF-094
      DO 12 MJ=1,NJ1                                                    SCEF-095
      MK=2-MJ+NSOM                                                      SCEF-096
      CALL EMRO(1,2*J-2*MJ+3,1,AX,BX,AF,JIMAX)                          SCEF-097
      DO 11 JI=1,JIMAX                                                  SCEF-098
      AMPLI(1,MK,NBMP)=AMPLI(1,MK,NBMP)+AF(JI)*AMPLI(1,MK,JI)           SCEF-099
      AMPLI(2,MK,NBMP)=AMPLI(2,MK,NBMP)+AF(JI)*AMPLI(2,MK,JI)           SCEF-100
      AMPLI(3,MJ,NBMP)=AMPLI(3,MJ,NBMP)+AF(JI)*AMPLI(3,MJ,JI)           SCEF-101
   11 AMPLI(4,MJ,NBMP)=AMPLI(4,MJ,NBMP)+AF(JI)*AMPLI(4,MJ,JI)           SCEF-102
   12 CONTINUE                                                          SCEF-103
      TGS(M,1)=TTETA*180.D0/3.141592653589793D0                         SCEF-104
      DO 13 L=2,6                                                       SCEF-105
   13 TGS(M,L)=0.D0                                                     SCEF-106
      RMU=-KIP                                                          SCEF-107
      DO 15 MJ=1,NSOM                                                   SCEF-108
      RMU=-RMU                                                          SCEF-109
      NMJ=NSOM-MJ+1                                                     SCEF-110
      DO 14 L=1,4                                                       SCEF-111
      TGS(M,2)=TGS(M,2)+AMPLI(L,MJ,NBMP)**2                             SCEF-112
   14 TGS(M,5)=TGS(M,5)+AMPLI(L,MJ,NBMP)*AMPLI(L,NMJ,NBMP)*RMU          SCEF-113
      TGS(M,4)=TGS(M,4)+(AMPLI(1,MJ,NBMP)*AMPLI(4,NMJ,NBMP)-AMPLI(3,NMJ,SCEF-114
     1NBMP)*AMPLI(2,MJ,NBMP))*RMU                                       SCEF-115
      TGS(M,3)=TGS(M,3)+AMPLI(1,MJ,NBMP)*AMPLI(4,MJ,NBMP)-AMPLI(3,MJ,NBMSCEF-116
     1P)*AMPLI(2,MJ,NBMP)                                               SCEF-117
   15 TGS(M,6)=TGS(M,6)+(BX**2-AX**2)*(AMPLI(1,MJ,NBMP)*AMPLI(3,MJ,NBMP)SCEF-118
     1+AMPLI(2,MJ,NBMP)*AMPLI(4,MJ,NBMP))+AX*BX*(AMPLI(3,MJ,NBMP)*AMPLI(SCEF-119
     23,NMJ,NBMP)+AMPLI(4,MJ,NBMP)*AMPLI(4,NMJ,NBMP)-AMPLI(1,MJ,NBMP)*AMSCEF-120
     3PLI(1,NMJ,NBMP)-AMPLI(2,MJ,NBMP)*AMPLI(2,NMJ,NBMP))*RMU           SCEF-121
      IF (TGS(M,2).EQ.0.D0) GO TO 16                                    SCEF-122
      TGS(M,3)=2.D0*TGS(M,3)/TGS(M,2)                                   SCEF-123
      TGS(M,4)=2.D0*TGS(M,4)/TGS(M,2)                                   SCEF-124
      TGS(M,5)=0.5D0*(1.D0-TGS(M,5)/TGS(M,2))                           SCEF-125
      TGS(M,6)=2.D0*TGS(M,6)/TGS(M,2)                                   SCEF-126
   16 TGS(M,2)=10.D0*TGS(M,2)                                           SCEF-127
      IF (MULTIJ.EQ.1) GO TO 18                                         SCEF-128
      TGX(M,1,NK)=TGX(M,1,NK)+TGS(M,2)                                  SCEF-129
      DO 17 II=2,5                                                      SCEF-130
      TGX(M,II,NK)=TGX(M,II,NK)+TGS(M,2)*TGS(M,II+1)                    SCEF-131
      IF (MULTIJ.EQ.0) TGX(M,II,NK)=TGX(M,II,NK)/TGX(M,1,NK)            SCEF-132
   17 CONTINUE                                                          SCEF-133
   18 WRITE (6,1003) (TGS(M,L),L=1,6)                                   SCEF-134
      WRITE (6,1004) SX                                                 SCEF-135
      IF (MULTIJ.NE.1) TGX(NTGS+NK,5,2)=TGX(NTGS+NK,5,2)+SX             SCEF-136
      CALL GRAL(TGS,TGS(1,2),NTGS,NG(1,NK),2)                           SCEF-137
      IF (MULTIJ.NE.0) GO TO 21                                         SCEF-138
      WRITE (6,1000) Q,(CATIE(M),M=1,12),J,SIGNE(IM)                    SCEF-139
      WRITE (6,1005)                                                    SCEF-140
      WRITE (6,1003) (TGS(M,1),(TGX(M,L,NK),L=1,5),M=1,NTGS)            SCEF-141
      WRITE (6,1004) TGX(NTGS+NK,5,2)                                   SCEF-142
      CALL GRAL(TGS,TGX(1,1,NK),NTGS,NG(1,NK),2)                        SCEF-143
      DO 20 M=1,NTGS                                                    SCEF-144
      DO 19 I=1,5                                                       SCEF-145
   19 TGX(M,I,NK)=0.D0                                                  SCEF-146
   20 CONTINUE                                                          SCEF-147
      TGX(NTGS+NK,5,2)=0.D0                                             SCEF-148
   21 RETURN                                                            SCEF-149
 1000 FORMAT (1H1/9H  ENERGY=,F10.4,5X,12A4///13H ****** LEVEL,I2,A1,8H SCEF-150
     1 ******//5X,25HANGLE  DIF. CROSS SECTION,11X,9HASYMMETRY,8X,12HPOLSCEF-151
     2ARISATION,11X,9HSPIN-FLIP,8X,12HOBSERVABLE Q/)                    SCEF-152
 1001 FORMAT (4X,1H2/4I5)                                               SCEF-153
 1002 FORMAT (4D18.10)                                                  SCEF-154
 1003 FORMAT (3X,F7.2,5D20.7)                                           SCEF-155
 1004 FORMAT (//29H TOTAL REACTION CROSS SECTION,D15.7,11H MILLIBARNS/) SCEF-156
 1005 FORMAT (//28H SUMMATION OVER  J  TRANSFER//)                      SCEF-157
      END                                                               SCEF-158
