C 07/12/98                                                      DWBB98  DWBB-000
C                                                                       DWBB-001
C RELATION BETWEEN THE FORM-FACTORS OF DWBA91 AND ECIS91                DWBB-002
C FOR A CENTRAL INTERACTION (WITHOUT EXCHANGE):                         DWBB-003
C FOR A TRANSFER J, THERE ARE THE FORM-FACTORS A AND B LISTED IN        DWBB-004
C DWBA91. USING THESE FORM FACTORS FOR ECIS91 AND ULTERIOR VERSIONS,    DWBB-005
C THE NUCLEAR MATRIX ELEMENTS ARE:                                      DWBB-006
C   - FOR A NATURAL PARITY STATE                                        DWBB-007
C    1    J    0    0   P*SQRT(2*J+1)                     FOR A         DWBB-008
C    2    J    2  2*J   P*(-)**J*SQRT(2*J*(J+1)*(2*J+1))  FOR B         DWBB-009
C   - FOR AN UNNATURAL PARITY STATE                                     DWBB-010
C    1  J-1    2  2*J   P*SQRT(2*J)                       FOR A         DWBB-011
C    2  J+1    2  2*J   -P*J*SQRT(2*(J+1))                FOR B         DWBB-012
C    3  J+1    2  2*J   P*SQRT(2*(J+1)                    FOR A         DWBB-013
C    4  J-1    2  2*J   P*(J+1)*SQRT(2*J)                 FOR B         DWBB-014
C WHERE P IS A SIGN (-)**ENT[J/2].                                      DWBB-015
C                                                                       DWBB-016
C IN WV:1 - MASS OF INCIDENT PARTICLE                                   DWBB-017
C       2 - MASS OF THE TARGET                                          DWBB-018
C       3 - K WAVE NUMBER                                               DWBB-019
C       4 - COULOMB PARAMETER                                           DWBB-020
C       5 - REDUCED MASS                                                DWBB-021
C       6 - COULOMB PHASE SHIFT FOR L=0                                 DWBB-022
C***********************************************************************DWBB-023
      IMPLICIT REAL*8 (A-H,O-Z)                                         DWBB-024
      LOGICAL LO(5)                                                     DWBB-025
      PARAMETER (IDMT=100000)                                           DWBB-026
      DIMENSION W(IDMT)                                                 DWBB-027
      COMMON /QUAN/ IPJ(2),IPI(2),IP3,LML,LMJ,IP4,KY,KC1,KCC,JT,NJY     DWBB-028
      COMMON /TITR/ TITLE(18),THETA1,THETA2,DTHETA,DTHE,CMB,XZ,WV(6,2)  DWBB-029
      CMB=4.7205613D0                                                   DWBB-030
      READ (5,1000) TITLE                                               DWBB-031
      WRITE (6,1001) TITLE                                              DWBB-032
      WRITE (6,1002) IDMT                                               DWBB-033
      READ (5,1003) (LO(I),I=1,2)                                       DWBB-034
      WRITE (6,1004) (LO(I),I=1,2)                                      DWBB-035
      READ (5,1005) THETA1,THETA2,DTHETA,DTHE                           DWBB-036
      WRITE (6,1006) THETA1,DTHETA,THETA2,DTHE                          DWBB-037
      CALL DEPH(W,IDMT,LO)                                              DWBB-038
      NAM1=1+(9*KCC+1)/2                                                DWBB-039
      NAM2=NAM1+4*(NJY+15)                                              DWBB-040
      CALL OBSE(W,W(NAM1),W(NAM1),W(NAM2),W(NAM2),JCAL,IDMT-NAM2,LO(5)) DWBB-041
      NFAC=NAM1+JCAL                                                    DWBB-042
      NFA=2*LML+IPJ(1)+IPJ(2)                                           DWBB-043
      W(NFAC)=0.D0                                                      DWBB-044
      A1=0.D0                                                           DWBB-045
      DO 1 I=2,NFA                                                      DWBB-046
      A1=A1+1.D0                                                        DWBB-047
    1 W(NFAC+I-1)=W(NFAC+I-2)+DLOG(A1)                                  DWBB-048
      KNT=NFA+NFAC                                                      DWBB-049
      KNH=KNT+4*IPJ(1)*IPJ(2)*LMJ                                       DWBB-050
      KNG=KNH+4*IPJ(1)*IPJ(2)*LMJ                                       DWBB-051
      KN=KNG+2*LML                                                      DWBB-052
      DO 2 I=KNT,KN-1                                                   DWBB-053
    2 W(I)=0.D0                                                         DWBB-054
      K=0                                                               DWBB-055
    3 READ (5,1007,END= 7 ) IK                                          DWBB-056
      IF (IK.EQ.0) STOP                                                 DWBB-057
      K=K+1                                                             DWBB-058
      IF (IK.EQ.2) GO TO 5                                              DWBB-059
      IF (K.GT.2) GO TO 6                                               DWBB-060
      READ (5,1007) IG,LMX                                              DWBB-061
      IF (IG.GT.2) GO TO 6                                              DWBB-062
      READ (5,1008) (WV(I,IG),I=1,6)                                    DWBB-063
      WRITE (6,1009) (WV(I,IG),I=1,6)                                   DWBB-064
      KI=KNG+IG-1                                                       DWBB-065
      W(KI)=WV(6,IG)                                                    DWBB-066
      DO 4 I=1,LML                                                      DWBB-067
      AI=I                                                              DWBB-068
    4 W(KI+2*I)=W(KI+2*I-2)+DATAN2(WV(4,IG),AI)                         DWBB-069
      CALL LECA(IPJ(1),LMX,LMJ,IG*IP3,W(KNT))                           DWBB-070
      GO TO 3                                                           DWBB-071
    5 IF (K.LE.2) GO TO 6                                               DWBB-072
      READ (5,1007) IG,JKJ,MPAR,LMX                                     DWBB-073
      COF=0.0478326D0*DSQRT(WV(5,1)*WV(5,2)/(4.D0*WV(3,2)*WV(3,1)))     DWBB-074
      IF (IG.GT.2) GO TO 6                                              DWBB-075
      CALL LECB(JKJ,MPAR,LMX,COF,W(KNG),IPJ(1),IPJ(2),LMJ,W(KNT),W(NFAC)DWBB-076
     1,NFA)                                                             DWBB-077
      GO TO 3                                                           DWBB-078
    6 WRITE (6,1010)                                                    DWBB-079
    7 WRITE (6,1011)                                                    DWBB-080
C GO BACK TO ECIS NOTATIONS, NECESSARY FOR ELASTIC SCATTERING           DWBB-081
      DO 8 I=1,LML                                                      DWBB-082
      W(KNG+2*I-2)=W(KNG+2*I-2)-WV(6,1)                                 DWBB-083
    8 W(KNG+2*I-1)=W(KNG+2*I-1)-WV(6,2)                                 DWBB-084
      KNA=KN+4*(IPJ(1)+IPJ(2))                                          DWBB-085
      XZ=5.D0/DFLOAT(IPJ(1))/WV(3,1)**2                                 DWBB-086
      CALL SCHE(W(KNT),LMJ,IPJ(1),IPJ(2),IPJ(1)+IPJ(2),W,W(KNG),XZ,W(KNHDWBB-087
     1),TX,W(KNA),W(KN))                                                DWBB-088
      MTETA=(THETA2-THETA1)/DTHETA+1.5D0                                DWBB-089
      KM=KN+3*(IP4+1)                                                   DWBB-090
      KT=KM+MTETA*(JT+2)                                                DWBB-091
      KR=IDMT-KT                                                        DWBB-092
      CALL RESU(W(KNH),TX,LMJ,W,W(NAM1),W(KN),IP4+1,W(KT),W(KM),MTETA,KRDWBB-093
     1,LO)                                                              DWBB-094
      KR=KR+KT                                                          DWBB-095
      N=IDMT-KR                                                         DWBB-096
      WRITE (6,1012) KR,N                                               DWBB-097
      STOP                                                              DWBB-098
 1000 FORMAT (18A4)                                                     DWBB-099
 1001 FORMAT (1H1/5X,80(1H*)/5X,1H*,78X,1H*/5X,1H*,3X,18A4,3X,1H*/5X,1H*DWBB-100
     1,78X,1H*/5X,80(1H*))                                              DWBB-101
 1002 FORMAT (//36H DWBB98           TOTAL DIMENSION  =,I10)            DWBB-102
 1003 FORMAT (2L1)                                                      DWBB-103
 1004 FORMAT (8H LO(1) =,L2,26H - RELATIVISTIC KINEMATICS/8H LO(2) =,L2,DWBB-104
     134H - ANGLES IN THE LABORATORY SYSTEM)                            DWBB-105
 1005 FORMAT (7F10.5)                                                   DWBB-106
 1006 FORMAT (/23H SCATTERING ANGLES FROM,F7.3,12H IN STEPS OF,F7.3,6H UDWBB-107
     1P TO,F8.3,28H DEGREES   AVERAGED WITH +/-,F8.3,8H DEGREES/)       DWBB-108
 1007 FORMAT (14I5)                                                     DWBB-109
 1008 FORMAT (4D18.10)                                                  DWBB-110
 1009 FORMAT (32H MASS OF THE INCIDENT PARTICLE   ,D15.6/19H MASS OF THEDWBB-111
     1 TARGET,13X,D15.6/5X,3HK =,D15.6,8X,5HETA =,D15.6/8H AMRED =,D15.6DWBB-112
     2,5X,8HSIGMA0 =,D15.6)                                             DWBB-113
 1010 FORMAT (16H **** ERROR ****)                                      DWBB-114
 1011 FORMAT (22H **** END OF DATA ****)                                DWBB-115
 1012 FORMAT (//39H *** WORKSPACE USED IN THIS COMPUTATION,I10,5H  ***,1DWBB-116
     10X,I10,18H MEMORIES NOT USED)                                     DWBB-117
      END                                                               DWBB-118
