C 07/12/98                                                      DWBB98  DEPH-000
      SUBROUTINE DEPH(MF,IDMT,LO)                                       DEPH-001
C HELICITY QUANTUM NUMBERS AND CHOICE OF OBSERVABLES FOR THE OUTPUT     DEPH-002
C INPUT VARIABLES: IDMT:   SIZE OF WORKING FIELD (DOUBLE PRECISION)     DEPH-003
C OUTPUT VARIABLES:MF:     TABLE OF QUANTUM NUMBERS AND OBSERVABLES     DEPH-004
C                                                                       DEPH-005
C                  LO(3):  GRAPH OF CROSS SECTION                       DEPH-006
C                  LO(4):  GRAPH OF POLARISATIONS                       DEPH-007
C IN COMMON /QUAN/:IJ1,IJ2:MULTIPLICITY OF THE INITIAL AND FINAL TARGET DEPH-008
C                  IP1,IP2:PARITY OF THE INITIAL AND FINAL TARGET       DEPH-009
C                  IP3:    1 OR 0 TO USE OR NOT ELASTIC SCATTERING      DEPH-010
C                  LML:    MAXIMUM NUMBER OF ANGULAR MOMENTA            DEPH-011
C                  LMJ:    MAXIMUM NUMBER OF TOTAL SPIN                 DEPH-012
C                  IP4:    NUMBER OF OBSERVABLES TO COMPUTE             DEPH-013
C                  KY:     END OF THE FIRST PART OF TABLE MF            DEPH-014
C                  KC1,KCC:BEGINNING AND END OF THE SECOND PART OF MF   DEPH-015
C                  JT:     MAXIMUM NUMBER OF KINDS OF POLARISATION      DEPH-016
C                  NJY:    MAXIMUM LABEL OF NON STANDARD OBSERVABLE     DEPH-017
C                                                                       DEPH-018
C   **** TABLE MF **** FIRST PART                                       DEPH-019
C FOR EACH INDEPENDENT AMPLITUDE (WITH RESPECT TO PARITY ONLY)          DEPH-020
C  MF(1,*)  HELICITY OF THE OUTGOING PARTICLE                           DEPH-021
C  MF(2,*)  HELICITY OF THE RESIDUAL TARGET                             DEPH-022
C  MF(3,*)  HELICITY OF THE INCOMING PARTICLE                           DEPH-023
C  MF(4,*)  HELICITY OF THE TARGET                                      DEPH-024
C    THESE HELICITIES ARE NUMBERED FROM THE LOWEST VALUE                DEPH-025
C  MF(5,*)  PARITY RELATED AMPLITUDES:0 NONE,1 OR -1 ONE WITH THIS SIGN DEPH-026
C  MF(6,*)  DOUBLE MAGNETIC QUANTUM NUMBER OF THE ROTATION MATRIX       DEPH-027
C    ELEMENT RELATED TO THE INITIAL STATE                               DEPH-028
C  MF(7,*)  DOUBLE MAGNETIC QUANTUM NUMBER OF THE ROTATION MATRIX       DEPH-029
C    ELEMENT FOR THE FINAL STATE; HOWEVER, WITH ABSOLUTE VALUE 10000, ITDEPH-030
C    INDICATES THAT THE LAST COMPUTED MATRIX ELEMENTS CAN BE USED WITH  DEPH-031
C    THE SIGN OF MF(7,*).  A RE-ORDERING OF THE HELICITIES HAS BEEN DONEDEPH-032
C  MF(8,*)  DIRECT ADDRESS OF THE AMPLITUDE IN AN ONE-ROW MATRIX        DEPH-033
C  MF(9,*)  DIRECT ADDRESS OF THE PARITY RELATED AMPLITUDE              DEPH-034
C***********************************************************************DEPH-035
      LOGICAL LO(5)                                                     DEPH-036
      DIMENSION MF(9,1),SIG(4)                                          DEPH-037
      COMMON /QUAN/ IJ1,IJ2,IP1,IP2,IP3,LML,LMJ,IP4,KY,KC1,KCC,JT,NJY   DEPH-038
      DATA SIG /1H+,1H-,4HOUT ,4H    /                                  DEPH-039
      READ (5,1000) IJ1,IP1,IJ2,IP2,IP3,LML,LMJ,IP4                     DEPH-040
      IP3=MIN0(IP3,1)                                                   DEPH-041
      WRITE (6,1001) IJ1,SIG(IP1+1),IJ2,SIG(IP2+1),SIG(IP3+3),LML,LMJ,IPDEPH-042
     14                                                                 DEPH-043
      IF (MOD(IJ1+IJ2,2).NE.0) GO TO 15                                 DEPH-044
      KCC=0                                                             DEPH-045
C LOOP ON THE NUCLEAR LEVELS                                            DEPH-046
      IP=MOD(IP1+IP2,2)                                                 DEPH-047
      DO 12 I1=1,2                                                      DEPH-048
      J1=2+1-I1                                                         DEPH-049
      DO 11 I2=1,IJ2                                                    DEPH-050
      J2=IJ2+1-I2                                                       DEPH-051
      DO 10 I3=1,2                                                      DEPH-052
      J3=2+1-I3                                                         DEPH-053
      DO 9 I4=1,IJ1                                                     DEPH-054
      J4=IJ1+1-I4                                                       DEPH-055
      IF (KCC.LT.1) GO TO 3                                             DEPH-056
C SEARCH FOR PARITY CONJUGATE AMONG THE AMPLITUDES ALREADY OBTAINED     DEPH-057
      DO 1 J=1,KCC                                                      DEPH-058
      IF ((MF(1,J).EQ.J1).AND.(MF(2,J).EQ.J2).AND.(MF(3,J).EQ.J3).AND.(MDEPH-059
     1F(4,J).EQ.J4)) GO TO 2                                            DEPH-060
    1 CONTINUE                                                          DEPH-061
      GO TO 3                                                           DEPH-062
    2 MF(5,J)=1-2*MOD(IP+J1+I2+J3+I4,2)                                 DEPH-063
      MF(9,J)=I1+2*(I2-1+IJ2*(I4-1+IJ1*(I3-1)))                         DEPH-064
      GO TO 9                                                           DEPH-065
C NEW AMPLITUDE                                                         DEPH-066
    3 KCC=KCC+1                                                         DEPH-067
      NMAX=(9*KCC+1)/2                                                  DEPH-068
      IF (NMAX.GE.IDMT) GO TO 17                                        DEPH-069
      MF(1,KCC)=I1                                                      DEPH-070
      MF(2,KCC)=I2                                                      DEPH-071
      MF(3,KCC)=I3                                                      DEPH-072
      MF(4,KCC)=I4                                                      DEPH-073
      MF(5,KCC)=0                                                       DEPH-074
      MF(6,KCC)=2*(MF(3,KCC)-MF(4,KCC)-1)+IJ1                           DEPH-075
      MF(7,KCC)=2*(MF(1,KCC)-MF(2,KCC)-1)+IJ2                           DEPH-076
      MF(8,KCC)=I1+2*(I2-1+IJ2*(I4-1+IJ1*(I3-1)))                       DEPH-077
      IF (KCC.LE.1) GO TO 9                                             DEPH-078
C SEARCH FOR RELATED ROTATION MATRIX ELEMENTS                           DEPH-079
      KK=KCC-1                                                          DEPH-080
      M1=IABS(MF(6,KCC)+MF(7,KCC))/2                                    DEPH-081
      M2=IABS(MF(6,KCC)-MF(7,KCC))/2                                    DEPH-082
      DO 8 J=1,KK                                                       DEPH-083
      IF (IABS(MF(7,J)).EQ.10000) GO TO 8                               DEPH-084
      M3=IABS(MF(6,J)+MF(7,J))/2                                        DEPH-085
      M4=IABS(MF(6,J)-MF(7,J))/2                                        DEPH-086
      IF (M1.NE.M3.OR.M2.NE.M4) GO TO 8                                 DEPH-087
      M3=IABS(MF(6,J)-MF(6,KCC)+MF(7,KCC)-MF(7,J))/2                    DEPH-088
      MF(7,KCC)=1-MOD(M3,4)                                             DEPH-089
      MF(7,KCC)=10000*MF(7,KCC)                                         DEPH-090
      JA=J+1                                                            DEPH-091
      IF (JA.EQ.KCC) GO TO 9                                            DEPH-092
C PERMUTATION OF AMPLITUDES                                             DEPH-093
      DO 7 M1=1,9                                                       DEPH-094
      M2=MF(M1,KCC)                                                     DEPH-095
      DO 4 M3=JA,KCC                                                    DEPH-096
      M4=KCC+JA-M3                                                      DEPH-097
    4 MF(M1,M4)=MF(M1,M4-1)                                             DEPH-098
      MF(M1,JA)=M2                                                      DEPH-099
    7 CONTINUE                                                          DEPH-100
      GO TO 9                                                           DEPH-101
    8 CONTINUE                                                          DEPH-102
    9 CONTINUE                                                          DEPH-103
   10 CONTINUE                                                          DEPH-104
   11 CONTINUE                                                          DEPH-105
   12 CONTINUE                                                          DEPH-106
C***********************************************************************DEPH-107
C   **** TABLE MF **** SECOND PART                                      DEPH-108
C  THIS PART OF THE TABLE IS PROLONGATED IN LECD AND WILL BE UPDATED    DEPH-109
C  BY OBSE      - FOR EACH OBSERVABLE                                   DEPH-110
C  MF(1,*)  KIND OF OBSERVABLE                                          DEPH-111
C  MF(2,*)  LEVEL NOT USED                                              DEPH-112
C  MF(5,*)  INDICATION FOR GRAPHS                                       DEPH-113
C  *** NON-STANDARD OPTIONS ***                                         DEPH-114
C  THE FIRST ONE MUST BE THE CROSS-SECTION                              DEPH-115
C ANY OBSERVABLE NOT DESCRIBED BELOW IS IDENTIFIED BY A NEGATIVE NUMBER DEPH-116
C  OF WHICH THE POSITIVE VALUE MUST BE FOUND BY OBSE                    DEPH-117
C  FOLLOWED BY THE DESCRIPTION OF THE OBSERVABLE                        DEPH-118
C **** STANDARD DESCRIPTIONS ****                                       DEPH-119
C  0  CROSS SECTION                                                     DEPH-120
C  1  CROSS SECTION DIVIDED BY RUTHERFORD'S CROSS SECTION               DEPH-121
C  2  VECTOR ANALYSING POWER                                            DEPH-122
C  3  VECTOR POLARISATION                                               DEPH-123
C  4  SPIN-FLIP DEFINED AS (A(0000 0000)+A(1100 1100)+A(1100 1-100))/2  DEPH-124
C  5  KYY OR D  DEFINED AS -A(1100 1100)-A(1100 1-100)                  DEPH-125
C  6  KXX OR R  DEFINED AS  A(1100 1100)-A(1100 1-100)                  DEPH-126
C  7  KZZ OR A' DEFINED AS  A(1000 1000)                                DEPH-127
C  8  KXZ OR R' DEFINED AS -SQRT(2.) A(1100 1000)                       DEPH-128
C  9  KZX OR A  DEFINED AS -SQRT(2.) A(1000 1100)                       DEPH-129
C 10  VECTOR ANALYSING POWER OF THE TARGET                              DEPH-130
C 11  AYY  DEFINED AS -A(1111 0000)-A(111-1 0000)                       DEPH-131
C 12  AXX  DEFINED AS  A(1111 0000)-A(111-1 0000)                       DEPH-132
C 13  AZZ  DEFINED AS  A(1010 0000)                                     DEPH-133
C 14  AXZ  DEFINED AS -SQRT(2.) A(1110 0000)                            DEPH-134
C 15  AZX  DEFINED AS -SQRT(2.) A(1011 0000)                            DEPH-135
C***********************************************************************DEPH-136
      KY=KCC                                                            DEPH-137
      KC1=KCC+1                                                         DEPH-138
      KCC=KCC+IP4                                                       DEPH-139
      NMAX=(9*KCC+1)/2                                                  DEPH-140
      IF (NMAX.GE.IDMT) GO TO 17                                        DEPH-141
      READ (5,1000) (MF(1,J),J=KC1,KCC)                                 DEPH-142
      IF (MF(1,KC1).NE.0) WRITE (6,1002)                                DEPH-143
      READ (5,1000) (MF(5,J),J=KC1,KCC)                                 DEPH-144
      MF(1,KC1)=0                                                       DEPH-145
      WRITE (6,1003) (MF(1,J),J=KC1,KCC)                                DEPH-146
      WRITE (6,1004) (MF(5,J),J=KC1,KCC)                                DEPH-147
      LO(3)=.FALSE.                                                     DEPH-148
      LO(4)=.FALSE.                                                     DEPH-149
      DO 13 J=KC1,KCC                                                   DEPH-150
      IF (MF(1,J).GT.15) GO TO 16                                       DEPH-151
      LO(3)=LO(3).OR.(MF(5,J).NE.0.AND.(MF(1,J).EQ.0.OR.MF(1,J).EQ.1))  DEPH-152
      LO(4)=LO(4).OR.(MF(5,J).NE.0.AND.(MF(1,J).NE.0.AND.MF(1,J).NE.1)) DEPH-153
   13 CONTINUE                                                          DEPH-154
      JT=0                                                              DEPH-155
      NJY=0                                                             DEPH-156
      DO 14 J=KC1,KCC                                                   DEPH-157
      NJY=MAX0(NJY,-MF(1,J))                                            DEPH-158
      IF (MF(1,J).EQ.0.OR.MF(1,J).EQ.1) GO TO 14                        DEPH-159
      JT=JT+1                                                           DEPH-160
   14 CONTINUE                                                          DEPH-161
      RETURN                                                            DEPH-162
   15 WRITE (6,1005) IJ1,IJ2                                            DEPH-163
      GO TO 18                                                          DEPH-164
   16 WRITE (6,1006)                                                    DEPH-165
      GO TO 18                                                          DEPH-166
   17 WRITE (6,1007) NMAX,IDMT                                          DEPH-167
   18 WRITE (6,1008)                                                    DEPH-168
      STOP                                                              DEPH-169
 1000 FORMAT (14I5)                                                     DEPH-170
 1001 FORMAT (34H MULTIPLICITY OF THE INITIAL STATE,I5,5X,7HPARITY ,A1/3DEPH-171
     14H MULTIPLICITY OF THE FINAL STATE  ,I5,5X,7HPARITY ,A1/5H WITH,A4DEPH-172
     2,19H ELASTIC SCATTERING/5X,I5,26H VALUES OF ANGULAR MOMENTA/5X,I5,DEPH-173
     321H VALUES OF TOTAL SPIN//26H EQUIDISTANT ANGLES OUTPUT,5X,I3,12H DEPH-174
     4OBSERVABLES)                                                      DEPH-175
 1002 FORMAT (56H THE FIRST OBSERVABLE MUST BE THE CROSS SECTION: LABEL DEPH-176
     10)                                                                DEPH-177
 1003 FORMAT (6X,14H OBSERVABLES: ,18I5/(24X,18I5))                     DEPH-178
 1004 FORMAT (20H GRAPH INFORMATION: ,18I5/(24X,18I5))                  DEPH-179
 1005 FORMAT (15H MULTIPLICITIES,I4,4H AND,I4,26H MUST HAVE THE SAME PARDEPH-180
     1ITY)                                                              DEPH-181
 1006 FORMAT (//76H THE STANDARD OBSERVABLES ARE ONLY 16, FOR ANY OTHER DEPH-182
     1GIVE A NEGATIVE INTEGER)                                          DEPH-183
 1007 FORMAT (/I6,19H MEMORIES REQUESTED,5X,I6,19H MEMORIES AVAILABLE)  DEPH-184
 1008 FORMAT (//22H IN DEPH  ... STOP ...)                              DEPH-185
      END                                                               DEPH-186
