C 14/04/98                                                      DWBB98  OBSE-000
      SUBROUTINE OBSE(MF,AM,ITX,BM,NX,JCAL,JTN,LO)                      OBSE-001
C COMPUTES FOR EACH OBSERVABLE ALL THE INDICATIONS FOR DO LOOPS AND THE OBSE-002
C GEOMETRICAL COEFFICIENTS NEEDED IN SCAT                               OBSE-003
C INPUT VARIABLES: MF:     INFORMATIONS COMING FROM DEPH AND LECD       OBSE-004
C                  JTN:    LENGTH AVAILABLE IN AM                       OBSE-005
C      THE SUBROUTINE RETURNS LO=.TRUE. IF THERE IS AN OBSERVABLE       OBSE-006
C  NOT IN THE CENTER OF MASS SYSTEM.                                    OBSE-007
C OUTPUT VARIABLES:AM:     SEE DESCRIPTION BELOW                        OBSE-008
C                  JCAL:   LENGTH OF AM                                 OBSE-009
C WORKING FIELDS:  BM(9,*) AND NX(18,*) IN EQUIVALENCE BY CALL          OBSE-010
C                  THE RESULTS ARE STORED AFTER THE WORKING FIELD       OBSE-011
C                  AND COPIED IN AM BEFORE RETURN.                      OBSE-012
C                  ITX(7,*) TO STORE LEGENDS, IN EQUIVALENCE WITH AM    OBSE-013
C AS INPUT,MF(1,I)=0 TO 10 FOR A STANDARD OBSERVABLE OR A NEGATIVE      OBSE-014
C     NUMBER FOR NON STANDARD OBSERVABLE OF WHICH THE DESCRIPTION       OBSE-015
C     HAS TO BE READ WITH THE CONTROL NUMBER -MF(1,I)                   OBSE-016
C     MF(5,I)= INDICATION FOR PLOTS                                     OBSE-017
C AS OUTPUT MF(1,I)=0 FOR CROSS-SECTION,1 FOR C.-S./RUTH.,-2 AND -3     OBSE-018
C     FOR VECTOR ANALYSING POWER AND POLARISATION FOR SPINS NOT GREATER OBSE-019
C     THAN 1                                                            OBSE-020
C     MF(2,I)             INDICATION FOR PLOTS                          OBSE-021
C     MF(3,I) AND MF(4,I) BEGINNING AND END OF THE DESCRIPTION IN AM    OBSE-022
C     MF(5,I) TO MF(9,I)  CONTAINS THE LEGEND                           OBSE-023
C***********************************************************************OBSE-024
C  THE FIRST PART OF THE AM TABLE IS SETS OF 10 D. P. INDICATIONS,EACH  OBSE-025
C     OF THEM RELATED TO A SINGLE 'A' - THE 8 FIRST ARE INDICATIONS FOR OBSE-026
C     THE 4 DO LOOPS, 9 IS A SET OF 6 LOGICAL IN A BINARY CODE AND INDI-OBSE-027
C     CATION FOR CHANGE OF FRAME FOR THE PARTICLE AND THE TARGET UNDER  OBSE-028
C     THE FORM N1+1000*N2, 10 IS THE AMPLITUDE.                         OBSE-029
C  THE SECOND PART ARE TENSOR OPERATOR MATRIX ELEMENTS.                 OBSE-030
C       INDICATIONS FOR A DO LOOP ARE 4 INTEGER                         OBSE-031
C        IM: LOWER BOUND                                                OBSE-032
C        IP: UPPER BOUND                                                OBSE-033
C        NM: DIFFERENCE OF MAGNETIC QUANTUM NUMBERS                     OBSE-034
C        IL: THE ADDRESS FROM THE TOP OF TABLE AM FOR THE COEFFICIENT ISOBSE-035
C             OBTAINED BY ADDING THE INDEX OF THE LOOP FOR PARTICLES    OBSE-036
C             OR SUBTRACTING THE INDEX OF THE LOOP FOR THE TARGET.      OBSE-037
C       THE 4 FIRST LOGICALS  ARE .TRUE. IF THERE IS A TENSOR OPERATOR  OBSE-038
C        FOR THE RELATED DO LOOP,.FALSE. FOR IDENTITY OPERATOR.         OBSE-039
C        THE FIFTH IS .TRUE. FOR NO TENSOR OPERATOR AT ALL              OBSE-040
C        THE SIXTH IS .TRUE. FOR PURE IMAGINARY COEFFICIENT             OBSE-041
C       INDICATION FOR CHANGE OF FRAME ARE                              OBSE-042
C            1 FOR LABORATORY SYSTEM                                    OBSE-043
C            2 FOR AXIS ALONG THE INCIDENT DIRECTION                    OBSE-044
C***********************************************************************OBSE-045
      IMPLICIT REAL*8 (A-H,O-Z)                                         OBSE-046
      LOGICAL LT1,LT2,LZ(6),LO                                          OBSE-047
      DIMENSION IY(7,16),ITX(7,1),MT(4),MF(9,1),NX(18,1),MX(8,21),NZ(2),OBSE-048
     1AM(1),BM(9,1),CX(21)                                              OBSE-049
      COMMON /QUAN/ IPJ(2),IPI(2),IP3,LML,LMJ,IP4,KY,KC1,KCC,JT,NJY     OBSE-050
      DATA IY /2*1,4H  CR,4HOSS-,4HSECT,4HION ,4H    ,2*1,4H   C,4H. S.,OBSE-051
     14H/RUT,4HHER.,4H    ,2*2,4H    ,4HASYM,4H. OR,4H IT1,4H1   ,2*3,4HOBSE-052
     2    ,4H VEC,4HT. P,4HOLAR,4H.   ,4,6,2*4H    ,4HSPIN,4H-FLI,4HP   OBSE-053
     3,7,8,2*4H    ,4HKYY ,4HOR D,4H    ,9,10,2*4H    ,4HKXX ,4HOR R,4H OBSE-054
     4   ,11,11,4H    ,4H   K,4HZZ O,4HR A',4H    ,12,12,2*4H    ,4HKZX OBSE-055
     5,4HOR A,4H    ,13,13,4H    ,4H   K,4HXZ O,4HR R',4H    ,2*14,4H   OBSE-056
     6  ,4H TAR,4HGET ,4HASYM,4H.   ,15,16,3*4H    ,4H AYY,4H    ,17,18,OBSE-057
     73*4H    ,4H AXX,4H    ,19,19,3*4H    ,4H AZZ,4H    ,20,20,3*4H    OBSE-058
     8,4H AXZ,4H    , 21,21,3*4H    ,4H AZX,4H    /                     OBSE-059
      DATA CX /3*1.D0,3*0.5D0,2*-1.D0,1.D0,-1.D0,1.D0,2*-1.4142137,1.414OBSE-060
     12137D0,2*-1.D0,1.D0,-1.D0,1.D0,2*-1.4142137/                      OBSE-061
      DATA MX /8*0,2*1,10*0,2*1,2*0,8*0,2*1,2*0,2*1,2*0,2*1,2*0,1,-1,2*0OBSE-062
     1,2*1,2*0,2*1,2*0,2*1,2*0,1,-1,2*0,2*1,2*0,2*1,2*0,2*1,2*0,1,-1,2*0OBSE-063
     2,1,3*0,1,3*0,2*1,2*0,1,3*0,1,3*0,2*1,2*0,2*0,2*1,4*0,4*1,4*0,3*1,-OBSE-064
     31,4*0,4*1,4*0,3*1,-1,4*0,1,0,1,5*0,3*1,5*0,1,0,2*1,4*0/           OBSE-065
      DATA JTS /0/                                                      OBSE-066
      IF (JTN.LT.378) GO TO 91                                          OBSE-067
      MT(1)=2                                                           OBSE-068
      MT(2)=IPJ(1)                                                      OBSE-069
      MT(3)=2                                                           OBSE-070
      MT(4)=IPJ(2)                                                      OBSE-071
C TRANSFER OF STANDARD DESCRIPTIONS                                     OBSE-072
      DO 2 I=1,21                                                       OBSE-073
      DO 1 J=1,8                                                        OBSE-074
    1 NX(J+6,I)=MX(J,I)                                                 OBSE-075
    2 BM(3,I)=CX(I)                                                     OBSE-076
      DO 4 I=1,16                                                       OBSE-077
      DO 3 J=1,7                                                        OBSE-078
    3 ITX(J,I)=IY(J,I)                                                  OBSE-079
    4 CONTINUE                                                          OBSE-080
      LO=.FALSE.                                                        OBSE-081
      KIT=17                                                            OBSE-082
      KNX=22                                                            OBSE-083
      JCAL=0                                                            OBSE-084
C VERIFICATION OF INDICATIONS ALREADY IN MF(1,I)                        OBSE-085
      DO 5 I=KC1,KCC                                                    OBSE-086
      IF (MF(1,I).GT.15) GO TO 83                                       OBSE-087
    5 MF(6,I)=0                                                         OBSE-088
C SEARCH FOR NON STANDARD OBSERVABLES                                   OBSE-089
    6 DO 7 L=KC1,KCC                                                    OBSE-090
      IF (MF(1,L).LT.0) GO TO 8                                         OBSE-091
    7 CONTINUE                                                          OBSE-092
      GO TO 56                                                          OBSE-093
    8 KZ=KIT                                                            OBSE-094
      KIT=KIT+1                                                         OBSE-095
C INPUT OF THE DESCRIPTION OF NON STANDARD OBSERVABLES                  OBSE-096
      LT1=.FALSE.                                                       OBSE-097
      LT2=.FALSE.                                                       OBSE-098
      READ (5,1000) LT1,LT2,KT3,KX,K,(ITX(J,KIT),J=3,7)                 OBSE-099
      K1=KNX+1                                                          OBSE-100
      KNX=KNX+K                                                         OBSE-101
      IF (18*KNX.GT.JTN) GO TO 91                                       OBSE-102
      READ (5,1001) ((NX(J,I),J=7,14),I=K1,KNX)                         OBSE-103
      READ (5,1002) (BM(3,I),I=K1,KNX)                                  OBSE-104
      IF (LT1.OR.LT2) READ (5,1002) (BM(1,I),I=K1,KNX)                  OBSE-105
    9 K2=K1                                                             OBSE-106
      WRITE (6,1003) KX,(ITX(J,KIT),J=3,7),K                            OBSE-107
      IF (LT1) WRITE (6,1004)                                           OBSE-108
      IF (KT3.EQ.1) WRITE (6,1005)                                      OBSE-109
      IF (KT3.EQ.2) WRITE (6,1006)                                      OBSE-110
      IF (.NOT.LT2) GO TO 22                                            OBSE-111
C OUTPUT OF THE DESCRIPTION NOT COMPLETELY IN TENSOR NOTATION           OBSE-112
C IF LT2=.TRUE. , OBSERVABLES CAN BE DEFINED AS MATRIX ELEMENTS         OBSE-113
C (MI,MF). IN THIS CASE,THE VALUES READ ARE (MI-S-1,MF-S-1) INSTEAD OF  OBSE-114
C THE QUANTUM NUMBERS OF TENSOR OPERATOR.                               OBSE-115
      WRITE (6,1007)                                                    OBSE-116
   10 K3=MIN0(K2+5,KNX)                                                 OBSE-117
      WRITE (6,1008) ((NX(I,J),I=11,14),J=K2,K3)                        OBSE-118
      WRITE (6,1009) (BM(3,I),I=K2,K3)                                  OBSE-119
      WRITE (6,1010) ((NX(I,J),I=7,10),J=K2,K3)                         OBSE-120
      WRITE (6,1011) (BM(1,I),I=K2,K3)                                  OBSE-121
      K2=K3+1                                                           OBSE-122
      IF (K2.LE.KNX) GO TO 10                                           OBSE-123
      KLT=1                                                             OBSE-124
C SEARCH FOR NON TENSOR DESCRIPTION - PSEUDO-LOOP FOR IJ                OBSE-125
      IJ=1                                                              OBSE-126
   11 K2=K1                                                             OBSE-127
      K6=KNX                                                            OBSE-128
   12 IF (K2.GT.K6) GO TO 14                                            OBSE-129
      DO 13 K=K2,K6                                                     OBSE-130
      IF (NX(2*IJ+5,K).LT.0) GO TO 15                                   OBSE-131
   13 CONTINUE                                                          OBSE-132
   14 IF (K6.NE.KNX) GO TO 27                                           OBSE-133
      GO TO 20                                                          OBSE-134
C RECURRENCE COMPUTATION OF (-)**(S-MF)*<S S MI -MF|L M>/SQRT(2*S+1)    OBSE-135
C STARTING WITH THE MINIMUM VALUE OF L                                  OBSE-136
   15 M1=MT(IJ)+NX(2*IJ+5,K)                                            OBSE-137
      M2=MT(IJ)+NX(2*IJ+6,K)                                            OBSE-138
      IF (M1.LT.0.OR.M2.LT.0) GO TO 84                                  OBSE-139
      M4=M1-M2                                                          OBSE-140
      M3=IABS(M4)+1                                                     OBSE-141
      M5=MT(IJ)                                                         OBSE-142
      E2=0.D0                                                           OBSE-143
      E3=1.D0                                                           OBSE-144
      C1=M1+M2-MT(IJ)+1                                                 OBSE-145
      D2=0.D0                                                           OBSE-146
      C2=0.D0                                                           OBSE-147
      DO 18 M=M3,M5                                                     OBSE-148
      IF (M.EQ.M3) GO TO 16                                             OBSE-149
      E1=E2                                                             OBSE-150
      E2=E3                                                             OBSE-151
      D1=D2                                                             OBSE-152
      F1=((M-1)**2-M4**2)*(MT(IJ)**2-(M-1)**2)                          OBSE-153
      F2=(2*M-1)*(2*M-3)                                                OBSE-154
      D2=DSQRT(F1/F2)                                                   OBSE-155
      E3=(C1*E2-D1*E1)/D2                                               OBSE-156
   16 KNX=KNX+1                                                         OBSE-157
      DO 17 JI=7,14                                                     OBSE-158
   17 NX(JI,KNX)=NX(JI,K)                                               OBSE-159
      NX(2*IJ+5,KNX)=M-1                                                OBSE-160
      NX(2*IJ+6,KNX)=M4                                                 OBSE-161
      C2=C2+E3*E3                                                       OBSE-162
   18 BM(1,KNX)=E3                                                      OBSE-163
C NORMALISATION AND SIGN GIVEN BY COEFFICIENT FOR MAXIMUM VALUE OF L    OBSE-164
      C2=C2*MT(IJ)                                                      OBSE-165
      C2=1.D0/DSQRT(C2)                                                 OBSE-166
      IF (E3.LT.0.D0) C2=-C2                                            OBSE-167
      IF (MOD(NX(2*IJ+6,K),2).EQ.0) C2=-C2                              OBSE-168
      DO 19 M=M3,M5                                                     OBSE-169
      JI=KNX+M-M5                                                       OBSE-170
      BM(3,JI)=BM(3,K)*BM(1,JI)*C2                                      OBSE-171
   19 BM(1,JI)=BM(1,K)*BM(1,JI)*C2                                      OBSE-172
      BM(3,K)=0.D0                                                      OBSE-173
      BM(1,K)=0.D0                                                      OBSE-174
      K2=K+1                                                            OBSE-175
      GO TO 12                                                          OBSE-176
   20 IJ=IJ+1                                                           OBSE-177
      IF (IJ.LE.4) GO TO 11                                             OBSE-178
      K2=K1                                                             OBSE-179
      LT2=.FALSE.                                                       OBSE-180
      IF (LT1) GO TO 22                                                 OBSE-181
C IF AXIS OF QUANTIFICATION NOT IN VERTICAL PLANE, TAKE IMAGINARY       OBSE-182
C AMPLITUDE FOR PURE IMAGINARY TENSORS                                  OBSE-183
      DO 21 K=K1,KNX                                                    OBSE-184
      M1=NX(7,K)+NX(9,K)+NX(11,K)+NX(13,K)                              OBSE-185
      IF (MOD(M1,2).NE.0) BM(3,K)=BM(1,K)                               OBSE-186
   21 CONTINUE                                                          OBSE-187
   22 IF (LT1) GO TO 35                                                 OBSE-188
C THE FIRST NON ZERO MAGNETIC QUANTUM NUMBER MUST BE POSITIVE           OBSE-189
      DO 26 K4=K1,KNX                                                   OBSE-190
      BM(1,K4)=0.D0                                                     OBSE-191
      DO 23 J=8,14,2                                                    OBSE-192
      IF (NX(J,K4)) 24 , 23 , 26                                        OBSE-193
   23 CONTINUE                                                          OBSE-194
      GO TO 26                                                          OBSE-195
   24 IK=0                                                              OBSE-196
      DO 25 J=8,14,2                                                    OBSE-197
      IK=IK+NX(J-1,K4)+NX(J,K4)                                         OBSE-198
   25 NX(J,K4)=-NX(J,K4)                                                OBSE-199
      IF (2*(IK/2).NE.IK) BM(3,K4)=-BM(3,K4)                            OBSE-200
   26 CONTINUE                                                          OBSE-201
      KLT=2                                                             OBSE-202
C REDUCTION OF THE DESCRIPTION                                          OBSE-203
C FOR CHANGE INTO TENSORS IF KLT=1, FOR HERE IF KLT=2                   OBSE-204
C FOR CHANGE TO AXIS IN THE REACTION PLANE IF KLT=3                     OBSE-205
   27 IF (K1.GT.KNX) GO TO 85                                           OBSE-206
      DO 30 K4=K1,KNX                                                   OBSE-207
      IF (DABS(BM(3,K4))+DABS(BM(1,K4)).LT..1D-6) GO TO 32              OBSE-208
      K5=K4-1                                                           OBSE-209
      IF (K1.GT.K5) GO TO 30                                            OBSE-210
      DO 29 J=K1,K5                                                     OBSE-211
      DO 28 I=7,14                                                      OBSE-212
      IF (NX(I,J).NE.NX(I,K4)) GO TO 29                                 OBSE-213
   28 CONTINUE                                                          OBSE-214
      GO TO 31                                                          OBSE-215
   29 CONTINUE                                                          OBSE-216
   30 CONTINUE                                                          OBSE-217
      GO TO ( 20 , 35 , 50 ),KLT                                        OBSE-218
   31 BM(3,J)=BM(3,J)+BM(3,K4)                                          OBSE-219
      BM(1,J)=BM(1,J)+BM(1,K4)                                          OBSE-220
   32 KNX=KNX-1                                                         OBSE-221
      IF (KNX.LT.K4) GO TO 27                                           OBSE-222
      DO 34 K=K4,KNX                                                    OBSE-223
      DO 33 J=7,14                                                      OBSE-224
   33 NX(J,K)=NX(J,K+1)                                                 OBSE-225
      BM(1,K)=BM(1,K+1)                                                 OBSE-226
   34 BM(3,K)=BM(3,K+1)                                                 OBSE-227
      GO TO 27                                                          OBSE-228
C OUTPUT OF THE DESCRIPTION                                             OBSE-229
   35 K3=MIN0(K2+5,KNX)                                                 OBSE-230
      WRITE (6,1008) ((NX(I,J),I=11,14),J=K2,K3)                        OBSE-231
      WRITE (6,1012) (BM(3,I),I=K2,K3)                                  OBSE-232
      WRITE (6,1010) ((NX(I,J),I=7,10),J=K2,K3)                         OBSE-233
      IF (LT1) WRITE (6,1011) (BM(1,I),I=K2,K3)                         OBSE-234
      K2=K3+1                                                           OBSE-235
      IF (K2.LE.KNX) GO TO 35                                           OBSE-236
      DO 37 K=K1,KNX                                                    OBSE-237
      DO 36 I=8,14,2                                                    OBSE-238
      IF (IABS(NX(I,K)).GT.NX(I-1,K).OR.NX(I-1,K).LT.0) GO TO 86        OBSE-239
   36 CONTINUE                                                          OBSE-240
   37 CONTINUE                                                          OBSE-241
      IF (.NOT.LT1) GO TO 54                                            OBSE-242
C CHANGE FROM VERTICAL AXIS OF QUANTIFICATION TO HELICITY DESCRIPTION   OBSE-243
C BY THE ROTATION R(PI/2,PI/2,PI/2)                                     OBSE-244
      DO 39 I=K1,KNX                                                    OBSE-245
      M1=IABS(NX(8,I))+IABS(NX(10,I))+IABS(NX(12,I))+IABS(NX(14,I))     OBSE-246
      M2=M1/2                                                           OBSE-247
      IF (2*M2.NE.M1) GO TO 87                                          OBSE-248
      IF (2*(M2/2).EQ.M2) GO TO 38                                      OBSE-249
      BM(3,I)=-BM(3,I)                                                  OBSE-250
      BM(1,I)=-BM(1,I)                                                  OBSE-251
   38 IF (M1.EQ.0) BM(1,I)=0.D0                                         OBSE-252
   39 CONTINUE                                                          OBSE-253
      KLT=3                                                             OBSE-254
C PSEUDO-LOOP ON IJ TO 50                                               OBSE-255
      IJ=7                                                              OBSE-256
   40 J1=KNX                                                            OBSE-257
      DO 47 K3=K1,KNX                                                   OBSE-258
      K=NX(IJ,K3)                                                       OBSE-259
      N1=K+NX(IJ+1,K3)+1                                                OBSE-260
      N=2*K+1                                                           OBSE-261
      E3=1.D0                                                           OBSE-262
      IF (K.EQ.0) GO TO 42                                              OBSE-263
C ROTATION MATRIX ELEMENTS FOR PI/2                                     OBSE-264
      DO 41 I=1,K                                                       OBSE-265
   41 E3=E3*.5D0                                                        OBSE-266
   42 C1=0.D0                                                           OBSE-267
      E2=0.D0                                                           OBSE-268
      FJ=K                                                              OBSE-269
      FS=-FJ                                                            OBSE-270
      DO 43 I=1,N1                                                      OBSE-271
      IF (I.EQ.1) GO TO 43                                              OBSE-272
      C2=C1                                                             OBSE-273
      C1=(I-1)*(1+N-I)                                                  OBSE-274
      C1=DSQRT(C1)                                                      OBSE-275
      E1=E2                                                             OBSE-276
      E2=E3                                                             OBSE-277
      E3=(2.D0*FJ*E2-E1*C2)/C1                                          OBSE-278
      FS=FS+1.D0                                                        OBSE-279
   43 F2=0.D0                                                           OBSE-280
      F3=E3                                                             OBSE-281
      D1=0.D0                                                           OBSE-282
      DO 46 J=1,N                                                       OBSE-283
      IF (J.EQ.1) GO TO 44                                              OBSE-284
      D2=D1                                                             OBSE-285
      D1=(J-1)*(1+N-J)                                                  OBSE-286
      D1=DSQRT(D1)                                                      OBSE-287
      F1=F2                                                             OBSE-288
      F2=F3                                                             OBSE-289
      F3=(2.D0*FS*F2-F1*D2)/D1                                          OBSE-290
   44 J1=J1+1                                                           OBSE-291
      IF (18*J1.GT.JTN) GO TO 91                                        OBSE-292
      DO 45 L=7,14                                                      OBSE-293
   45 NX(L,J1)=NX(L,K3)                                                 OBSE-294
      BM(3,J1)=F3*BM(3,K3)                                              OBSE-295
      BM(1,J1)=F3*BM(1,K3)                                              OBSE-296
   46 NX(IJ+1,J1)=J-1-K                                                 OBSE-297
   47 CONTINUE                                                          OBSE-298
C REDUCTION OF THE DESCRIPTION                                          OBSE-299
      J2=K1-1                                                           OBSE-300
      J3=KNX+1                                                          OBSE-301
      DO 49 J4=J3,J1                                                    OBSE-302
      J2=J2+1                                                           OBSE-303
      DO 48 L=7,14                                                      OBSE-304
   48 NX(L,J2)=NX(L,J4)                                                 OBSE-305
      BM(3,J2)=BM(3,J4)                                                 OBSE-306
   49 BM(1,J2)=BM(1,J4)                                                 OBSE-307
      KNX=J2                                                            OBSE-308
      GO TO 27                                                          OBSE-309
   50 IJ=IJ+2                                                           OBSE-310
      IF (IJ.LE.13) GO TO 40                                            OBSE-311
      DO 53 J1=K1,KNX                                                   OBSE-312
      M1=NX(7,J1)+NX(9,J1)+NX(11,J1)+NX(13,J1)                          OBSE-313
      M2=NX(8,J1)+NX(10,J1)+NX(12,J1)+NX(14,J1)+4*M1                    OBSE-314
      M3=M2/2                                                           OBSE-315
      IF (2*(M1/2).EQ.M1) GO TO 51                                      OBSE-316
      IF (2*M3.NE.M2) GO TO 52                                          OBSE-317
      BM(3,J1)=BM(1,J1)                                                 OBSE-318
      GO TO 52                                                          OBSE-319
   51 IF (2*M3.EQ.M2) GO TO 52                                          OBSE-320
      BM(3,J1)=-BM(1,J1)                                                OBSE-321
   52 IF (2*(M3/2).NE.M3) BM(3,J1)=-BM(3,J1)                            OBSE-322
   53 CONTINUE                                                          OBSE-323
      LT1=.FALSE.                                                       OBSE-324
      WRITE (6,1013)                                                    OBSE-325
      K=KNX+1-K1                                                        OBSE-326
      GO TO 9                                                           OBSE-327
C STORAGE OF THE DESCRIPTION                                            OBSE-328
   54 L1=0                                                              OBSE-329
      ITX(1,KIT)=K1                                                     OBSE-330
      ITX(2,KIT)=KNX                                                    OBSE-331
      DO 55 I=KC1,KCC                                                   OBSE-332
      IF (MF(1,I).NE.-KX) GO TO 55                                      OBSE-333
      MF(1,I)=KZ                                                        OBSE-334
      MF(6,I)=KT3                                                       OBSE-335
      L1=L1+1                                                           OBSE-336
   55 CONTINUE                                                          OBSE-337
      IF (L1.EQ.0) WRITE (6,1014) KX                                    OBSE-338
      GO TO 6                                                           OBSE-339
C COMPUTATION OF ALL THE INDICATIONS NEEDED FOR THE OBSERVABLES         OBSE-340
C (BEGINNING AND END OF DO LOOPS,GEOMETRICAL COEFFICIENTS ...)          OBSE-341
   56 DO  57 I=KC1,KCC                                                  OBSE-342
      I1=MF(1,I)+1                                                      OBSE-343
      MF(3,I)=ITX(1,I1)                                                 OBSE-344
   57 MF(4,I)=ITX(2,I1)                                                 OBSE-345
      LT1=.FALSE.                                                       OBSE-346
   58 LT1=.NOT.LT1                                                      OBSE-347
C LT1=.TRUE.  FIRST PASSAGE: NUMBER OF INFORMATIONS NEEDED FOR DO LOOPS OBSE-348
C LT1=.FALSE. SECOND ONE: COMPUTATION OF GEOMETRICAL COEFFICIENTS WHICH OBSE-349
C ARE STORED AFTER THE INDICATIONS FOR DO LOOPS                         OBSE-350
      ICAL=0                                                            OBSE-351
      NCAL=0                                                            OBSE-352
      DO 78 I=KC1,KCC                                                   OBSE-353
      IF (MF(1,I).LE.0) GO TO 78                                        OBSE-354
      IF (MF(1,I).NE.1) GO TO 59                                        OBSE-355
      IF (IP3.NE.1) GO TO 88                                            OBSE-356
      GO TO 78                                                          OBSE-357
   59 IF ((MF(1,I).EQ.2.AND.MT(1).LE.3).OR.(MF(1,I).EQ.3.AND.MT(3).LE.3)OBSE-358
     1) GO TO 62                                                        OBSE-359
      IF (I.EQ.KC1) GO TO 63                                            OBSE-360
      I1=I-1                                                            OBSE-361
      DO 60 J=KC1,I1                                                    OBSE-362
      IF (MF(1,I).EQ.MF(1,J).AND.MF(2,I).EQ.MF(2,J)) GO TO 61           OBSE-363
   60 CONTINUE                                                          OBSE-364
      GO TO 63                                                          OBSE-365
   61 MF(3,I)=MF(3,J)                                                   OBSE-366
      MF(4,I)=MF(4,J)                                                   OBSE-367
      GO TO 78                                                          OBSE-368
   62 MF(1,I)=-MF(1,I)                                                  OBSE-369
      IF ((MF(1,I).EQ.-2.AND.MT(1).EQ.0).OR.(MF(1,I).EQ.-3.AND.MT(3).EQ.OBSE-370
     10)) GO TO 89                                                      OBSE-371
      GO TO 78                                                          OBSE-372
   63 I1=MF(3,I)                                                        OBSE-373
      I2=MF(4,I)                                                        OBSE-374
      DO 77 KI=I1,I2                                                    OBSE-375
      KT=0                                                              OBSE-376
      DO 73 L=1,4                                                       OBSE-377
      K=NX(2*L+5,KI)                                                    OBSE-378
      NM=NX(2*L+6,KI)                                                   OBSE-379
      KT=KT+K                                                           OBSE-380
      IF (K.GT.MT(L)) GO TO 90                                          OBSE-381
      IF (ICAL.EQ.0) GO TO 65                                           OBSE-382
      DO 64 N=1,ICAL                                                    OBSE-383
      IF (MT(L).EQ.NX(15,N).AND.K.EQ.NX(16,N).AND.NM.EQ.NX(17,N)) GO TO OBSE-384
     1 71                                                               OBSE-385
   64 CONTINUE                                                          OBSE-386
   65 ICAL=ICAL+1                                                       OBSE-387
      IF (18*ICAL.GT.JTN) GO TO 91                                      OBSE-388
      NX(15,ICAL)=MT(L)                                                 OBSE-389
      NX(16,ICAL)=K                                                     OBSE-390
      NX(17,ICAL)=NM                                                    OBSE-391
      NX(18,ICAL)=JCAL                                                  OBSE-392
      IF (LT1) GO TO 73                                                 OBSE-393
      IN=MT(L)                                                          OBSE-394
      NX(1,ICAL)=MAX0(1,1+NM)                                           OBSE-395
      NX(2,ICAL)=MIN0(IN,IN+NM)                                         OBSE-396
      NX(3,ICAL)=NM                                                     OBSE-397
      NX(4,ICAL)=JCAL-NX(1,ICAL)+1                                      OBSE-398
      IF (NX(16,ICAL).EQ.0) GO TO 70                                    OBSE-399
C RECURRENCE COMPUTATION OF GEOMETRICAL COEFFICIENTS                    OBSE-400
      F3=2*K+1                                                          OBSE-401
      F3=DSQRT(F3)                                                      OBSE-402
      DO 66 J=1,K                                                       OBSE-403
      F1=IN-J                                                           OBSE-404
      F2=IN+J                                                           OBSE-405
   66 F3=-F3*DSQRT(F1/F2)                                               OBSE-406
      JNM=NM                                                            OBSE-407
      INM=IABS(JNM)                                                     OBSE-408
      IF (JNM.EQ.0) GO TO 68                                            OBSE-409
      IF (INM.NE.JNM.AND.2*(INM/2).NE.INM) F3=-F3                       OBSE-410
      DO 67 J=1,INM                                                     OBSE-411
      F1=(K+J)*(K-J+1)                                                  OBSE-412
      F2=J*(IN-J)                                                       OBSE-413
   67 F3=F3*DSQRT(F1/F2)                                                OBSE-414
   68 JCAL=JCAL+1                                                       OBSE-415
      IS=NX(2,ICAL)-NX(1,ICAL)                                          OBSE-416
      IF (2*(JCAL+IS).GT.JTS) GO TO 91                                  OBSE-417
      BM(JCAL,KX)=F3                                                    OBSE-418
      IF (IS.LT.1) GO TO 70                                             OBSE-419
      F2=0.D0                                                           OBSE-420
      D1=K*(K+1)-(IN+1)*(INM-1)                                         OBSE-421
      C2=0.D0                                                           OBSE-422
      DO 69 J=1,IS                                                      OBSE-423
      C1=C2                                                             OBSE-424
      C2=J*(IN-J)*(J+INM)*(IN-J-INM)                                    OBSE-425
      C2=DSQRT(C2)                                                      OBSE-426
      D1=D1+2*(2*J-2-IN+INM)                                            OBSE-427
      F1=F2                                                             OBSE-428
      F2=F3                                                             OBSE-429
      F3=-(D1*F2+C1*F1)/C2                                              OBSE-430
      JCAL=JCAL+1                                                       OBSE-431
      BM(JCAL,KX)=F3                                                    OBSE-432
   69 CONTINUE                                                          OBSE-433
   70 N=ICAL                                                            OBSE-434
   71 IF (LT1) GO TO 73                                                 OBSE-435
      DO 72 MA=1,4                                                      OBSE-436
      MC=20*NCAL+4*L+MA-4                                               OBSE-437
   72 NX(MC,KX)=NX(MA,N)                                                OBSE-438
      LZ(L)=NX(16,N).NE.0                                               OBSE-439
   73 CONTINUE                                                          OBSE-440
      IF (LT1) GO TO 76                                                 OBSE-441
      LZ(5)=KT.EQ.0                                                     OBSE-442
      LZ(6)=2*(KT/2).NE.KT                                              OBSE-443
      NZ(1)=0                                                           OBSE-444
      NZ(2)=0                                                           OBSE-445
      IF (LZ(4)) NZ(2)=MF(6,I)                                          OBSE-446
      IF (LZ(3).OR.LZ(4)) NZ(1)=MF(6,I)                                 OBSE-447
      LO=LO.OR.NZ(1).NE.0                                               OBSE-448
      IA1=0                                                             OBSE-449
      IA2=1                                                             OBSE-450
      DO 74 LI=1,6                                                      OBSE-451
      IF (LZ(LI)) IA1=IA1+IA2                                           OBSE-452
   74 IA2=2*IA2                                                         OBSE-453
      NX(20*NCAL+17,KX)=IA1                                             OBSE-454
      NX(20*NCAL+18,KX)=NZ(1)+1000*NZ(2)                                OBSE-455
      BM(10*NCAL+10,KX)=BM(3,KI)                                        OBSE-456
C INVERSION OF LOOPS FOR TARGET                                         OBSE-457
      DO 75 LI=2,4,2                                                    OBSE-458
      IF (.NOT.LZ(LI)) GO TO 75                                         OBSE-459
      IM=NX(20*NCAL+4*LI-3,KX)                                          OBSE-460
      NX(20*NCAL+4*LI-3,KX)=MT(LI)-NX(20*NCAL+4*LI-2,KX)+1              OBSE-461
      NX(20*NCAL+4*LI-2,KX)=MT(LI)-IM+1                                 OBSE-462
      NX(20*NCAL+4*LI-1,KX)=-NX(20*NCAL+4*LI-1,KX)                      OBSE-463
      NX(20*NCAL+4*LI,KX)=NX(20*NCAL+4*LI,KX)+IM+NX(20*NCAL+4*LI-2,KX)  OBSE-464
   75 CONTINUE                                                          OBSE-465
   76 NCAL=NCAL+1                                                       OBSE-466
   77 CONTINUE                                                          OBSE-467
      IF (LT1) GO TO 78                                                 OBSE-468
      MF(4,I)=NCAL                                                      OBSE-469
      MF(3,I)=NCAL+I1-I2                                                OBSE-470
   78 CONTINUE                                                          OBSE-471
      IF (.NOT.LT1) GO TO 79                                            OBSE-472
      KX=MAX0(KNX,ICAL)+1                                               OBSE-473
      JCAL=10*NCAL                                                      OBSE-474
      JTS=JTN-18*(KX-1)                                                 OBSE-475
      IF (2*JCAL.GT.JTS) GO TO 91                                       OBSE-476
      GO TO 58                                                          OBSE-477
C STORAGE OF LEGENDS AND COPY OF RESULTS                                OBSE-478
   79 DO 81 I=KC1,KCC                                                   OBSE-479
      I5=IABS(MF(1,I))+1                                                OBSE-480
      MF(2,I)=MF(5,I)                                                   OBSE-481
      DO 80 J=3,7                                                       OBSE-482
   80 MF(J+2,I)=ITX(J,I5)                                               OBSE-483
   81 CONTINUE                                                          OBSE-484
      DO 82 I=1,JCAL                                                    OBSE-485
   82 AM(I)=BM(I,KX)                                                    OBSE-486
      RETURN                                                            OBSE-487
   83 WRITE (6,1015) I,MF(1,I)                                          OBSE-488
      GO TO 91                                                          OBSE-489
   84 WRITE (6,1016) NX(2*IJ+5,K),NX(2*IJ+6,K),MT(IJ)                   OBSE-490
      GO TO 91                                                          OBSE-491
   85 WRITE (6,1017)                                                    OBSE-492
      GO TO 91                                                          OBSE-493
   86 WRITE (6,1018) NX(2*I-1,K1),NX(2*I,K1)                            OBSE-494
      GO TO 91                                                          OBSE-495
   87 WRITE (6,1019)                                                    OBSE-496
      GO TO 91                                                          OBSE-497
   88 WRITE (6,1020) MF(2,I)                                            OBSE-498
      GO TO 91                                                          OBSE-499
   89 WRITE (6,1021) MF(2,I)                                            OBSE-500
      GO TO 91                                                          OBSE-501
   90 WRITE (6,1022) MT(L),MF(2,I),L,K                                  OBSE-502
   91 WRITE (6,1023)                                                    OBSE-503
      STOP                                                              OBSE-504
 1000 FORMAT (2L1,I1,I2,I5,5A4)                                         OBSE-505
 1001 FORMAT (8I5)                                                      OBSE-506
 1002 FORMAT (6F10.5)                                                   OBSE-507
 1003 FORMAT (/11H OBSERVABLE,I3,9H LABELLED,5X,5A4,10X,I3,11H COMPONENTOBSE-508
     1S)                                                                OBSE-509
 1004 FORMAT (57H DEFINED WITH AN AXIS PERPENDICULAR TO THE REACTION PLAOBSE-510
     1NE)                                                               OBSE-511
 1005 FORMAT (33H DEFINED IN THE LABORATORY SYSTEM)                     OBSE-512
 1006 FORMAT (42H DEFINED WITH RESPECT TO THE INCIDENT BEAM)            OBSE-513
 1007 FORMAT (34H NOT COMPLETELY DEFINED BY TENSORS)                    OBSE-514
 1008 FORMAT (/6(11X,4I2,2X))                                           OBSE-515
 1009 FORMAT (6(2H +,F8.4,2H*M,9X))                                     OBSE-516
 1010 FORMAT (6(11X,4I2,2X))                                            OBSE-517
 1011 FORMAT (16H IMAGINARY PARTS/6(1X,F8.5,12X))                       OBSE-518
 1012 FORMAT (6(2H +,F8.4,2H*A,9X))                                     OBSE-519
 1013 FORMAT (//21H AFTER TRANSFORMATION/)                              OBSE-520
 1014 FORMAT (32H THE OBSERVABLE READ WITH NUMBER,I4,12H IS NOT USED)   OBSE-521
 1015 FORMAT (4H THE,I4,22H TH OBSERVABLE,OF KIND,I2,15H IS NOT DEFINED)OBSE-522
 1016 FORMAT (23H NON TENSOR INDICATIONS,I4,4H AND,I4,24H INCORRECT FOR OBSE-523
     1(2*S+1) =,I3)                                                     OBSE-524
 1017 FORMAT (16H ZERO OBSERVABLE)                                      OBSE-525
 1018 FORMAT (/60H TOO LARGE MAGNETIC QUANTUM NUMBER OR NEGATIVE MULTIPOOBSE-526
     1LARITY,2I6)                                                       OBSE-527
 1019 FORMAT (61H THE SUM OF MAGNETIC QUANTUM NUMBERS IS ODD FOR ONE COMOBSE-528
     1PONENT)                                                           OBSE-529
 1020 FORMAT (67H NO CROSS SECTION DIVIDED BY RUTHERFORD'S FOR THE INELAOBSE-530
     1STIC CHANNEL,I3)                                                  OBSE-531
 1021 FORMAT (47H NO POLARISATION FOR A ZERO SPIN IN THE CHANNEL,I3)    OBSE-532
 1022 FORMAT (5X,I5,31H IS A TOO SMALL SPIN IN CHANNEL,I4,13H AND PARTICOBSE-533
     1LE,I4,35H FOR A POLARISATION OF TENSOR ORDER,I4)                  OBSE-534
 1023 FORMAT (//22H IN OBSE  ... STOP ...)                              OBSE-535
      END                                                               OBSE-536
