C 09/12/98                                                      DWBB98  LECA-000
      SUBROUTINE LECA(IJ,LMX,LMJ,IK,W)                                  LECA-001
C READ AND PLACE RESULTS OF ELASTIC SCATTERING                          LECA-002
C INPUT:   IJ:     MULTIPLICITY OF THE INITIAL AND FINAL TARGET.        LECA-003
C          LMX:    NUMBER OF J VALUES FOR ELASTIC SCATTERING.           LECA-004
C          LMJ:    NUMBER OF J VALUES FOR FINAL RESULTS.                LECA-005
C          IK:     1 TO STORE ELASTIC RESULTS,                          LECA-006
C                  ANY OTHER VALUE TO READ RESULTS WITHOUT STORING THEM.LECA-007
C OUTPUT:  W(*,*,*,*):     UPDATED SCATTERING MATRIX:                   LECA-008
C                W(1,*,*,*), W(2,*,*,*): REAL AND IMAGINARY PARTS,      LECA-009
C                W(*,I,J,K):   ITH COMPONENT OF THE JTH SOLUTION AND    LECA-010
C                              THE KTH TOTAL ANGULAR MOMENTUM.          LECA-011
C***********************************************************************LECA-012
      IMPLICIT REAL*8 (A-H,O-Z)                                         LECA-013
      DIMENSION W(2,LMJ,IJ,IJ,2)                                        LECA-014
      IF (LMX.EQ.0) RETURN                                              LECA-015
      DO 2 I=1,LMX                                                      LECA-016
      READ (5,1000) A1,A2,A3,A4                                         LECA-017
      IF (IK.NE.1) GO TO 2                                              LECA-018
      IMIN=MAX0((2*I-IJ+2)/2,1)                                         LECA-019
      IMAX=MIN0((2*I+IJ)/2,LMJ)                                         LECA-020
      DO 1 J=IMIN,IMAX                                                  LECA-021
      JI=IJ/2+1+I-J                                                     LECA-022
      JR=MOD(I+J,2)+1                                                   LECA-023
      JQ=3-JR                                                           LECA-024
      W(1,J,JI,JI,JR)=A1                                                LECA-025
      W(2,J,JI,JI,JR)=A2                                                LECA-026
      W(1,J,JI,JI,JQ)=A3                                                LECA-027
    1 W(2,J,JI,JI,JQ)=A4                                                LECA-028
    2 CONTINUE                                                          LECA-029
      RETURN                                                            LECA-030
 1000 FORMAT (4D18.10)                                                  LECA-031
      END                                                               LECA-032
